2023-06-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Offer advice to users of PDF who want a table of contents
	at the front of the document.

	* doc/groff.texi (ms Document Structure): Move mention of
	pdfjam(1) from here...
	(ms TOC): ...to here, and identify alternatives, including
	gropdf(1)'s `pdfswitchtopage` macro.

	* doc/ms.ms (General structure of an ms document):
	(Creating a table of contents): Similar.

	Fixes <https://savannah.gnu.org/bugs/?64278>.  Thanks to Michał
	Kruszewski for the report.

2023-06-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Migrate terminology to "scaling unit".

	...from "scaling indicator".

	Fixes <https://savannah.gnu.org/bugs/?60957>.  Thanks to Ingo
	Schwarze for the discussion.

2023-05-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Revise discussion of fonts.

	* doc/groff.texi:
	- Rename node/section "Fonts and Symbols" to "Using Fonts".  Add
	  giant new introduction, properly establishing terminology.
	- Rename node/section "Changing Fonts" to "Selecting Fonts".
	  Shift location of `.fn` and `.sty` register documentation.
	  Rewrite presentation of `ft` and `\f`.  Discuss typeface
	  selection by mounting position and font (or style) name
	  together; since arguments to these formatter instructions are
	  always interpreted as mounting positions first, it doesn't
	  make much sense to me to present them separately, and the new
	  introduction provides the necessary background.  Tighten
	  example.  Document that current and previous font selections
	  are environment properties.
	- Add several concept index entries.
	- Do more migration from "symbol" and "glyph" names to "special
	  character" names.

	* man/groff.7 (Using fonts): Introduce new section, synced with
	the renamed node from our Texinfo manual above.

	Fixes <https://savannah.gnu.org/bugs/?62973>.

2023-05-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Revise "Page Layout" material.

	* doc/groff.texi:
	- Recast generally.
	- Describe behavior of `pl` in more detail.
	- Migrate terminology from "scaling indicator" to "scaling
	  unit".
	- Stop discussing page margins in the context of the `pl`
	  request.
	- Move concept index entries regarding margins from here to
	  "Traps".
	- Move discussion of `pn` request to precede `tl` request.
	- Add concept index entries.
	- Recast description of `tl` request.  Migrate terminology from
	  "justification" to "alignment".
	- Recast description of `lt` request.  Describe behavior in more
	  detail.
	- Recast description of `pc` request.
	- Add example of `lt` and `tl` usage.  Add forward reference to
	  "Traps", mentioning page header and footer traps.

	Fixes <https://savannah.gnu.org/bugs/?55124>.  Thanks to Dave
	Kemper for the report.

2023-05-22  Dave Kemper <saint.snit@gmail.com>

	[docs]: Correct minor punctuation, grammar, and spelling issues.

	Also remove a couple instances of unnecessarily telling the
	reader to note something.

	* doc/groff.texi:
	* man/groff.7.man:
	* man/groff_char.7.man:
	* man/groff_diff.7.man:
	* man/roff.7.man:
	* src/roff/nroff/nroff.1.man: Do it.

	Fixes <https://savannah.gnu.org/bugs/?64230>.  [I threw in a few
	more fixes.  --GBR]

2023-04-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Attempt to further clarify end-of-sentence detection.

	* doc/groff.texi (Sentences):
	* man/roff.7 (Concepts): Do it.

	Fixes <https://savannah.gnu.org/bugs/?64091>.  Thanks to Ingo
	Schwarze and Dave Kemper for the report.

2023-04-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Minimally document `tag`, `taga` requests.

	* doc/groff.texi (Postprocessor Access):
	* man/groff.7 (Request short reference): Do it.

	Fixes <https://savannah.gnu.org/bugs/?62695>.

2023-04-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Fix typos.

	* doc/groff.texi (ms basic information):
	* doc/ms.ms (Basic information): Do it.

	Fixes <https://savannah.gnu.org/bugs/?64032>.  Thanks to an
	anonymous reporter.

2023-03-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Operators in Conditionals):
	* man/groff.7.in (Conditional expressions): Clarify how the
	output comparison operator is recognized.

	Fixes <https://savannah.gnu.org/bugs/?63812>.  Thanks to John
	Gardner for the report.

2023-03-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	Use a better type for symbol hashes.

	* bootstrap.conf: Add "stdint" module to ensure that the
	`uintptr_t` type is available.
	* src/include/symbol.h: Include <stdint.h> for `uintptr_t`.
	(class symbol):
	(symbol::hash): Change return type from `unsigned long`, which
	causes build failures on 64-bit MinGW, to `uintptr_t`.
	(symbol::hash): Use a C++ type cast, not a C-style one.

	Thanks to Bruno Haible for reporting the build failure in the
	64-bit MinGW environment, and for suggesting a remedy.

2023-03-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[groff]: Revise a test to be more revealing.

	* src/roff/groff/tests/initialization_is_quiet.sh: Stop using
	"set -e".  Instead use `fail` variable and `wail` function (and
	lowercase names for our internal variables) like many of our
	other tests.  If the "unset" shell built-in fails, skip the
	test (prompted by /usr/xpg4/bin/sh on Solaris).  Attempt every
	groff locale, with and without compatibility mode initially
	enabled, instead of stopping at the first failure.  Report
	standard error and standard output content separately.  Use
	groff's `-a` flag to prepare the standard output, for
	readability.
	* PROBLEMS: Document that this test might be skipped rather than
	failing on Solaris.  (What actually happens depends on which
	shell you run it with, and we advise a variety of approaches.)

	Thanks to Bruno Haible for feedback regarding mysterious
	failures of this test on GNU/Hurd and NetBSD systems.

2023-03-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* bootstrap.conf (gnulib_modules): Add "stdbool-c99" per
	recommendation from Bruno Haible.

	Fixes build problem on Solaris using Sun compiler.

2023-03-06  Bruno Haible <bruno@clisp.org>

	* Makefile.am (AR): Remove hardcoded value. Let Automake use the
	value from config.status.

	{Fixes build problem on 64-bit AIX.  Problem appears to date
	back to commit 5fec19d453, 2014-08-15. --GBR}

2023-03-06  Bruno Haible <bruno@clisp.org>

	* arch/misc/misc.am (shdeps.sed): Rename target from this...
	($(SH_DEPS_SED_SCRIPT)): ...to this, to work better with make(1)
	on FreeBSD, NetBSD, and AIX.

2023-03-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Discard now-unneeded Autoconf macro and variables.

	* configure.ac: Stop calling `GROFF_POPPLER`.  Stop populating
	the Automake conditional `HAVE_PDFTOOLS`.  Eliminate chatter
	about their availability in the configuration report.
	* m4/groff.m4 (GROFF_POPPLER): Delete.

2023-03-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_URW_FONTS_NOTICE): Adapt wording of notice
	to presence and identity of Ghostscript interpreter command.
	Clarify that it is gropdf(1) specifically that traverses the
	Ghostscript search path reported by its "-h" option.

	Continues <https://savannah.gnu.org/bugs/?63808>.  Thanks to
	Deri James for the ongoing discussion.

2023-02-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	[devpdf]: Revise tests.

	* font/devpdf/tests/check-default-foundry.sh.in: Test only the
	base 14 fonts of the PDF standard unconditionally.  Test the
	remainder from the set of 35 commonly distributed only if a
	Ghostscript interpreter was detected at configuration time,
	because the latter fonts _must_ be embedded in PDF documents.
	If they're not present, skip the test rather than failing it.
	* font/devpdf/tests/check-urw-foundry.sh.in: Skip test if no URW
	fonts detected at configuration time, rather than failing it.
	* m4/groff.m4 (GROFF_GROPDF_PROGRAM_NOTICE)
	(GROFF_URW_FONTS_NOTICE): Drop warnings of expected test
	failures.  The tests no longer fail in the anticipated
	circumstances.

2023-02-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[devpdf]: Generate tests from template files, so we can populate
	the test scripts with information determined at configuration.
	The default foundry test depends on $GHOSTSCRIPT, and the URW
	foundry test on $urwfontsdir.

	* font/devpdf/tests/check-default-foundry.sh:
	* font/devpdf/tests/check-urw-foundry.sh: Rename these...
	* font/devpdf/tests/check-default-foundry.sh.in:
	* font/devpdf/tests/check-urw-foundry.sh.in: ...to these.

	* font/devpdf/devpdf.am (font_devpdf_default_test)
	(font_devpdf_urw_test): New variables store names of generated
	test scripts.
	(font/devpdf/tests/check-default-foundry.sh):
	(font/devpdf/tests/check-urw-foundry.sh): New targets produce
	test scripts from corresponding .in files.

2023-02-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[devpdf]: Trivially refactor.  Rename sed-substitutum [Lat.]
	from "@GROFF_GHOSTSCRIPT_INTERPRETERS@" to "@GHOSTSCRIPT@" for
	clarity and brevity; this is a scalar value containing the
	Autoconf-determined name of the Ghostscript interpreter.  It is
	not the same as the replacement that occurs in contrib/pdfmark.

	* font/devpdf/devpdf.am:
	* font/devpdf/util/BuildFoundries.pl: Do it.

2023-02-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Stop scraping output of Ghostscript executable with
	"-h" option to attempt to find URW fonts.  Fonts that ship with
	Ghostscript are regarded as the "default" foundry, not the URW
	foundry (though they often ultimately originate with URW fonts).
	They are often missing Adobe Font Metric (AFM) files, so it is
	impossible for groff to generate font description files for them
	at build time.

	* m4/groff.m4 (GROFF_URW_FONTS_CHECK): Drop `AC_REQUIRE` on
	`GROFF_AWK_PATH`.  Drop awk-based scraping of Ghostscript "-h"
	output.  Annotate need for sync between this list of
	characteristic font file names and the one in BuildFoundries.

	Thanks to Deri James for the ongoing discussions.

2023-02-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Drop now-redundant explicit
	`GROFF_URW_FONTS_CHECK`.  `GROFF_GROPDF_DEPENDENCIES_CHECK`
	`AC_REQUIRE`s it as of commit ec001d2a23, 18 February.

2023-02-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_URW_FONTS_CHECK): When looking for a
	characteristic URW font by its file name, also check for
	"URWGothic-Book" with no file extension.  Avoids false negatives
	in URW Type 1 font detection when using Ghostscript 9.53.3.
	Thanks to Deri James for suggesting the test procedure that
	uncovered this flaw.

2023-02-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* Makefile.am (uninstall_groffdirs): Remove "html.mono" and
	"html.node" directories corresponding to HTML version of our
	Texinfo manual.
	* doc/doc.am (uninstall-html): Uninstall HTML version of our
	Texinfo manual more reliably.

	Fixes a regression introduced by me in commit c2698aade, 6 April
	{my claim "we're only deleting files with this command, not
	directories" was not correct}.

2023-02-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[doc]: Handle output formats of our Texinfo manual more
	consistently.

	* doc/doc.am (install-doc): Add dependency on (Automake
	standard) target 'install-dvi'.
	(maintainer-clean-local): Remove our Texinfo manual in plain
	text format.
	(install-data-local): Add dependency on new target
	'install-txt'.
	(install-txt): Install our Texinfo manual in plain text format.
	(uninstall-local): Add dependency on new target 'uninstall-txt'.
	(uninstall-txt): Uninstall our Texinfo manual in plain text
	format.

	Thanks to T. Kurt Bond for noticing the discrepancy.

2023-02-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (install-pdf-local, install-html-local): Enable
	rules to work in out-of-tree builds.

2023-02-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (uninstall-hook): Drop dependency on
	"uninstall_mom"; this is not the appropriate place to declare
	it, and "uninstall_groffdirs" already depends on it in mom's
	Automake file.

2023-02-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Have more tests report output.

	* src/roff/groff/tests/ab_works.sh:
	* src/roff/groff/tests/handle_special_input_code_points.sh:
	* src/roff/groff/tests/initialization_is_quiet.sh:
	* src/roff/groff/tests/msoquiet_works.sh:
	* src/roff/groff/tests/soquiet_works.sh:
	* tmac/tests/an-ext_MR-works.sh:
	* tmac/tests/an_MR-works.sh: Do it.

2023-02-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Prevent failures when $GROFF_ENCODING is set.

	* src/roff/groff/tests/ab_works.sh:
	* src/roff/groff/tests/handle_special_input_code_points.sh:
	* src/roff/groff/tests/initialization_is_quiet.sh:
	* src/roff/groff/tests/msoquiet_works.sh:
	* src/roff/groff/tests/soquiet_works.sh:
	* tmac/tests/an-ext_MR-works.sh:
	* tmac/tests/an_MR-works.sh:
	* tmac/tests/an_font-remapping-does-not-affect-titles.sh: Unset
	$GROFF_ENCODING before running test because preconv(1) confounds
	these tests.

	Thanks to Alexis for reporting this problem.

2023-02-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Rename test.

	* tmac/tests/s_no-excess-space-around-displays.tmac: Rename...
	* tmac/tests/s_no-excess-space-around-displays.sh: ...to this.
	* tmac/tmac.am (tmac_TESTS): Update.

2023-02-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	[gropdf]: Revise tests to run unconditionally, rather than
	configuring them away at build time, which can cause a
	distribution archive to be incorrectly structured.  Update
	configuration notices when optional dependencies are absent.

	* font/devpdf/devpdf.am (font_devpdf_TESTS): Remove `USE_GROPDF`
	and `HAVE_URW_FONTS` conditionals.
	* m4/groff.m4 (GROFF_GROPDF_PROGRAM_NOTICE):
	(GROFF_URW_FONTS_NOTICE): Warn reader that a gropdf test failure
	is to be expected.

	Fixes <https://savannah.gnu.org/bugs/?63824> (2/2).

2023-02-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	[grohtml]: Revise tests to check for requisite programs at test
	time and skip if not found, rather than configuring them away at
	build time, which can cause a distribution archive to be
	incorrectly structured.

	* m4/groff.m4: Annotate requisite program list since we're
	violating the DRY principle.
	* src/roff/groff/groff.am (groff_TESTS): Populate
	unconditionally.

	* src/roff/groff/tests/html_works_with_grn_and_eqn.sh:
	* src/roff/groff/tests/smoke-test_html_device.sh: Check for
	requisite programs and skip test if any are not found.

	Fixes <https://savannah.gnu.org/bugs/?63824> (1/2).

2023-02-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man pages]: Define page-local `MR` fallback.

	[man pages]: Provide page-local fallback definition of new `MR`
	macro.  I didn't think I was going to have to do this, but the
	premier site on the web for viewing Linux man pages, Michael
	Kerrisk's man7.org, has been pulling snapshots of the pages
	themselves without upgrading the underlying macros, and so man
	page cross references set with `MR` are getting lost in its
	presentations.  (I acknowledge: Ingo Schwarze warned me
	something like this could happen.)  This definition is intended
	as a stopgap measure only.  I want to revert this after groff
	1.23 is released and has spread to some reasonable degree.

	* contrib/chem/chem.1.man:
	* contrib/eqn2graph/eqn2graph.1.man:
	* contrib/gdiffmk/gdiffmk.1.man:
	* contrib/glilypond/glilypond.1.man:
	* contrib/gperl/gperl.1.man:
	* contrib/gpinyin/gpinyin.1.man:
	* contrib/grap2graph/grap2graph.1.man:
	* contrib/hdtbl/groff_hdtbl.7.man:
	* contrib/mm/groff_mm.7.man:
	* contrib/mm/groff_mmse.7.man:
	* contrib/mm/mmroff.1.man:
	* contrib/mom/groff_mom.7.man:
	* contrib/pdfmark/pdfroff.1.man:
	* contrib/pic2graph/pic2graph.1.man:
	* contrib/rfc1345/groff_rfc1345.7.man:
	* man/groff.7.man:
	* man/groff_char.7.man:
	* man/groff_diff.7.man:
	* man/groff_font.5.man:
	* man/groff_out.5.man:
	* man/groff_tmac.5.man:
	* man/roff.7.man:
	* src/devices/grodvi/grodvi.1.man:
	* src/devices/grohtml/grohtml.1.man:
	* src/devices/grolbp/grolbp.1.man:
	* src/devices/grolj4/grolj4.1.man:
	* src/devices/gropdf/gropdf.1.man:
	* src/devices/gropdf/pdfmom.1.man:
	* src/devices/grops/grops.1.man:
	* src/devices/grotty/grotty.1.man:
	* src/devices/xditview/gxditview.1.man:
	* src/preproc/eqn/eqn.1.man:
	* src/preproc/eqn/neqn.1.man:
	* src/preproc/grn/grn.1.man:
	* src/preproc/pic/pic.1.man:
	* src/preproc/preconv/preconv.1.man:
	* src/preproc/refer/refer.1.man:
	* src/preproc/soelim/soelim.1.man:
	* src/preproc/tbl/tbl.1.man:
	* src/roff/groff/groff.1.man:
	* src/roff/nroff/nroff.1.man:
	* src/roff/troff/troff.1.man:
	* src/utils/addftinfo/addftinfo.1.man:
	* src/utils/afmtodit/afmtodit.1.man:
	* src/utils/grog/grog.1.man:
	* src/utils/hpftodit/hpftodit.1.man:
	* src/utils/indxbib/indxbib.1.man:
	* src/utils/lkbib/lkbib.1.man:
	* src/utils/lookbib/lookbib.1.man:
	* src/utils/pfbtops/pfbtops.1.man:
	* src/utils/tfmtodit/tfmtodit.1.man:
	* src/utils/xtotroff/xtotroff.1.man:
	* tmac/groff_man.7.man.in:
	* tmac/groff_me.7.man:
	* tmac/groff_ms.7.man:
	* tmac/groff_trace.7.man:
	* tmac/groff_www.7.man: Do it.

	Fixes <https://savannah.gnu.org/bugs/?63825>.  Thanks greatly to
	Alexis for identifying an issue with mandoc(1)'s handling of an
	earlier iteration of this fallback, and to John Gardner for
	identifying a method of detecting mandoc as the renderer at
	formatting time.

2023-02-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/an_TS-do-not-keep-tables-when-cR-set.sh: Improve
	portability of script by using shell constructs instead of the
	nonstandard GNU coreutils 'seq' utility.  Resolves test failure
	on Solaris 10.
	* HACKING: Document this problem.

2023-02-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_MAKE_DEFINES_RM): Test the make(1) in the
	environment variable $MAKE if defined, not a literal "make".
	Required on (some) Solaris 10 configurations where traditional
	make(1) is not installed but GNU make is installed as "gmake".

2023-02-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/latin2_works.sh: Fix missing backslash in printf.
	Solaris printf(1) was sensitive to this error; macOS and GNU
	printf were not.  Fixes a test failure on Solaris 11.

2023-02-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/tests/regression_savannah_58153.sh: Improve
	portability.  Avoid the unpredictability of implementations when
	putting backslashes inside a groff-piped printf shell command
	inside a here document inside a command substitution by changing
	the groff escape character to something meaningless to the shell
	and to printf ('@').  Fixes a test failure on Solaris 11.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/Foundry.in: Recognize URW foundry replacements for
	Helvetica Bold-Oblique and Helvetica Oblique under the file
	names "NimbusSans-BoldItalic.t1" and "NimbusSans-Italic.t1",
	respectively.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (uninstall-pdf): Clean more fastidiously; try to
	remove the configured `pdfdocdir` in the event it is empty, but
	do not fail if it isn't.  (It can be a directory shared with
	other groff components; we don't know in what order the
	uninstall targets will serialize, but the last one run should
	succeed.)

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Detangle "pdfroff" and "gropdf" configuration (2/2).

	* m4/groff.m4: Give pdfroff its own Autoconf macros to handle
	dependency checking, build objectives, and user notice.
	(GROFF_PDFROFF_DEPENDENCIES_CHECK): New macro requires
	`GROFF_AWK_PATH` and `GROFF_GHOSTSCRIPT_PATH`, determines
	whether pdfroff can be used at build time, and (if not)
	constructs part of message to be shown to user explaining why.
	(GROFF_PDFROFF_PROGRAM_NOTICE): New macro requires
	`GROFF_PDFROFF_DEPENDENCIES_CHECK` and emits message if needed.
	(GROFF_GHOSTSCRIPT_AVAILABILITY_NOTICE): Drop mention of impact
	on pdfroff since its dedicated notice covers this now.
	* configure.ac: Call the new macros at appropriate times.
	Produce a new Automake macro, `USE_PDFROFF`, to replace
	inapposite use of `USE_GROPDF` in pdfmark.am.
	* contrib/pdfmark/pdfmark.am: Use `USE_PDFROFF` instead of
	`USE_GROPDF`.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Detangle "pdfroff" and "gropdf" configuration (1/2).

	* m4/groff.m4 (GROFF_GROPDF_DEPENDENCIES_CHECK): Add
	`AC_REQUIRE`ment on `GROFF_URW_FONTS_CHECK`.  Per discussion
	with Deri James, if _either_ Ghostscript or the URW fonts are
	avilable, gropdf will be fully functional, consequent to commit
	d5515, 22 June.  Drop dependency on awk; it is used only at
	configuration time (in an Autoconf macro) and since Savannah
	#62775 was resolved (19 September), it has not been strictly
	necessary.  (It is useful for searching more locations for URW
	fonts, but several others are searched even if it is absent.)
	Stop populating notice text here, instead moving it...
	(GROFF_GROPDF_PROGRAM_NOTICE): ...here, since it no longer needs
	to be dynamically constructed.

	Continues <https://savannah.gnu.org/bugs/?63808>.  Thanks to
	Deri James for the continued discussion.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Rename `GROFF_CHECK_GROPDF_PROGRAMS` macro to
	`GROFF_GROPDF_DEPENDENCIES_CHECK` to generalize for greater
	accuracy in forthcoming change.

	* configure.ac:
	* m4/groff.m4: Do it.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[gropdf]: Don't run automated tests if 'gropdf' will be
	operating with reduced function.  If neither Ghostscript nor the
	URW fonts are available at configuration time, there is no point
	testing for successful build-time population of the font
	descriptions for the default and URW foundries.

	* font/devpdf/devpdf.am (font_devpdf_TESTS) [USE_GROPDF]: Run
	"check-default-foundry" only if gropdf is fully functional.
	(font_devpdf_TESTS) [USE_GROPDF && HAVE_URW_FONTS]: Run
	"check-urw-foundry" only if the URW fonts were found.

	Continues <https://savannah.gnu.org/bugs/?63808>.  Thanks to
	Deri James for the continued discussion.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[gropdf]: Rename tests to more accurately characterize their
	purpose.

	* font/devpdf/tests/basic-fonts-present.sh:
	* font/devpdf/tests/urw-fonts-present.sh: Rename these...
	* font/devpdf/tests/check-default-foundry.sh:
	* font/devpdf/tests/check-urw-foundry.sh: ...to these.
	* font/devpdf/devpdf.am (font_devpdf_TESTS): Reflect rename.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[gropdf]: Revise tests to be foundry-focussed.

	* font/devpdf/tests/basic-fonts-present.sh: Stop trying to match
	font descriptions in the "devps" directory with ones in
	"devpdf"; instead, test whether "BuildFoundries" did its job.
	Test for font descriptions corresponding to the full 35
	PostScript Level 2 font repertoire, plus groff's "EURO".
	* font/devpdf/tests/urw-fonts-present.sh: Drop stale comment and
	rename variable for better parallelism with the other test
	above.

	Continues <https://savannah.gnu.org/bugs/?63808>.  Thanks to
	Deri James for the continued discussion.

2023-02-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Tweak fix to Savannah #63768.

	* tmac/an.tmac (MR): Ensure `an*url` always has a value,
	defaulting to "format 1" (man:page(section)).  Resequence the
	macOS URL formats to sort the contemporary one before the
	others.
	* tmac/man.local: Reflect resequencing of integer assignments to
	formats.  Clarify historicity of annotations.

	Continues <https://savannah.gnu.org/bugs/?63768>.  Thanks to
	John Gardner for further discussion.

2023-02-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Port a test to Solaris 11 sed.

	* tmac/tests/s_TC-works-with-percent-in-custom-titles.sh: Put
	newlines after opening braces in sed scripts.  macOS and GNU sed
	tolerate their absence, but this sed does not.
	* HACKING: Document this problem.

2023-02-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.am (groff_TESTS) [!USE_GROHTML]: Don't
	test the 'grohtml' driver if we know it won't work.

2023-02-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/tests/\
	device_control_escapes_express_basic_latin.sh: Use printf(1),
	which is often a shell built-in command, more consistently.
	Double backslashes intended as literals in the format string,
	and single-quote format strings using them.  Fixes test failure
	seen on Solaris 11 with GNU Bash 4.4 and ksh 93u+ (2012-08-01).

2023-02-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/an_use-input-traps-correctly.sh: Explicitly test
	`SM` and `SB` with 'ps' output device.  If one set
	GROFF_TYPESETTER=utf8 in the test environment, these test cases
	would fail.  Thanks to John Gardner for the report.

2023-02-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Add Automake conditional, `HAVE_GHOSTSCRIPT`, so
	that we can populate the list of PDF device font tests
	dynamically.  Call new macro
	`GROFF_GHOSTSCRIPT_AVAILABILITY_NOTICE`.  Call
	`GROFF_GHOSTSCRIPT_VERSION_NOTICE` after it, but before
	`GROFF_URW_FONTS_NOTICE`.
	* m4/groff.m4 (GROFF_AWK_NOTICE): New macro produces warning if
	no awk could be found.  This reduces gropdf functionality, but
	so do missing URW fonts, so we report this problem separately.
	Report the names under which we sought it, since there's a
	configure script option for that.
	(GROFF_GHOSTSCRIPT_AVAILABILITY_NOTICE): New macro explains
	consequences of missing optional dependency on Ghostscript
	program: reduced grohtml functionality, nonfunctional pdfroff.
	Report the names under which we sought it, since there's a
	configure script option for that.
	(GROFF_CHECK_GROPDF_PROGRAMS): Better characterize gropdf's
	reduced function, pointing out the ways in which it would be
	more useful if the dependencies were met.  Also simplify the
	computational grammar.
	(GROFF_URW_FONTS_NOTICE): Identify 'U' as the foundry name
	gropdf uses for the URW fonts.  Confirm continuing availability
	of most recent URW fonts release; bump date.
	* font/devpdf/devpdf.am: Test availability of "basic" (PDF base
	14) fonts (plus groff's "EURO") if either Ghostscript or URW
	fonts are available.  Test availability of URW fonts (35) only
	if Ghostscript _and_ the URW fonts were found at configuration
	time.

	Fixes <https://savannah.gnu.org/bugs/?63808>.  Thanks to Deri
	James for the report and extremely helpful pseudocode.

2023-02-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_GHOSTSCRIPT_VERSION_CHECK,
	GROFF_URW_FONTS_NOTICE): Add macro dependency on
	`GROFF_GHOSTSCRIPT_PATH`, which should have been there already.
	(GROFF_GROHTML_PROGRAM_NOTICE): Add macro dependency on
	`GROFF_CHECK_GROHTML_PROGRAMS`, which should have been there
	already.

	(GROFF_CHECK_GROHTML_PROGRAMS, GROFF_PNMTOOLS_CAN_BE_QUIET):
	Move `AC_REQUIRE` expansions to precede shell variable
	assignments (after checking that the required macros don't
	clobber the assignments we're making).

2023-02-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/tests/basic-fonts-present.sh: Revise test again,
	per feedback from Deri James.  Even without Ghostscript or URW
	fonts available, gropdf can generate valid PDF documents; it
	simply can't embed fonts in general (without further
	arrangements made on the host system), which means it is
	restricted to the PDF base 14 fonts.  That's enough for many
	purposes, including generating our compiled man pages document
	{with minor degradations to the typeface lists in gropdf(1) and
	grops(1)}.  Drop the 'gs' command check, which also didn't check
	for the name of the Ghostscript interpreter determined by the
	"configure" script.  Replace dynamically generated font list
	with a static one (the base 14 fonts plus groff's EURO).

2023-02-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/tests/basic-fonts-present.sh: Revise test.
	Improve explanation of why we're looking for the gs(1) command
	in a font availability test.  Prefix diagnostic output with name
	of test script.  Perform a search for the 'ps' device font
	descriptions that will work in more build scenarios (i.e., don't
	assume an out-of-tree build taking place in an immediate
	subdirectory of the source).  Distinguish failure to find the
	font descriptions from a failure to locate the 'gs' command,
	skipping the test in both scenarios.  Reduce noise in output.
	* m4/groff.m4 (GROFF_CHECK_GROPDF_PROGRAMS): Revise warning
	issued when awk and Ghostscript are unavailable; gropdf will not
	be completely inoperative.  Characterize its reduced function.

	Thanks to Deri James in <https://lists.gnu.org/archive/html/\
	groff-commit/2023-02/msg00089.html> for prompting me to take a
	another look at this.

2023-02-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/latin2_works.sh:
	* tmac/tests/latin5_works.sh:
	* tmac/tests/latin9_works.sh: Port to work around macOS's
	apparently POSIX non-conforming 'od' command.  Use single-byte
	octal output format instead of "character", and update test
	expectations accordingly.  Apparently gratuitously, macOS also
	puts more spaces after the octal address field when using this
	output format.
	* HACKING: Document, and elaborate upon, this problem.

2023-02-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Port a test to work with macOS sed.

	* tmac/tests/doc_heading-font-remapping-works.sh: Put semicolons
	between commands and closing braces in sed script.  Put each of
	multiple closing braces on a separate input line, because macOS
	doesn't accept them otherwise.  Resolves test failure observed
	on macOS.
	* HACKING: Document the closing brace sequence problem.

2023-02-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Port a test to work with macOS sed.

	* tmac/tests/an_TS-adds-no-vertical-space.sh: Put semicolons
	between commands and closing braces in sed script.  Separate
	command stream into multiple '-e' expressions, breaking them
	after branch and label commands.  Resolves test failure observed
	on macOS.
	* HACKING: Document the above problems.

2023-02-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/tests/\
	some_escapes_accept_newline_delimiters.sh: Weaken regexes in two
	test cases to accommodate excessive output from macOS's 'od'
	command.  Resolves test failure seen on macOS.
	* HACKING: Add section "Writing Tests" and document the above
	since this is the second time I've cracked my shin on this.

2023-02-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/tests/basic-fonts-present.sh: Skip test if 'gs'
	command not available.  The test is to ensure that gropdf will
	produce sound documents using the base fonts from PostScript,
	but since gropdf requires Ghostscript to do this (as noted in
	our "./configure" messages), it makes no sense to validate font
	availability if the program is absent.  Resolves test failure
	seen on macOS with minimal dependencies installed.

2023-02-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Manipulating Filling and Adjustment): Say more
	about the consequences of a break.

	Fixes <https://savannah.gnu.org/bugs/?63777>.  Thanks to Dave
	Kemper for the report.

2023-02-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Re-re-christen 'ESCAPE_AMPERSAND' ('\&').  Now call it a
	{non-transparent} "dummy character".  Also rechristen
	'ESCAPE_RIGHT_PARENTHESIS', ('\)') as the "transparent dummy
	character"; it has no impact on sentence-ending detection.

	* doc/groff.texi:
	* doc/meref.me.in:
	* man/groff.7.man:
	* man/groff_diff.7.man:
	* man/roff.7.man:
	* src/preproc/refer/refer.1.man:
	* tmac/groff_man.7.man.in: Do it.

	Fixes <https://savannah.gnu.org/bugs/?62816>.  Thanks to Dave
	Kemper for the report and to the groff mailing list for the
	vigorous discussion.  I don't expect my solution to please
	everyone.

2023-02-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Add internal register `an*MR-URL-format` to
	select from a few known formats of man page hyperlink.  There
	are three known on macOS, and one used everywhere else.
	* tmac/man.local: Document this feature so macOS users can enjoy
	the OSC 8 hyperlink feature if their terminal application
	supports it.

	I hope that this feature will be a temporary measure while macOS
	implements support for the man page URL format used everywhere
	else in the world.

	Fixes <https://savannah.gnu.org/bugs/?63768>.  Thanks to John
	Gardner for the report, research, consultation, and testing.

2023-02-11  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[BuildFoundries]: Fails if neither ghostcript nor URW fonts
	are installed.

	* font/devpdf/util/BuildFoundries.pl: When the change to hold
	paths in an array, rather than a delimited string (see commit
	4ae4aeb6555f4f16c28fcb03eb1f56577826054c), the FindGSpath
	subroutine should return a pointer to an empty array when the
	call to ghostscript fails, rather than return an empty string,
	as was done previously.

	See <https://lists.gnu.org/archive/html/groff/2023-02/\
	msg00042.html>; thanks to Bruno Haible for the report.

2023-02-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	Switch to using system's assert.h header file.  It is futile to
	attempt to preserve compatibility with ISO C90 systems by
	providing a bespoke predicate-reporting assert() (a C99 feature)
	when gnulib, which we require, itself demands C99.  This ensures
	that `static_assert` remains defined so that gnulib can use it.
	Thanks to Bruno Haible for the consultation.
	<https://lists.gnu.org/archive/html/groff/2023-02/msg00034.html>

	* src/include/assert.h: Delete.

	* src/devices/grodvi/dvi.cpp:
	* src/devices/grolbp/lbp.cpp:
	* src/devices/grolj4/lj4.cpp:
	* src/include/itable.h:
	* src/include/stringclass.h:
	* src/libs/libbib/linear.cpp:
	* src/libs/libbib/search.cpp:
	* src/libs/libdriver/printer.cpp:
	* src/libs/libgroff/assert.cpp:
	* src/libs/libgroff/color.cpp:
	* src/libs/libgroff/errarg.cpp:
	* src/libs/libgroff/font.cpp:
	* src/libs/libgroff/nametoindex.cpp:
	* src/libs/libgroff/prime.cpp:
	* src/libs/libgroff/relocate.cpp:
	* src/libs/libgroff/searchpath.cpp:
	* src/preproc/eqn/box.cpp:
	* src/preproc/eqn/delim.cpp:
	* src/preproc/eqn/pile.cpp:
	* src/preproc/eqn/script.cpp:
	* src/preproc/html/pre-html.cpp:
	* src/preproc/pic/pic.h:
	* src/preproc/preconv/preconv.cpp:
	* src/preproc/soelim/soelim.cpp:
	* src/roff/groff/groff.cpp:
	* src/roff/troff/troff.h:
	* src/utils/hpftodit/hpftodit.cpp:
	* src/utils/indxbib/indxbib.cpp:
	* src/utils/lkbib/lkbib.cpp:
	* src/utils/lookbib/lookbib.cpp:
	* src/utils/tfmtodit/tfmtodit.cpp: Respell "assert.h" inclusion
	with angle brackets instead of quotation marks.

	Fixes <https://savannah.gnu.org/bugs/?63078>.

2023-02-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (token::next): Use correct kind of
	null object in comparison.  Fixes latent bug that would be
	exposed if we were to migrate from zero literals to `nullptr`.

2023-02-09  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf] Parse multiple entries in 'papersize' as specified in
	the groff_font man page. Reported by Ben Wong and fix based on
	his patch, thanks.

	* src/devices/gropdf/gropdf.pl: Parse papersize string for
	possible multiple (space separated) entries. First valid entry
	wins.

	Fixes https://savannah.gnu.org/bugs/?63757

2023-02-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	Correct numerous typos and solecisms throughout the source tree.

	* ChangeLog:
	* ChangeLog.115:
	* ChangeLog.116:
	* ChangeLog.117:
	* ChangeLog.118:
	* ChangeLog.119:
	* ChangeLog.121:
	* ChangeLog.122:
	* Makefile.am:
	* NEWS:
	* PROBLEMS:
	* README:
	* contrib/chem/chem.am:
	* contrib/chem/chem.pl:
	* contrib/glilypond/README.txt:
	* contrib/glilypond/glilypond.pl:
	* contrib/hdtbl/groff_hdtbl.7.man:
	* contrib/mm/ChangeLog:
	* contrib/mm/m.tmac:
	* contrib/pdfmark/pdfmark.ms:
	* doc/automake.mom:
	* doc/groff.texi:
	* doc/me-revisions:
	* doc/webpage.ms:
	* m4/lib-link.m4:
	* man/groff.7.man:
	* man/groff_diff.7.man:
	* man/roff.7.man:
	* src/devices/grohtml/post-html.cpp:
	* src/devices/grolbp/lbp.h:
	* src/devices/gropdf/TODO:
	* src/devices/gropdf/gropdf.1.man:
	* src/devices/gropdf/gropdf.pl:
	* src/devices/xditview/ChangeLog:
	* src/devices/xditview/xditview.c:
	* src/libs/libdriver/input.cpp:
	* src/libs/libgroff/glyphuni.cpp:
	* src/preproc/eqn/eqn.1.man:
	* src/preproc/grn/gprint.h:
	* src/preproc/grn/main.cpp:
	* src/preproc/html/pre-html.cpp:
	* src/preproc/preconv/preconv.cpp:
	* src/preproc/tbl/table.cpp:
	* src/roff/groff/pipeline.c:
	* src/roff/groff/tests/substring_works.sh:
	* src/roff/groff/tests/
	use_point_size_escape_with_single_digit_arg.sh:
	* src/roff/troff/div.cpp:
	* src/roff/troff/input.cpp:
	* src/roff/troff/troff.1.man:
	* src/utils/grog/grog.pl:
	* src/utils/indxbib/indxbib.cpp:
	* src/utils/tfmtodit/tfmtodit.1.man:
	* tmac/doc-old.tmac:
	* tmac/doc.tmac:
	* tmac/groff_man.7.man.in:
	* tmac/hyphen.fr: Do it.

	Fixes <https://savannah.gnu.org/bugs/?63589>.  Thanks to Bjarni
	Ingi Gislason for the report.

2023-02-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Drop XFAIL test.  It was written with an unclear
	understanding of how DWB (AT&T) and Heirloom Doctools troff
	behaved.  The individual checks might come back, modified.

	* src/preproc/tbl/tests/table-lacks-spurious-top-border.sh:
	Delete.

	* src/preproc/tbl/tbl.am (tbl_TESTS): Drop it.
	(tbl_XFAIL_TESTS, XFAIL_TESTS): Drop now empty assignment and
	unnecessary update, respectively.

2023-02-04  Bertrand Garrigues <bertrand.garrigues@laposte.net>

	Update gnulib submodule

	gnulib now points on sha1 4e9fcc7b84fcac07a3e5a3cd5f66d1ff320dc8e8

2023-02-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Fix bugs using boxes or vertical rules at table edges on
	nroff devices, particularly when combined with region or column
	expansion.

	* src/preproc/tbl/table.h (class table): Add `GAP_EXPAND`
	enumeration constant.  James Clark seems to have designed GNU
	tbl carefully to avoid distinguishing region expansion from
	column expansion in a categorical way, but I needed a way for
	formatting-time logic to know which was in use.  (Column
	expansion, the "x" modifier, expands columns--i.e., text.
	Region expansion expands [or compresses] the _gaps_ between
	columns.)
	* src/preproc/tbl/main.cpp (process_options): Set `GAP_EXPAND`
	flag in table if "expand" region option seen.
	* src/preproc/tbl/table.cpp: Add new macro `LEFTOVER_FACTOR_REG`
	to name a new roff register for the remainder of gap-expansion
	space when the amount of space available for expansion is
	divided by the number of gaps.
	(table::compute_overall_width): If _not_ expanding a table in
	either respect and in nroff mode, reduce line length by 1n for
	each of any left and right border (because the vertical lines
	eat character cells).  This prevents bordered or boxed tables
	from being overset even when they use neither expansion feature.
	(table::compute_separation_factor): If gap-expanding a table,
	store any remainder from the division used to compute the
	separation factor into the new `LEFTOVER_FACTOR_REG`.
	(table::compute_column_positions): Insert that remainder into
	the gap before the last (rightmost) column of the table.  This
	_could_ be done more elegantly by spreading each en in a
	symmetric way across a subset of the gaps.  (It is necessarily a
	subset by the pigeonhole principle.)  But it didn't seem worth
	the effort for a feature (region expansion) that few users
	employ.  (Usually what you want is the "x" column modifier.)
	Alternatively, "forget it, Jake--it's a terminal emulator".

	* src/preproc/tbl/tbl.am (tbl_XFAIL_TESTS): Remove now-passing
	tests.

	Fixes <https://savannah.gnu.org/bugs/?63640> and
	<https://savannah.gnu.org/bugs/?63749>.

2023-02-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp (table::compute_column_positions):
	Stop multiplying the gaps at the left and right edges of a table
	{which occur when it is boxed or has a leading and/or trailing
	vertical line} by the column separation factor.  Only interior
	column gaps should be spread.  This change prevents tables using
	the "expand" region option from being overset (exceeding the
	line length), but might not (yet) fully expand to that length on
	low-resolution devices due to integer roundoff.

2023-02-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp (table::compute_total_separation)
	(table::compute_separation_factor, table::compute_widths): Add
	comments to generated roff output to assist the mystified user.

2023-02-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Refactor.

	* src/preproc/tbl/table.cpp:
	* src/preproc/tbl/table.h: Rename `compute_expand_width` to
	`compute_overall_width`, since this member function is used on
	_all_ tables, not just those undergoing column or gap expansion.
	For instance, in a post-groff 1.22.4 development, it throws a
	diagnostic if an unexpanded table overruns the line length.
	* src/preproc/tbl/table.cpp (table::compute_widths): Update call
	site of `compute_overall_width`.
	* src/preproc/tbl/table.cpp: Split the roff register behind the
	`EXPAND_REG` C++ preprocessor macro into two, adding
	`AVAILABLE_WIDTH_REG`.  Annotate the distinction.
	(compute_overall_width): Annotate.  Move and conditionalize
	logic so as not to produce as much unnecessary roff output.

2023-02-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/main.cpp (main): Avoid reading from invalid
	memory upon failure to open an input file.

	Fixes <https://savannah.gnu.org/bugs/?63751>.

2023-02-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/lex.cpp (get_delimited_text): Avoid reading
	from invalid memory when throwing diagnostic.  Duplicate
	`filename` string, then free it on all paths out of function.

	Fixes <https://savannah.gnu.org/bugs/?63214>.

2023-02-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Add more tests.

	* src/preproc/tbl/tests/boxes-and-vertical-rules.sh:
	* src/preproc/tbl/tests/expand-region-option-works.sh:
	* src/preproc/tbl/tests/x-column-modifier-works.sh: Do it.

	* src/preproc/tbl/tbl.am (tbl_TESTS): Run tests.
	(tbl_XFAIL_TESTS): Add; future changes will resolve these.

2023-02-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp (table::compute_column_positions):
	If a table has "left separation" (it is boxed, or has a vertical
	rule on the left-hand side), increase the first column's start
	register value by 1n, for symmetry with the right-hand size.

	* src/preproc/tbl/tests/check-horizontal-line-length.sh:
	* src/preproc/tbl/tests/check-line-intersections.sh:
	* src/preproc/tbl/tests/check-vertical-line-length.sh: Update
	output expectations.

	* src/preproc/tbl/tbl.am (tbl_XFAIL_TESTS): Remove now-passing
	test.

	See <https://savannah.gnu.org/bugs/?61597> for background.

2023-02-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp (table::compute_total_separation):
	Trivially refactor; rename loop indices so it's obvious which
	dimension of a matrix they're referring to.

2023-02-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp (table::determine_row_type)
	(table::compute_widths, table::do_row): Boolify some local ints.

2023-02-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Refactor handling of vertical lines in format.  Validate
	input more strictly.  Add diagnostics when vertical lines are
	redundant with box borders.

	* src/preproc/tbl/main.cpp (process_format): Shift diagnostic
	about excess vertical lines in a sequence at the beginning of a
	row description to later, after the first proper column
	descriptor has been interpreted.  Normalize a sequence of more
	than two consecutive vertical lines to 2 when they occur at the
	beginning of a row description.  Unconditionally update
	`list->vline` and reset `vline_count` once we start looking for
	modifiers, since we know we've finished any sequence of vertical
	lines, and at the end of a row definition.  Rename and retype
	loop variable int `success` to Boolean
	`is_valid_modifier_sequence`.  Drop now-invalid assertion.
	* src/preproc/tbl/table.cpp (table::add_vlines): Throw new
	diagnostics when vertical lines are redundant with box borders.
	Add assertion to ensure we got a valid vertical line value (0,
	1, or 2) from `process_format`.  Throw these only once per table
	format, not for every row.

2023-01-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/main.cpp (process_table): Trivially refactor.
	Rename `form` to `fmt` to imply "format", not "form".

2023-01-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/main.cpp (process_format): Throw error
	diagnostic if more than 2 vertical lines are specified at the
	beginning of a row definition.

	Fixes <https://savannah.gnu.org/bugs/?63731>.

2023-01-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/main.cpp (process_format): Recast diagnostic
	message to refer to character by its Unicode name and generalize
	to accurately cover additional circumstance of excess '|'
	symbols at end of row definition.

2023-01-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/ms.ms: Remove redundant initializations.

2023-01-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/ms.ms: Define appropriate hyphen-minus mapping on 'cp1047'
	output device.

2023-01-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (TE): Enable no-space mode after outputting the
	display distance vertically, replacing any inter-paragraph
	distance that might follow.

2023-01-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[grohtml]: Fix misleading diagnostic message.

	* src/preproc/html/pre-html.cpp (main): The suggestion should be
	to re-run the formatter (groff, troff), not "pre-grohtml", with
	a different output driver since the document may be malformed.

2023-01-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/main.cpp (process_format): Fix code hygiene
	nit: nullify `list` pointer after freeing its target.

2023-01-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Really fix Savannah #63449.

	* src/preproc/tbl/main.cpp (process_format): "Or" on the
	`HAS_TOP_VLINE` flag if the format specification begins with a
	"|"; the beginning is a separate state in the FSM used to parse
	the description.  I missed it in commit 0e93ab4102, 1 December.

	Fixes <https://savannah.gnu.org/bugs/?63449>.

2023-01-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/tests/\
	do-not-overdraw-page-top-in-nroff-mode.sh: Correct erroneous
	check of test output, and add two more test cases.

2023-01-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Move the saving of the hyphenation mode from
	the "top level" to...
	(mY): ...this new macro.
	(SY, mQ, MR): Call `mY` before disabling hyphenation.

	Problem introduced by me in commit 096c2f0567, 16 February.
	"an-ext.tmac" gets sourced by "an.tmac" before any
	command-line setting of the `HY` register is handled, so (for
	groff) the stored hyphenation mode was the default for the
	language, not reflecting user disablement.  The synopsis macros,
	which do not have an alternate implementation in "an.tmac" for
	leverage of groff features, were causing hyphenation to be
	resurrected (after `YS`) even if the user had disabled it.
	Saving the hyphenation mode anew upon entry to these macros is
	arguably inefficient, but it is more correct since a man page
	could conceivably manipulate the automatic hyphenation mode
	{even if that's not recommended outside of tbl(1) text blocks}.

2023-01-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Add regression test for hyphenation getting wrongly
	restored by `YS`, `ME`, `UE`, and `MR` macros.

	* tmac/tests/an_HY-register-works.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2023-01-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (Sh, Ss): Narrow scope of font remappings
	lexically and restrict remapping to the heading font family (if
	any) to avoid undesired remapping of fonts in page headers if,
	say, a (sub)section heading begins just prior to a page
	break--which is ugly anyway and should be avoided, but the
	package has no keep macros and solving that problem in an
	automatic way promises to be complex.

2023-01-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (MT, UR): Throw style warning if macro called
	without (exactly one) argument.

2022-12-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (doc/groff-man-pages.pdf): Set (sub)section
	headings in Helvetica bold in compiled man pages, as a test and
	demonstration of the `HF` feature's application to both man(7)
	and mdoc(7) documents.

2022-12-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `HF` string.

	* tmac/doc.tmac (initialization): Add logic supporting `HF`
	string just as our man(7) implementation does.  If the font name
	ends with `B` (as the default does), set
	`doc-remap-I-style-in-headings` register and extract font
	family, which can be empty (as is the default).
	* tmac/mdoc/doc-common (Sh, Ss): If
	`doc-remap-I-style-in-headings` register set, perform (and
	unwind) font remapping of italic to bold-italic face.
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Define `doc-Sh-font` in terms of `HF`.

	* tmac/tests/doc_heading-font-remapping-works.sh: Test it.
	* tmac/tmac.am (tmac_TESTS): Run test.

	* tmac/groff_mdoc.7.man (Options): Document it.
	* NEWS: Update item.

	Fixes last part of <https://savannah.gnu.org/bugs/?63046>.

2022-12-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tmac]: Revise "fallback" character definitions in several
	respects for Unicode characters from General Punctuation block.

	* tmac/fallbacks.tmac: Comment out fallbacks for U+200B, U+2010,
	U+2011, and U+201[89CD], due to ineffectuality or apparent groff
	bugs.  Redefine U+2012 fallback to include hair space (\^)
	around synthetic figure dash.  Redefine U+2016 to use `\[ba]`
	special characters instead of ordinary `|` characters to dodge
	possible character translations by user.

	Fixes part of <https://savannah.gnu.org/bugs/?63354>.  Thanks to
	Dave Kemper for the (multifarious) discussion.

2022-12-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Invoking groff, Built-in Registers):
	* man/groff.7.man (Writable predefined registers):
	* src/roff/groff/groff.1.man (Environment):
	* src/roff/troff/troff.1.man (Environment): Replace erroneous
	reference to ctime(3) with localtime(3).

	Fixes <https://savannah.gnu.org/bugs/?63509>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-12-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Fix potential problem(s) in trap handler.

	* src/roff/groff/tests/smoke-test_html_device.sh: Move call of
	`cleanup` function from end of script to after the tests that
	generate temporary files have been run, and before script
	possibly exits with status 77 to skip some checks.  Within trap
	handler, mask trapped signals while running handler.
	(cleanup): Reset trap dispositions to default after removing
	files; once the temporary files are gone, we no longer need a
	trap handler.  One might already be running however, and this
	ensures that its "suicide" ("kill -s INT $$") will succeed.

2022-12-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `FT` register.

	* tmac/doc.tmac (initialization): Add logic supporting `FT`
	register just as our man(7) implementation does.
	* tmac/mdoc/doc-common (doc-set-up-titles): Plant footer trap in
	validated user-requested location.
	* tmac/groff_mdoc.7.man (Options): Document it.
	* NEWS: Update item.

	Fixes part of <https://savannah.gnu.org/bugs/?63046>.

2022-12-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Fix code style nit: use `as` requests to
	avoid overlong input lines.

2022-12-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac: Inform user we're ignoring their "-rD1" setting
	if also formatting HTML; parallels groff man(7) behavior.

2022-12-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac: Trivially refactor.  Relocate handling of `D`
	command-line register to prepare for greater synchronization
	with groff man(7).

2022-12-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp: Trivially refactor.  Rename
	{portion of} internal register to include an interword hyphen
	for readability.

2022-12-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Change default line length to 6.5 inches.

	* tmac/s.tmac (par@load-init): Do it.

	* doc/groff.texi (ms Document Control Settings):
	* doc/ms.ms (Document control settings):
	* tmac/groff_ms.7.man (Document control settings): Document it.

	* tmac/tests/s_honor-MINGW-when-two-columns.sh:
	* tmac/tests/s_mark-column-start-correctly.sh: Update test
	expectations.

	* NEWS: Add item.

2022-12-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (TH): Relocate `an-break-body-text` trap to be
	one half-inch above footer (instead of twice the footer
	distance).  I reason that anyone who customizes `FT` is doing so
	to overprint some kind of material at the bottoms of pages, or
	simply to make the margin larger.  (One then wonders why we
	don't have an `HD` register for the top.)  Also remove register
	when done with it.
	* tmac/groff_man.7.man.in (Options) <FT>: Document this.

2022-12-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (TH): Trivially refactor.  Rename
	`an-footer-location` to `an*footer-location` and set page traps
	in order descending the page.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `X` register.

	* tmac/doc.tmac (initialization): Add logic supporting `X`
	register just as our man(7) implementation does.
	* tmac/groff_mdoc.7.man (Options): Document it.
	* NEWS: Update item.

	Fixes part of <https://savannah.gnu.org/bugs/?63046>.

2022-12-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Add unit test for `X` register.

	* tmac/tests/doc_X-register-works.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-12-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac (Nm): Fix `if` -> `ie` typo/thinko.

	Fixes <https://savannah.gnu.org/bugs/?63527>.  Thanks to John
	Gardner for the report.

2022-12-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/doc_Nm-works.sh: Add more checks.

2022-12-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/tests/smoke-test_html_device.sh: Add checks for
	inlining of images when tbl(1) or eqn(1) used.

2022-12-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/andoc.tmac (reload-man): Unplant `doc-break-body-text`
	trap, added in commit 892703b17e, 6 September.  Its survival
	into man(7) pages didn't seem to cause any problems but I have
	no confidence that will remain true forever.

2022-12-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (initialization): Fix problem with `FT` register
	validation.  Small but valid values were being rejected due to
	inappropriate use of scaling operator.  Also throw user a bone
	by expressing what size '1v' is for the output device, in basic
	units.

2022-12-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man, mdoc]: Fix Savannah #63500.  Support use of `P` (initial
	page number) register when batch rendering, regardless of
	switching macro packages between man(7) and mdoc(7) or setting
	of `C` (continuous numbering) register.  (`P` without `C` means
	"start numbering each rendered document at \n[P]".)

	* tmac/an.tmac (an-end): Call `an*break-page-with-new-number`
	instead of invoking `bp`.
	(an*break-page-with-new-number): If `P` is set and `C` is not,
	use value of `P` as the next page number.
	(TH): If `C` register is set, remove `P` register after ending a
	previous document.
	(initialization): If `P` is set, assign the page number using
	the `pn` request if the transition to the first formatted page
	has not yet occurred; otherwise update page number register `%`
	directly.  Also ignore it with diagnostic if `ps4html` register
	{for grohtml's internal use} is set.  Add explanatory comment.

	* tmac/mdoc/doc-common (Dd): If `C` register is set, remove `P`
	register after ending a previous document.
	(doc-end-macro): Call `doc-break-page-with-new-number` instead
	of invoking `bp`.
	(doc-break-page-with-new-number): If `P` is set and `C` is not,
	use value of `P` as the next page number.
	* tmac/doc.tmac (initialization): If `P` is set, assign the page
	number using the `pn` request if the transition to the first
	formatted page has not yet occurred; otherwise update page
	number register `%` directly.  Also ignore it with diagnostic if
	`ps4html` register (for grohtml's internal use) is set.  Add
	explanatory comment.

	Fixes <https://savannah.gnu.org/bugs/?63500>.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `P` register.

	* tmac/doc.tmac (initialization): Add logic supporting `P`
	register just as our man(7) implementation does.
	* tmac/groff_mdoc.7.man (Formatting with groff, troff, and
	nroff): Document it.
	* NEWS: Update item.

	Fixes part of <https://savannah.gnu.org/bugs/?63046>.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Add unit tests for man/mdoc `P` register.

	* tmac/tests/an_P-register-works.sh:
	* tmac/tests/andoc_P-register-works.sh:
	* tmac/tests/doc_P-register-works.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run tests.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man, mdoc]: Refactor.  Rename a Boolean register to more
	clearly communicate its purpose.  This also reverses its sense.

	* tmac/an.tmac (TH): Rename `an-is-first-page-of-document` to
	`an*need-titles-reset`.  Drop redundant store.  Reverse sense of
	test.
	(initialization): Initialize it to zero.

	* tmac/mdoc/doc-common (Dd): Rename
	`doc-is-first-page-of-document` to `doc-need-titles-reset`.
	Drop redundant store.  Reverse sense of test.
	(initialization): Initialize it to zero.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Add future regression test for header/footer
	mishandling that wasn't already covered (not a live bug; was
	exposed by attempted refactoring).

	* tmac/tests/andoc_check-an-to-doc-transition.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man, mdoc]: Trivially refactor.

	* tmac/an.tmac (an-start-new-document): Rename this...
	(an*break-page-with-new-number): ...to reflect its reduced
	responsibility.

	* tmac/mdoc/doc-common (doc-start-new-document): Rename this...
	(doc-break-page-with-new-number): ...to reflect its reduced
	responsibility.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man, mdoc]: Refactor to separate page number management from
	header trap management.

	* tmac/an.tmac (an-start-new-document): Stop removing
	`an-header` trap.
	(TH): Clear the trap here even if not continuously rendering,
	and call `an-start-new-document`.

	* tmac/mdoc/doc-common (doc-start-new-document): Stop removing
	`doc-header` trap.
	(Dd): Clear the trap here even if not continuously rendering,
	and call `doc-start-new-document`.

2022-12-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common: Refactor for better parallelism with our
	man(7) implementation and to prepare for a synchronized change
	to both.
	(Dd): Move open-coded (inlined) operations from here...
	(doc-start-new-document): ...to this new macro.
	(doc-end-macro): Drop unnecessary register assignment.  `Dd`
	takes care of it if there is a subsequent mdoc(7) document.

2022-12-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Fix off-by-one error in generated diagnostic message.

	* src/preproc/tbl/table.cpp: Define new preprocessor macro,
	`PREVIOUS_PAGE_REG`.
	(table::init_output): Compute value for register named using
	`PREVIOUS_PAGE_REG`, use it in diagnostic, and then remove it.
	Also fix verb tense in message.

2022-12-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Expose the fact of a table's boxedness via a troff
	register so that macro packages can make more intelligent
	decisions about space requirements (since box borders occupy
	significant space on nroff devices).

	* src/preproc/tbl/table.cpp: Define new preprocessor macro,
	`IS_BOXED_REG`.
	(table::do_top): Initialize "boxedness" register.

2022-12-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (TH): Clarify computation and diagnostic message.

2022-12-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Fix Savannah #61878.

	* src/preproc/tbl/table.cpp: Define new preprocessor macro,
	`STARTING_PAGE_REG`.
	(table::define_bottom_macro): Have the formatter issue a warning
	if an unkept, boxed table ends on a different page than it
	began.
	(table::do_top): Save current page number when table begins.

	Fixes <https://savannah.gnu.org/bugs/?61878>.

2022-12-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Regression-test Savannah #61878.

	* src/preproc/tbl/tests/\
	warn-on-long-boxed-unkept-table.sh: Do it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run test.

2022-12-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp: Write comments to generated output;
	these correspond to functions in this file and to major
	operations of table construction.
	(init_output, compute_widths, define_bottom_macro, do_row)
	(do_top, do_bottom): Do it.

2022-12-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Trivially refactor.  Rename class `constant_int_reg` to
	`readonly_register`.  Say "readonly" instead of "const" to
	try to avoid confusion with C++ constness.  Drop "int" because
	integer-valued registers are the norm, not the exception.

	* src/roff/troff/column.cpp (init_column_requests):
	* src/roff/troff/div.cpp (init_div_requests):
	* src/roff/troff/input.cpp (top level, init_input_requests):
	* src/roff/troff/node.cpp (init_node_requests):
	* src/roff/troff/reg.h: Do it.

2022-12-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Trivially refactor.  Rename class `constant_reg` to
	`readonly_text_register`.  Say "readonly" instead of "const" to
	try to avoid confusion with C++ constness.  Say "text" because
	this class is _mostly_ used for interpolation of string-valued
	registers like the version registers `.x`, `.y` and `.Y`.
	Nevertheless there are some abuses (apparently because the
	constructors for register classes don't accept integer
	parameters for initialization--why?).

	* src/roff/troff/input.cpp (top level)
	(readonly_text_register::readonly_text_register)
	(readonly_text_register::get_string)
	(main, init_registers, init_requests): Do it.

2022-12-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Trivially refactor.  Rename `number_reg_dictionary` to
	`register_dictionary`.  It's shorter _and_ non-abbreviated _and_
	matches our documentation.

	* src/roff/troff/column.cpp (init_column_requests):
	* src/roff/troff/div.cpp (page_number, init_div_requests):
	* src/roff/troff/env.cpp (print_env, init_env_requests)
	(init_hyphen_requests):
	* src/roff/troff/input.cpp (length_request)
	(interpolate_number_format, do_register, do_if_request, main)
	(init_registers, init_input_requests):
	* src/roff/troff/node.cpp (get_register, init_node_requests):
	* src/roff/troff/reg.cpp (top level, define_number_reg)
	(inline_define_reg, alter_format, remove_reg, alias_reg)
	(rename_reg, print_number_regs):
	* src/roff/troff/reg.h: Do it.

2022-12-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Add regression test.

	* tmac/tests/an_link-trailing-text-hugs-previous.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-12-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/fallbacks.tmac: Really use troff-mode fallbacks only on
	typesetting devices; because this macro file is loaded so early,
	we cannot rely on ".if t".  Thanks to Dave Kemper for the
	discussion in Savannah #63354.

2022-12-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Use more mnemonic register names, thanks to
	the recent freeing up of some name space.
	- mJ -> mH: saved automatic hyphenation mode
	- mX -> mE: formatting in EX/EE context (Boolean)

2022-12-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/pdf.tmac: Drop deletion of unused string `PDFHREF.TEXT`.

2022-12-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (an-end, AT, UC, DT, PD, SH, IP, BI, BR, IB, IR)
	(RB, RI, OP, an*end-hyperlink, MR): Refactor; "nop"ify macros
	that produce formatted output or call other macros using string
	interpolations--except where we can't: see Savannah #63470.

2022-12-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (R): Drop macro definition, which implements a
	hack for people who try to use "R" as a font style macro.  This
	doesn't seem to happen much in actual practice (though perhaps
	the diagnostic this hack produces is responsible for suppression
	of the mistake).  Retaining it interferes with the
	"nop"-ification of this macro file.
	* NEWS: Add item.

2022-12-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Use truly traditional hyphenation mode on
	non-groff-compatible formatters.

2022-12-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Update test coverage and expectations.

	* tmac/tests/an_ME-punct-hyphenates.sh: Test both "an.tmac" and
	"an-ext.tmac" implementations of `ME`.
	* tmac/tests/an_UE-punct-hyphenates.sh: Test both "an.tmac" and
	"an-ext.tmac" implementations of `UE`.
	* tmac/tests/an_UE-breaks-before-long-URIs.sh: Update test
	expectations.  I appear to have inadvertently fixed some
	inelegant rendering.

2022-12-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Rename to reflect code reorganization.

	* tmac/tests/an-ext_ME-punct-hyphenates.sh:
	* tmac/tests/an-ext_MT-body-hyphenates.sh:
	* tmac/tests/an-ext_UE-breaks-before-long-URIs.sh:
	* tmac/tests/an-ext_UE-punct-hyphenates.sh:
	* tmac/tests/an-ext_UR-body-hyphenates.sh: Rename these...
	* tmac/tests/an_ME-punct-hyphenates.sh:
	* tmac/tests/an_MT-body-hyphenates.sh:
	* tmac/tests/an_UE-breaks-before-long-URIs.sh:
	* tmac/tests/an_UE-punct-hyphenates.sh:
	* tmac/tests/an_UR-body-hyphenates.sh: ...to these.

	* tmac/tmac.am (tmac_TESTS): Reflect renames.

2022-12-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Remove groff-feature-dependent code for
	hyperlink management, greatly reducing the size of the file,
	which we permissively license and encourage people to copy
	around.  Drop register definitions corresponding to
	groff-specific output device names.  Drop definition and use of
	`mL` and `mR` strings for angle brackets; no observable change
	on non-groff formatters.  Recognize `mG` register to enable
	testing of these macros even if the formatter is groff.
	(mV): Radically simplify.  This internal "back-end" for `MT` and
	`UR` now just stores its argument in a string, `m1`.
	(mQ): Radically simplify.  This internal "back-end" for `ME` and
	`UE` now just disables automatic hyphenation, formats the saved
	`m1` string between angle brackets, suffixes it with the
	optional argument, and restores automatic hyphenation.
	(UR, MT): Call `mV` with one argument, not nine.
	(UE, ME): Call `mQ` with one argument, not nine.

	* tmac/tests/an-ext_MR-works.sh: Add test of this file's
	simplified `MR` implementation.
	* tmac/tests/an-ext_MT-works.sh:
	* tmac/tests/an-ext_UR-works.sh: Move tests of groff-specific
	hyperlink output from here...
	* tmac/tests/an_MT-works.sh:
	* tmac/tests/an_UR-works.sh: ...to these new files.
	* tmac/tests/an_MR-works.sh:
	* tmac/tests/an_MT-works.sh:
	* tmac/tests/an_UR-works.sh: Add tests for valid HTML formatting
	of hyperlinks, which experience shows is a bit fragile in the
	face of diversion manipulation and output line continuation.

	* tmac/tmac.am (tmac_TESTS): Run new tests.

2022-12-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Support `mG` register: clear it to force the
	loading of this file's macros even if they have an
	implementation in tmac/an.tmac and the formatter claims groff
	compatibility.  This is to ease these macros' testing under
	groff and keep the implementations here simple.
	* tmac/an.tmac: Initialize `mG` register to 1 if not set on
	command line.

2022-12-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Initialize `mX` register.

2022-12-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Define `mC` string (constant-width typeface
	used by `EX`/`EE` macros) as `R` in nroff mode.  Thanks to
	Russ Allbery for prompting me to think more about the
	limitations of Solaris troff.  Implementations do varying
	things with the "previous" font restored by `\fP` or an
	unargumented `.ft` if a requested font is not found.

2022-11-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Fix Savannah #63449.

	* src/preproc/tbl/table.h (class table): Add new enumeration
	constants for use with `flags` member variable: `HAS_TOP_VLINE`
	and `HAS_TOP_HLINE`, which track properties of the table.
	Unlike others, these have no correspondence to table region
	options.
	* src/preproc/tbl/main.cpp (process_format): Add new local
	Boolean to track whether we're interpreting a format for the
	first row.  Use this to "or" on the `HAS_TOP_VLINE` or
	`HAS_TOP_HLINE` flags if "|" or [_-] are encountered in the
	first row's format, as appropriate.
	(process_data): "Or" on `HAS_TOP_HLINE` if a single or double
	horizontal line is used as the first row's data.
	* src/preproc/tbl/table.cpp (do_top): On nroff mode devices, add
	one vee of space above the table if we're going to be drawing an
	unintersected vertical rule above the table's top.

	Fixes <https://savannah.gnu.org/bugs/?63449>.

2022-11-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Regression-test Savannah #63449.

	* src/preproc/tbl/tests/\
	do-not-overdraw-page-top-in-nroff-mode.sh: Do it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run test.

2022-11-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/main.cpp (struct input_entry_format)
	(input_entry_format::input_entry_format)
	free_input_entry_format_list, process_format): Trivially
	refactor.  Rename `pre_vline` to `vline_count`.

2022-11-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp
	(vertical_rule::contribute_to_bottom_macro, table::print)
	(table::init_output, table::divide_span)
	(table::compute_expand_width, table::define_bottom_macro)
	(table::do_bottom): Produce roff output that is more readable,
	for maintainability.  Indent control lines inside macro
	definitions.  Standardize form of `if`, `ie`, and `el` requests.
	Some output will not be indented because it is produced within
	narrowly-scoped C++ functions (set_troff_location,
	table::print_single_hline, table::print_double_hline,
	table::do_row), I haven't verified that each one is called from
	a consistent troff indentation level, and I'm not sure it's a
	win to parameterize those functions in the indentation level.

2022-11-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Fix Savannah #61909.

	* src/preproc/tbl/table.cpp (SAVED_INTER_WORD_SPACE_SIZE)
	(SAVED_INTER_SENTENCE_SPACE_SIZE): Add new preprocessor macros.
	(block_entry::do_divert): Restore saved inter-word and
	inter-sentence space when formatting a text entry.
	(table::init_output): When a table region begions, save the
	values of inter-word and inter-sentence space.  Add request to
	the reset macro to restore saved inter-word and inter-sentence
	space when leaving table region.
	(table::do_top): Set inter-sentence space to be equal to
	inter-word space.  This way spaces are "literal" in ordinary
	table extries (but not text blocks).

	Fixes <https://savannah.gnu.org/bugs/?61909>.

2022-11-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Regression-test Savannah #61909.

	* src/preproc/tbl/tests/\
	save-and-restore-inter-sentence-space.sh: Do it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run test.

2022-11-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Suppress line numbering when formatting tables, and
	restore it afterward.

	* src/preproc/tbl/table.cpp: Revert much of commit b69062693's
	{2011-07-20} changes to this file.  They were too complex for me
	to understand, and permitted Savannah #60140 to persist (or
	caused it).
	(ROW_START_LINE_REG, ROW_SAVE_LINE_REG, ROW_MAX_LINE_REG)
	(REPEATED_NM_SET_MACRO, REPEATED_NM_SUS_MACRO): Drop
	preprocessor macros.
	(SAVED_NUMBERING_LINENO, SAVED_NUMBERING_SUPPRESSION_COUNT): Add
	new preprocessor macros.
	(table::init_output, table::print_single_hline)
	(table::print_double_hline, table::define_bottom_macro)
	(table::do_row, table::do_top, table::do_bottom): Drop old
	logic.

	(table::init_output): When the table begins, save the current
	line number register `ln` and the count of remaining lines to be
	suppressed (the new `.nn` register).  Then suppress numbering
	for the next 2 billion+ lines of output, with a groveling
	apology to the elegance police.
	(table::do_bottom): Restore saved value of `.nn`.  If numbering
	was active (even if suppressed), restore it with `nm` request.
	If it wasn't, disable it, in case it was turned on inside the
	table region.

	Fixes <https://savannah.gnu.org/bugs/?60140>.  Thanks to Hans
	Bezemer for noting the practical significance of this bug.

2022-11-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Regression-test Savannah #60140.

	* src/preproc/tbl/tests/save-and-restore-line-numbering.sh: Do
	it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run test.

2022-11-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Implement new `.nn` register to report the remaining
	count of lines to have their numbering suppressed.

	* src/roff/troff/env.h (class environment): Declare new member
	function `get_no_number_count()`.
	* src/roff/troff/env.cpp (get_no_number_count): Define new
	member function, returning value of member variable
	`no_number_count`.
	(init_env_requests): Define new ".nn" register and attach it to
	`get_no_number_count()`.

	* doc/groff.texi (Miscellaneous): Document it.  Include example
	of use to determine whether current output line will be
	numbered.  Also clarify meaning of register; `.nn` is not
	decremented except when output line numbering is enabled.
	* man/groff.7.man (Read-only registers): Document it.

	* src/roff/groff/tests/dot-nn_register_works.sh: Test it.
	* src/roff/groff/groff.am (groff_TESTS): Run test.

	* NEWS: Add item.

	See <https://lists.gnu.org/archive/html/groff/2022-11/\
	msg00153.html>.

2022-11-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/fallbacks.tmac: Comment out four of the fallback
	character definitions for (preconv'd) Unicode character input
	added to address Savannah #58930 (corresponding to \[dg], \[dd],
	\[%0], and \[rn]; they are failing for not yet understood
	reasons involving "macros" attached to groff character info
	structs, and the semantics of what it means for a character to
	"exist" per the 'c' conditional operator.  Fixes regression when
	using "tty-char.tmac" (which nroff loads by default).  Problem
	introduced by me in commit 132182bd71, 23 October.  The hope is
	to resolve this issue post-groff 1.23.0.  Thanks to Dave Kemper
	for the report and discussion in Savannah #63332.

2022-11-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac (SY, YS, mV): Remove `mA`, `mI`, and `mT`
	registers when done with them.

2022-11-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/node.h (character_exists):
	* src/roff/troff/node.cpp (character_exists): Boolify.

2022-11-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	[doc]: Add make(1) dependency.

	* doc/doc.am (doc/groff-man-pages.pdf): Add dependency on our
	FreeEuro font since we embed it.

2022-11-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Refactor generation of "freeeuro.pfa" to make more
	economical use of existing infrastructure, per a suggestion from
	Deri James.  This also puts the file where gropdf's "download"
	file can find it when running it in a separate build directory.
	We use it to generate "groff-man-pages.pdf".

	* font/devps/freeeuro.pfa: Rename this...
	* font/devps/freeeuro.ps: ...to this.  We can now use the suffix
	rule that also applies to "symbolsl.ps" and "zapfdr.ps".

	* font/devps/devps.am (DEVPSFONTFILES): Move "freeeuro.pfa" from
	here...
	(DEVPSFONTFILES_GENERATED): ...to here.
	(EXTRA_DIST): Ship the "new" "freeeuro.ps" file.

2022-11-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devps/psstrip.sed: Stop stripping comment lines in
	general instead of preserving only ones that use the form in the
	Document Structuring Conventions.  This way we won't strip
	copyright notices, like Werner Lemberg's in the FreeEuro font.
	Thanks to Deri James for pointing this out.

2022-11-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	tmac/an-ext.tmac: Refactor to reduce code size.

	* tmac/an-ext.tmac: Refactor to reduce code size.  `UE` and `ME`
	have nearly identical implementations so...

	(mQ): Define new macro to perform the requisite actions, and...

	(UE, ME): Make these into wrappers calling mQ.

2022-11-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Add unit tests for `MT/ME` and `UR/UE`.

	* tmac/tests/an-ext_MT-works.sh:
	* tmac/tests/an-ext_UR-works.sh: Do it.

	* tmac/tmac.am (tmac_TESTS): Run tests.

2022-11-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl: Throw warning if paper format is
	unrecognized.

2022-11-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (Msg): Align more closely with
	diagnostic message format prescribed by GNU Coding Standards:
	emit space (only) prior to message severity.

2022-11-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/meref.me.in: Drop unnecessary initialization parameters
	from document.  The line and title length do not need to be set
	in troff mode; the document lays out fine for a variety of paper
	formats if these are not forced to 6.5 inches.  Also drop
	redundant initialization of `pp` register.

2022-11-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Fix Savannah #63377.

	* tmac/doc.tmac (Nm): Properly leverage new
	`doc-in-name-section` variable.  Set page topic `doc-topic-name`
	to the first encountered argumentful `Nm` call in the "Name"
	section while handling other "Name" section concerns, instead of
	later after deciding we're not in the "Synopsis" section.
	Problem caused by me when fixing antediluvian mdoc bug in commit
	0d85615c62, 5 November.

	Fixes <https://savannah.gnu.org/bugs/?63377>.  Thanks to John
	Gardner for the report.

2022-11-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Add tests for `Nm` macro.

	* tmac/tests/doc_Nm-works.sh: Do it.  Test regression reported
	in Savannah #63377.  Also ensure that we handle the case where
	multiple `Nm` items are declared in the "Name" section (as might
	happen in library man pages).
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-11-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/papersize.tmac: Improve integration with mm(7) macro
	package.  If a paper format has been selected, set `W` register
	to new line length (if not already set on command line).
	Similarly, set `O` register to 1 inch for the symmetric
	horizontal margins otherwise assumed by this macro file.  This
	means that "groff -mm" and "groff -dpaper=letter -mm" are _not_
	synonymous (when groff is configured to use U.S. letter as the
	default paper format), because groff mm(7) uses a page offset of
	0.963 inches on typesetters for compatibility with DWB mm.
	* NEWS: Add item.

	See discussion in <https://lists.gnu.org/archive/html/\
	groff/2022-11/msg00081.html> and (some) follow-ups.

2022-11-16  Deri James  <deri@chuzzlewit.myzen.co.uk>

	* src/devices/gropdf/gropdf.pl: If the argument to the paper
	format option '-p' matches a recognized format but includes a
	trailing 'L' or 'l' ("legalL" or "a4l", for example), rotate the
	document's MediaBox.

2022-11-16  Deri James  <deri@chuzzlewit.myzen.co.uk>

	* src/devices/gropdf/gropdf.pl: Fix incorrect hotspot placement
	if page is in landscape orientation.
	(FixRect): Perform coordinate transform if page is rotated.
	(Rotate): New function performs relevant trigonometry.

	Fixes <https://savannah.gnu.org/bugs/?63380>.  Thanks to Blake
	McBride for the report.

2022-11-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac: Integrate better with papersize.tmac by no longer
	forcing line (and title) length to 6 inches for typesetters on
	initialization.  Gather default line length from output device
	description, possibly modified later (by other macro file or
	input).  No change to terminal ("nroff mode") output.
	* NEWS: Add item.

2022-11-16  Peter Schaffter <peter@schaffter.ca>

	* tmac/papersize.tmac: If a paper format has been selected,
	smuggle right margin setting to mom(7) if not overridden by the
	user.  See discussion in <https://lists.gnu.org/archive/html/\
	groff/2022-11/msg00081.html> and (some) follow-ups.

2022-11-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (doc/groff-man-pages.pdf)
	(doc/groff-man-pages.utf8.txt): Add dependencies on new
	`TMAC_PACKAGE_MAN` and `TMAC_PACKAGE_MDOC` convenience macros.

2022-11-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tmac.am (TMAC_PACKAGE_MAN, TMAC_PACKAGE_MDOC): Define
	convenience macros for in-tree documents to depend on.

2022-11-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Trivially refactor.  Rename `an-section` to
	`an*section`.

2022-11-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grolbp/lbp.cpp (usage): Tweak usage message.  The
	output driver should be perfectly capable of handling output
	from non-GNU (but device-independent) troffs.

2022-11-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grops/ps.cpp (usage): Employ more informative
	metasyntactic variable names in usage message.  Also summarize
	program's function and direct reader to man page if help
	explicitly requested (inferred from identity of output stream).

2022-11-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Trivially refactor for congruence with
	documentary terminology.  Rename strings and macros.
	- an-title                 -> an*topic
	- an-abbreviate-page-title -> an*abbreviate-page-topic
	- an-title-abbv            -> an*topic-abbv
	- an-title-string          -> an*topic-string
	- an-title-length          -> an*topic-length
	- an-title-length-prev     -> an*topic-length-prev
	- an-title-new-length      -> an*topic-new-length
	- an-page-title-style      -> an*topic-style
	(TH): Recast diagnostic message to refer to "section", not
	"volume" title.

2022-11-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Refactor to reduce code size.  `UR` and `MT`
	have identical implementations so...
	(mV): Define new macro to perform the requisite actions, and...
	(UR, MT): Make these into wrappers calling mV.

2022-11-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac (UR, MT): Fix problem with incorrect line
	lengths and occasional "can't adjust" warnings when using
	hyperlinks.  Reduce the line length within the diversion by the
	amount of indentation used in the context.  Without this, lines
	were getting set too short.  (You might think they'd be too
	long, but when creating a new environment, the _formatter's_
	default line length is used; that's 65n on terminal devices.)

2022-11-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Add test to ensure that link text (when the hyperlink
	itself is not formatted because the device supports
	hyperlinking) uses the correct line length and is adjusted.

	* tmac/tests/an_adjust-link-text-correctly.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run tests.

2022-11-11  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/devpdf.am: Refactor.
	(MOSTLYCLEANFILES): Populate macro incrementally, adjacent to
	the targets that build the files to be cleaned.  This will
	enable cleaner refactoring in the future.
	(DEFAULT_BASE35_FONTS): Add new macro storing the targets of the
	PostScript Level 2 standard base 35 font descriptions.
	(devpdffont_DATA): Populate using `DEFAULT_BASE35_FONTS`.
	(URW_BASE35_FONTS): Add new macro, empty if [!HAVE_URW_FONTS];
	and [HAVE_URW_FONTS] otherwise naming the `U` foundry font
	description counterparts of the `DEFAULT_BASE35_FONTS`.
	(devpdffont_DATA): Append `URW_BASE35_FONTS`.
	($(DEFAULT_BASE35_FONTS) $(URW_BASE35_FONTS)): Assert dependency
	on "font/devpdf/download".  This isn't literally true, but
	BuildFoundries generates all of these together, so if the
	"font/devpdf/download" target rule runs successfully, the font
	description files named in these macro expansions will be
	generated too.

2022-11-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.pl: Add new command-line option to
	specify the generated font description's "spacewidth" parameter;
	in commit bf7f6862c3, 2021-09-24, I made libgroff complain if
	this directive is missing (since any font, even a "special" one,
	can be selected as current and the formatter's behavior when
	encountering an input space should be well-defined under that
	circumstance).  Adding this option enables a well-formed font
	description to be produced.
	* src/utils/afmtodit/afmtodit.pl (usage):
	* src/utils/afmtodit/afmtodit.1.man (Synopsis, Options):
	Document it.
	* NEWS: Add item.

2022-11-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.pl: Use our own fatal exit
	function instead of Perl's "die".
	(croak): New subroutine emits argument as part of diagnostic
	message and exits with status 1.
	(usage): Exit with status 2, not 1, on usage errors.

	* NEWS: Document new exit behavior.

2022-11-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/devpdf.am (font/devpdf/download): Improve
	comprehensibility of comments in generated "download" file.
	Stop bracketing path element separator with spaces.

2022-11-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/util/BuildFoundries.pl (LoadFoundry): Stop
	capitalizing beginning of diagnostic message (per GNU Coding
	Standards).  Drop ellipsis from end since no further diagnostics
	relevant to that message are expected.  Trim trailing slashes
	from font path elements.

2022-11-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devps/devps.am: Refactor.  Turn two identical target
	rules into a (BSD-make-style, old-fashioned) pattern rule.

2022-11-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Rechristen self "GNU roff".

2022-11-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/pic/pic.ypp: Slightly refactor.  Rename parameter
	`form` (format) to `fmt` to make its nature as an abbreviation
	clear.
	(format_number, do_sprintf): Reorder null pointer equality
	comparisons to avoid inadvertent lvalue assignment.
	(do_sprintf): Declare lists of valid format conversion
	specifiers and modifiers explicitly instead of as happenstance
	literals.  Recast diagnostic messages to refer to "invalid", not
	"bad" input; refer to input keyword correctly as "sprintf" (not
	"snprintf"); and report the identity of the invalid conversion
	specifier we reject.

2022-11-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac (Fl, doc-flag-recursion, doc-print-recursive)
	(doc-print-prefixes, Ar, Nm, Pa, Xr, doc-do-func, Fn)
	(doc-do-func-args, Fo): Remove now-relic resets of type size to
	previous value.  Since commit 5125754cdf, 23 February, no mdoc
	macro ever changes the type size.

2022-11-08  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf]: Cater for invalid entries in download file.

	* src/devices/gropdf/gropdf.pl: Test if path in the "download"
	file points to a readable file.  Also change order so that the
	first valid entry is used as the font to embed.  This replaces
	previous order where last found entry is used.

	Fixes <https://savannah.gnu.org/bugs/?62950>.

2022-11-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Set page topic in roman in "Name" section.

	* tmac/doc.tmac (Nm): If in the "Name" section of the page, set
	argument(s) with the `No` (normal formatting) macro instead of
	handling them...normally.  Since `Nm`'s usual behavior is to set
	the next argument in boldface, in this circumstance it is set in
	roman.  Aligns page rendering with man(7) and fixes a bug
	documented in the 4.3BSD-Reno mdoc.samples(7) page (1990-06-22),
	upon which the groff_mdoc(7) page is based.
	* tmac/groff_mdoc.7.man (Bugs): De-document bug.

	Fixes part of <https://savannah.gnu.org/bugs/?62926>.

2022-11-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common: Add internal register
	`doc-in-name-section` to keep track of whether a macro is called
	within the "Name" section of the document, to prepare a means of
	fixing a long-standing bug with `Nm`.
	(Sh): Canonicalize capitalization of section heading sooner.
	Set or clear `doc-in-name-section` based on result.
	(Rd): Add new register to dump.
	* tmac/doc.tmac (doc-save-global-vars, doc-restore-global-vars):
	Handle new register.

2022-11-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Use font CR, not CB, for `Cm` ("command modifier") and
	`Fl` ("flag") macros on typesetters.

	* tmac/mdoc/doc-ditroff (doc-Cm-font, doc-Fl-Font): Switch to
	Courier roman from Courier bold.  This congrues better with
	other `Li` literals, which were not in boldface.

2022-11-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-nroff (doc-Li-Font): Switch from roman to bold.
	On typesetters, the use of Courier (roman) plainly distinguishes
	unquoted literals from their context.  On terminals there was no
	such visible distinction.  Fortunately, in groff_mdoc(7) itself,
	this does not result in a blinding blitz of boldface because the
	`Ql` (quoted literal) macro is so often used, and it maintains
	the roman style.  This change further aligns groff mdoc(7) with
	groff man(7) style conventions.  (Also see how we handle
	literals for typesetters and terminals in the "ms.ms" document.)

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Make `Sx` macro perform quotation, not italicization.
	It's thorougly inconsistent with English composition practices
	to refer to (sub)section headings within a document as if they
	were major works.

	* tmac/doc.tmac (Sx): Implement.
	* tmac/mdoc/doc-ditroff (doc-Sx-font):
	* tmac/mdoc/doc-nroff (doc-Sx-font): Delete.
	* tmac/groff_mdoc.7.man (Section Cross References): Rename...
	((Sub)section cross references): ...to this.  Recognize
	existence of `Ss` macro, curiously overlooked before.
	* NEWS: Add item.

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Drop now-unused `doc-pageref` string.  It was nowhere
	interpolated outside of state management macros.

	* tmac/doc.tmac (doc-save-global-vars, doc-restore-global-vars):
	* tmac/mdoc/doc-common: Do it.

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (doc-header, doc-footer): Revise for
	clarity and to use correct typefaces for titles.
	(doc-header): Add new strings to ease title construction.
	`doc-xref` stores the fully formatted page topic and section
	number, e.g., "troff(1)"; `doc-abbv` stores the its potentially
	abbreviated form when it is too long to fit.
	(doc-footer): Use `doc-xref` as above.  Stop setting the `Os`
	and `Dd` parameters in the ("semantic"?) font used for the
	page's section number (probably unnoticed all these years
	because the font used to render that was (Times) roman).

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac:
	* tmac/mdoc/doc-common: Rename strings for clarity.
	- doc-document-title -> doc-page-topic
	- doc-document-title-saved -> doc-page-topic-saved
	* tmac/mdoc/doc-common: Use new name.

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff (doc-page-topic-font):
	* tmac/mdoc/doc-nroff (doc-page-topic-font): Set man page topic
	names in italics.

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Rename strings for clarity.
	- doc-caption-font -> doc-page-topic-font
	- doc-caption-font2 -> doc-page-section-font
	* tmac/mdoc/doc-common (doc-header, doc-footer): Use new names.

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac: Delete suppression of `Pa` font selection in a
	"Files" section.  This special handling was not documented.

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff (doc-Pa-font): Set file specifications
	in italics on typesetters.  (Terminals already use italics.)

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff (doc-Xr-font):
	* tmac/mdoc/doc-nroff (doc-Xr-font): Set man page topic cross
	references in italics.

2022-11-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Rename `doc-Tn-font-shape` to
	`doc-Tn-font` for better parallelism with other font selection
	strings for mdoc macros, since the `Tn` macro no longer
	manipulates the type size.
	* tmac/doc.tmac (Tn): Use new name.

2022-11-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Debugging): Fix misleading claim.  The
	arguments to the `tm`, `tmc`, and `tm1` requests are not read in
	copy mode.  For example, you don't need to double backslashes to
	get them to interpolate registers or strings.

2022-11-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (an-end):
	* tmac/mdoc/doc-common (doc-end-macro): Ensure that document
	footer appears in continuous rendering mode even when a final
	pending output line in the document is 1v from the page bottom.
	Replace `fl` call with `br`, which IMO has clearer semantics.
	Extend page length by 1v before doing so if the current vertical
	position is within 1v of the page bottom.

	Thanks to Alex Colomar for the report.

2022-11-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man, mdoc]: Regression-test special case of continuous
	rendering when the last pending output line in the document is
	1v from the (notional) page bottom.

	* tmac/tests/an_output-footer-when-continuously-rendering.sh:
	* tmac/tests/doc_output-footer-when-continuously-rendering.sh:
	Do it.
	* tmac/tmac.am (tmac_TESTS): Run tests.

2022-11-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (TE): Update diagnostic to mention another
	failure mode: a man page that is simply a `so` request requires
	soelim(1) to be run if the sourced page uses tbl(1).

2022-11-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/xditview/xditview.am
	($(GXDITVIEW_GROFF_VERSION_H)): Run `$(MKDIR_P)` and `printf` as
	separate rule commands in order to use them with `$(AM_V_at)`
	and `$(AM_V_GEN)`, respectively.  Prevents noise from build.

	Fixes <https://savannah.gnu.org/bugs/?63302>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-10-31  G. Branden Robinson <g.branden.robinson@gmail.com>

	[eqn]: Fix Savannah #63299.

	* src/preproc/eqn/main.cpp: Revise input file line number
	handling.
	(read_line): Stop dealing with `current_lineno` here; it's now
	up to its caller (`do_file()`) to manipulate the line number.
	(do_file): When reading new file, initialize `current_lineno` to
	1 instead of 0.  Reset it to zero when encountering EOF (so that
	diagnostics will not include a line number at all).  When
	performing nested call to `read_line()` to gather '.EN' from
	input, increment the line number.  Write correct line number in
	output groff `lf` requests; in groff, its first argument assigns
	the number of the _next_ input line.  Increment line number at
	end of outer `read_line()` loop.

	Fixes <https://savannah.gnu.org/bugs/?63299>.  Thanks to Alex
	Colomar for the report.

2022-10-31  G. Branden Robinson <g.branden.robinson@gmail.com>

	[eqn]: Regression-test Savannah #63299.

	* src/preproc/eqn/tests/\
	diagnostics-report-correct-line-numbers.sh: Do it.
	* src/preproc/eqn/eqn.am (eqn_TESTS, TESTS, EXTRA_DIST): Run
	test.

2022-10-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/grog/grog.pl (fail, warn, construct_command)
	(version): Restore trailing newlines to `print`ed output.  They
	went missing when I removed the assignment of the output record
	separator in commit 6f2e367836, 24 October.  Thanks to Dave
	Kemper for catching this.

2022-10-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/preconv/preconv.cpp: Trivially refactor.  Rename
	`default_encoding` to `fallback_encoding` for clarity.  Update
	comments and debugging diagnostic messages accordingly.

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[grolj4]: Absorb lj4_font(5) man page into grolj4(1).

	* src/devices/grolj4/lj4_font.5.man: Delete, moving content...
	* src/devices/grolj4/grolj4.1.man (Fonts): ...hither.

	* doc/doc.am (GROFF_MAN_PAGES1):
	* src/devices/grolj4/grolj4.am (man5_MANS, EXTRA_DIST): Stop
	formatting and shipping removed page.

	* src/roff/groff/groff.1.man:
	* src/utils/hpftodit/hpftodit.1.man: Drop references to page.

	Fixes <https://savannah.gnu.org/bugs/?61819>.

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `SN` register to configure subsection heading
	indentation.

	* tmac/doc.tmac: Recognize `SN` register if set on command line
	and use groff man(7)-compatible default if it is not.
	* tmac/mdoc/doc-common (Ss): Use this register instead of a
	literal.
	* tmac/groff_mdoc.7.man (Formatting with groff, troff, and
	nroff): Document it.
	* NEWS: Update item.

	Fixes part of <https://savannah.gnu.org/bugs/?62926>.

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `IN` register to configure paragraph
	indentation.

	* tmac/doc.tmac: Recognize `IN` register if set on command line
	and use groff man(7)-compatible defaults if it is not.
	* tmac/mdoc/doc-common (Sh): Use this register instead of
	`doc-paragraph-indentation`.
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Stop setting pargraph indentation
	defaults here.
	* tmac/groff_mdoc.7.man (Formatting with groff, troff, and
	nroff): Document it.
	* NEWS: Update item.

	* tmac/tests/doc_Mt-works.sh:
	* tmac/tests/doc_indents-correctly.sh: Update test expectations.

	Fixes part of <https://savannah.gnu.org/bugs/?62926>.

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (Sh): Fix code style nit.  Set paragraph
	indentation absolutely rather than incrementally.  mdoc(7)
	doesn't have relative inset macros like man(7)'s `RS`/`RE`, so
	the relative measurement could mislead the reader.  (The
	section heading itself uses an indentation of 0.)

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Fix Debian #1022179.

	* tmac/mdoc/doc-common (Ss): Indent entire subsection heading by
	3 ens, even if it breaks across output lines.  (Change and
	restore indentation explicitly instead of using a temporary
	indent to achieve this.  Also indent absolutely by 3n instead of
	retreating by one quarter inch.)

	Fixes <https://bugs.debian.org/1022179>.  Thanks to наб for the
	report.

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/doc_indents-correctly.sh: Add regression test for
	Debian #1022179.

	* tmac/tmac.am (tmac_TESTS): Run test.

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Fix misleading register name.

	* tmac/mdoc/doc-common (Sh):
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Rename `doc-subheader-indent` to
	`doc-paragraph-indentation`, because the latter is what it's
	used for.

2022-10-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_POPPLER): Improve shell code portability.
	Per the GNU Autoconf manual, "The -a, -o, '(', and ')' operands
	are not present in all implementations, and have been marked
	obsolete by Posix 2008.  ...portable uses of test should never
	have more than four arguments, and scripts should use shell
	constructs like '&&' and '||' instead."

2022-10-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/preconv/preconv.cpp: Alter usage message handling.
	(usage): Summarize purpose of program and steer reader to man
	page (only) if help was explicitly requested, and exit
	successfully from here...
	(main): ...instead of calling scope.

2022-10-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/preconv/preconv.cpp (usage): Use more
	communicative metasyntactic variable names.
	* src/preproc/preconv/preconv.1.man (Synopsis, Options): Align
	with updated usage message.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp: Alter usage message handling.
	(usage): Summarize purpose of program and steer reader to man
	page (only) if help was explicitly requested, and exit
	successfully from here...
	(main): ...instead of calling scope.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grolbp/lbp.cpp: Alter usage message handling.
	(usage): Summarize purpose of program and steer reader to man
	page (only) if help was explicitly requested, and exit
	successfully from here...
	(main): ...instead of calling scope.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grolbp/lbp.cpp (main): Handle `getopt_long()`
	return value more idiomatically.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grolbp/lbp.cpp: Fix code style nits.
	(main): Use standard C library symbols `EXIT_SUCCESS` and
	`EXIT_FAILURE` instead of integer literals as arguments to
	`exit()`.  Add assertion.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grotty/tty.cpp: Alter usage message handling.
	(usage): Summarize purpose of program and steer reader to man
	page (only) if help was explicitly requested, and exit
	successfully from here...
	(main): ...instead of calling scope.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grotty/tty.cpp: Fix code style nits.
	(main): Use standard C library symbols `EXIT_SUCCESS` and
	`EXIT_FAILURE` instead of integer literals as arguments to
	`exit()`.  Replace `assert(0)` call with communicative
	predicate.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp: Alter usage message handling.
	(synopsis, help): Coalesce these two functions...
	(usage): ...into this one.  Summarize purpose of program and
	steer reader to man page only if help was explicitly requested,
	rather than blitzing user with text upon a usage error.  Also
	drop option summary from usage message, as it duplicates
	groff(1).

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/grog/grog.pl: Alter usage message handling.
	(help): Rename this subroutine...
	(usage): ...to this.  Summarize purpose of program and steer
	reader to man page only if help was explicitly requested, rather
	than blitzing user with text upon a usage error.  Also drop
	option summary from usage message, as it duplicates grog(1).

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/grog/grog.pl: Drop relic code and comments.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[grog]: Migrate expansion of Perl interpreter in shebang.
	Use the same technique as afmtodit, mmroff, gropdf, and pdfmom.

	* src/utils/grog/grog.am (grog): Replace "@PERL@" instead of
	'^\(#! \).*perl'.
	* src/utils/grog/grog.pl: Use "@PERL@" in shebang.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[afmtodit]: Give program a usage message.

	* src/utils/afmtodit/afmtodit.pl: Add new scalar `want_help` of
	Boolean sense.  Recognize new long option `--help`, attached to
	`$want_help`.  Stop stripping off directory name components from
	program name when emitting diagnostics.  No other groff program
	does this (well, gropdf did until recently), and it might save
	users some confusion if they're working with multiple copies of
	afmtodit.
	(usage): New subroutine reports usage message.  If help was
	explicitly requested, summarize purpose of program and steer
	reader to man page.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[afmtodit]: Migrate expansion of Perl interpreter in shebang.
	Use the same technique as mmroff, gropdf, and pdfmom.

	* src/utils/afmtodit/afmtodit.am (afmtodit): Replace "@PERL@"
	instead of "/usr/bin/perl".
	* src/utils/afmtodit/afmtodit.pl: Use "@PERL@" in shebang.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[gropdf] Give program a usage message.

	* src/devices/gropdf/gropdf.pl: Add new scalar `want_help` of
	Boolean sense.  Recognize new long option `--help`, attached to
	`$want_help`.
	(usage): New subroutine reports usage message.  If help was
	explicitly requested, summarize purpose of program and steer
	reader to man page.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/xditview/xditview.c (Syntax): "#if 0" out
	reference to `-noPolyText` option, whose effect is likewise
	bracketed in another file.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (enable_warning, disable_warning):
	Recast diagnostic messages for clarity.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[pfbtops]: Fix code style and diagnostic nits.

	* src/utils/pfbtops/pfbtops.c (error): Exit with `EXIT_FAILURE`
	status (from standard C library) instead of status 2.
	(main): Exit with `EXIT_SUCCESS` status when writing version or
	help information.  Exit with status 2 when dying due to usage
	error.  Use `fprintf()` and `strerror()` to construct error
	message when dying due to inability to open input file instead
	of using `perror()`, which anonymizes its caller and thus should
	never be used in serious work.  Avoid it like `gets()`.
	* NEWS: Add item for exit status changes.

	Continues the long process of fixing Savannah #52463.

2022-10-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man pages]: Don't document macro package compatibility wrapper
	directory if it's not used.

	* Makefile.am (.man): Use sed to replace
	'@COMPATIBILITY_WRAPPERS@' in man page text with value of
	`compatibility_wrappers` shell variable.  Document its purpose.
	* src/preproc/eqn/eqn.1.man (Description):
	* src/preproc/grn/grn.1.man (Options):
	* src/roff/groff/groff.1.man (Installation directories):
	* src/roff/troff/troff.1.man (Environment): Mention
	`@SYSTEMMACRODIR@` only if `@COMPATIBILITY_WRAPPERS@` expands to
	something other than "no" (it could be "yes" or "manual").

	Thanks to Alexander Kanavin and Jeremy Puhlman for the report.

2022-10-21  Robert Yang <liezhi.yang@windriver.com>

	* font/devpdf/util/BuildFoundries.pl:
	* src/devices/gropdf/gropdf.pl:
	* src/devices/gropdf/pdfmom.pl: Replace use of '-w' in shebang
	line with "use warnings;".

2022-10-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/fallbacks.tmac: Define fallback characters for many code
	points from the Unicode General Punctuation Block.  This is to
	ease migration from other documentation formats; in many cases
	there are more idiomatic *roff ways of getting results that
	typeset better and are amenable to fine tuning.  For instance,
	Unicode defines spaces and dashes of various discrete widths;
	when typesetting with *roff, you can have a space or dash (among
	other things) of any length achievable by the output device.
	* tmac/ps.tmac: Migrate non-breaking hyphen fallback character
	definition from here to the foregoing.

	Fixes <https://savannah.gnu.org/?58930>.  Thanks to Dave Kemper
	for the report and discussion.

2022-10-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac:
	* tmac/s.tmac: Escape newlines when opening conditional blocks.

	Fixes <https://savannah.gnu.org/?63197>.  Thanks to Bjarni Ingi
	Gislason for the report and Dave Kemper for the quick fix.

2022-10-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grodvi/dvi.cpp (usage):
	* src/devices/grohtml/post-html.cpp (usage):
	* src/devices/grolbp/lbp.cpp (usage):
	* src/devices/grolj4/lj4.cpp (usage):
	* src/devices/grops/ps.cpp (usage):
	* src/devices/grotty/tty.cpp (usage):
	* src/devices/xditview/xditview.cpp (usage):
	* src/preproc/eqn/main.cpp (usage):
	* src/preproc/grn/main.cpp (usage):
	* src/preproc/html/pre-html.cpp (usage):
	* src/preproc/pic/main.cpp (usage):
	* src/preproc/preconv/preconv.cpp (usage):
	* src/preproc/refer/refer.cpp (usage):
	* src/preproc/soelim/soelim.cpp (usage):
	* src/preproc/tbl/main.cpp (usage):
	* src/roff/groff/groff.cpp (synopsis, help):
	* src/roff/nroff/nroff.sh:
	* src/roff/troff/input.cpp (usage):
	* src/utils/addftinfo/addftinfo.cpp (usage):
	* src/utils/hpftodit/hpftodit.cpp (usage):
	* src/utils/indxbib/indxbib.cpp (usage):
	* src/utils/lkbib/lkbib.cpp (usage):
	* src/utils/lookbib/lookbib.cpp (usage):
	* src/utils/pfbtops/pfbtops.c (usage):
	* src/utils/tfmtodit/tfmtodit.cpp (usage):
	* src/utils/xtotroff/xtotroff.c (usage): Update usage message.
	Present different modes of operation on separate output lines.
	Sort options in English lexicographic order.  Document help
	option(s) as last mode of operation.

2022-10-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl: Revise handling of argument 0.
	Rename scalar `progname` to `prog` for brevity (and preparation
	for writing a usage message).  Also stop stripping off directory
	name components from it.  No other groff program does this, and
	it might save users some confusion if they're working with
	multiple copies of gropdf.

2022-10-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	Migrate terminology from "paper size" to "paper format" or
	"paper dimensions" as appropriate in documentation and
	diagnostic messages.  "Format" implies an orientation (which can
	be overridden in many cases) whereas size does not.  When only
	the magnitudes of measurements are at issue (mainly for internal
	purposes), use the term "dimensions".

	* NEWS:
	* PROBLEMS:
	* doc/groff.texi:
	* m4/groff.m4 (GROFF_PAGE):
	* man/groff_font.5.man:
	* man/groff_tmac.5.man:
	* src/devices/grodvi/dvi.cpp (main):
	* src/devices/grolbp/grolbp.1.man:
	* src/devices/grolbp/lbp.cpp (main):
	* src/devices/grolj4/grolj4.1.man:
	* src/devices/grolj4/lj4.cpp (lj4_printer::lj4_printer, main):
	* src/devices/grolj4/lj4_font.5.man:
	* src/devices/gropdf/gropdf.1.man:
	* src/devices/grops/grops.1.man:
	* src/devices/grops/ps.cpp (main):
	* src/roff/groff/groff.1.man:
	* tmac/papersize.tmac: Do it.

2022-10-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff (doc-left-parenthesis)
	(doc-right-parenthesis, doc-left-bracket, doc-right-bracket):
	Drop thin and hair space escape sequences from these string
	definitions.  (Also, doc-right-bracket was inconsistent with
	doc-left-bracket, the former inserting horizontal motion only
	before the bracket character.)  Eliminates excess space when
	using Pq, Po, Pc and Bq, Bo, Bc macros and formatting for
	typesetters, and aligns output with behavior of `Pq` and `Bq` as
	documented in groff_mdoc(7).

	Fixes <https://bugs.debian.org/1021795>.  Thanks to наб for the
	report.

2022-10-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff: Use groff-canonical typeface names in
	font selection escape sequences.  Migrate 'C' to 'CR' and 'CO'
	to 'CI'.  (Admittedly, "Courier oblique" is more pedantically
	correct than "Courier italic".  But the iron ball of Unix troff
	history and its style trio [later quartet] of "R", "I", "B"
	{then "BI"} will not be ignored.)

2022-10-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff: Drop nilpotent type size escape
	sequences from string definitions.

2022-10-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	Document a CSTR #54 erratum regarding \n(st and \n(sb.

	* doc/groff.texi (Page Motions):
	* man/groff.7.man (Writable registers):
	* man/groff_diff.7.man (New registers): Do it.

	* PROBLEMS: Further clarify.  Note DWB and Heirloom behavior.

2022-10-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/main.cpp (read_line): Fix switched test
	consequents when updating `current_lineno`.

2022-10-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/xtotroff/xtotroff.c (main): Annotate "xtotroff" as a
	GNU program in version information.

2022-10-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/xditview/xditview.am
	($(GXDITVIEW_GROFF_VERSION_H): Perform correct substitution to
	get groff version string into `Version_string` C symbol.
	Continues commit c73decb58f, 9 October.

2022-10-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.1.man (Files): Fix ordering error.

	Fixes <https://savannah.gnu.org/bugs/?63228>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-10-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/lex.cpp (get_delimited_text): Clear line
	number when hitting EOF.
	* src/preproc/eqn/main.cpp: Revise end-of-file handling.  Clear
	line number upon reaching EOF so that we don't report a nonsense
	value one greater than the number of lines in the input file.
	(read_line): Boolify.  Make static (local linkage only), since
	it has no external callers.  Introduce new Boolean variable
	`is_end_of_file`.  Clear `current_lineno` if EOF, and increment
	it otherwise.
	(do_file, main): Clarify diagnostic messages.

2022-10-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[eqn]: Improve diagnostics involving unprintable characters.

	* src/preproc/eqn/main.cpp (input_char_description): New
	function constructs a human-readable string describing
	characters.
	(read_line, inline_equation, main): Call new function and adjust
	diagnostic message wording to accommodate the phrase it returns.

	Fixes <https://savannah.gnu.org/bugs/?63218>.

2022-10-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[eqn]: Improve diagnostics.

	* src/preproc/eqn/lex.cpp (file_input::~file_input):
	* src/preproc/eqn/main.cpp (main): Die if `fclose()` fails and
	report underlying system error.
	(inline_equation): Identify inline equation context.

2022-10-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac (2c, 1c): Throw diagnostic if changing columnation
	with a footnote pending.  This isn't necessarily an error per
	se, but in many cases it will flag an undesirable page layout
	due to the limited flexibility of me(7)'s footnote support at
	present.  See <https://savannah.gnu.org/bugs/?63176>.

2022-10-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/main.cpp: Fix code style nits.
	(usage): Align output with man page.  Document separate
	invocation modes separately.
	(main): Use standard C library symbols `EXIT_SUCCESS` and
	`EXIT_FAILURE` with `exit()` calls instead of integer literals.
	Replace `assert(0)` call with communicative predicate.  Check
	return value of `fclose()`, and exit with fatal error if it
	fails.  Distinguish `ferror()` status and `fflush(stdout)`
	failures when cleaning up before exit.

2022-10-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (read_color_draw_node): Clarify
	diagnostic.

2022-10-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/dvi.tmac: Always render \[aq] as a neutral apostrophe.
	Thanks to the TC fonts, we can do this even when the default CM
	text fonts are in use.

	Fixes <https://savannah.gnu.org/bugs/?63200>.

2022-10-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/ec.tmac: Remove apparently unnecessary remappings of
	styles (and reassertion of style slots in the font mounting
	position list, albeit in an unusual order (RBI instead of RIB)).
	This code frustrated the rendering of man pages with post-1.22.4
	groff for the 'dvi' output device when using EC fonts.  Instead
	remap the T and H family typefaces in all four styles
	explicitly.  (The CW and CWI faces were already handled.)  Also
	add remappings of groff+PostScriptish font names "CB" and "CBI"
	to CW EC faces of normal weight, corresponding to dvi.tmac; see
	commits 529e2ca0c4, 2002-03-23 and c9741da6c0, 2021-05-06.

	Fixes <https://savannah.gnu.org/bugs/?63194>.

2022-10-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/an_works-with-ec.sh: Add regression test for
	Savannah #63194.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-10-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/ec_works.sh: Add unit test to validate use of EC
	fonts when "-mec" option given.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-10-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/latin2.tmac:
	* tmac/latin5.tmac:
	* tmac/latin9.tmac: Perform the character remapping shenanigans
	of the fix for Savannah #63112 only if the output device is
	"latin1" (a terminal using an 8-bit character encoding).  Only
	then can we be sure that Latin-1 glyphs will be unavailable when
	other encodings are used and that `\N` escape sequences will
	identify correct glyph indices in a font (because there is no
	font per se accessible to groff--simply a terminal implementing
	a character encoding).

2022-10-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (GetType1): Clarify diagnostic.
	When failing to open a font file for embedding in a PDF, mention
	this context.

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.tables: Update against Unicode 15.
	No substantive changes.

	Fixes <https://savannah.gnu.org/bugs/?63188>.

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: If URW fonts were located, add the directory
	where they were found to the configuration report.

	Attempts to fix <https://savannah.gnu.org/bugs/?62860> (2/2).

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4: Try to make gropdf's search for URW font files
	more deterministic.  To disambiguate cases where multiple--not
	necessarily identical--copies may be found on the system, search
	_only_ in the directory given to the `--with-urw-fonts-dir`
	configure option, if present.  This populates the "Foundry" file
	generated by the build, causing gropdf to search there first.
	(GROFF_URW_FONTS_PATH): Stop `AC_SUBST`ing `urwfontsdir` here.
	(GROFF_URW_FONTS_CHECK): `AC_REQUIRE` `GROFF_URW_FONTS_PATH` to
	be run first.  If `urwfontsdir` is not null, search only there
	for URW fonts.  Assign `urwfontsdir` the value of the directory
	in which the fonts are found.  Assign it an empty value if none
	are found.  Either way, `AC_SUBST` the variable.

	Attempts to fix <https://savannah.gnu.org/bugs/?62860> (1/2).

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (LoadFont): Clarify diagnostic.
	gropdf opens "fonts" in two distinct ways.  On the one hand, it
	opens groff font description files for essentially all
	nontrivial output.  On the other, it may open actual Type 1 font
	files for embedding in a PDF.  Make failure of the former case
	less confusable with the latter.

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Document new XN/XH and related macros.

	* doc/groff.texi (Creating a table of contents):
	* doc/ms.ms (Creating a table of contents):
	* tmac/groff_ms.7.man (Creating a table of contents): Do it.

	Fixes <https://savannah.gnu.org/bugs/?63110>.

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[gxditview]: Support `-version`, `--version` option.  As a C
	program, gxditview had no access to the (C++) libgroff
	`Version_string` symbol, so construct a header file to store
	this datum at build time.  If groff gets other user-facing C
	programs, we should consider generating this header in
	src/include instead.

	* src/devices/xditview/xditview.am: Generate "groff_version.h"
	file.
	(GXDITVIEW_GROFF_VERSION_H): Define new macro.
	($(GXDITVIEW_GROFF_VERSION_H)): Define target to generate file.
	(XDITVIEW_GENHDRS): Add $(GXDITVIEW_GROFF_VERSION_H).

	* src/devices/xditview/xditview.c: Include new header file.
	(Syntax): Report newly supported options.
	(main): Recognize and handle new options.

	* src/devices/xditview/gxditview.1.man (Synopsis): Document
	them.

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[gxditview]: Update usage message production and contents.

	* src/devices/xditview/xditview.c: Use C99 Boolean type.
	(Syntax): Accept additional Boolean argument indicating whether
	the usage message is to be issued due to an error.  Write
	message to stderr if so, and stdout otherwise.  Stop presuming
	length of output line; guessing where to wrap is unreliable due
	to variable terminal width and length of argv[0].  Write one
	line per invocation mode of the program.  Stop duplicatively
	documenting standard X Toolkit options.  Exit with standard C
	library `EXIT_FAILURE` status if there was an error, and
	`EXIT_SUCCESS` otherwise.
	(main): Refactor to prepare for `--version` support.

	* src/devices/xditview/gxditview.1.man (Synopsis): Sync list of
	options with usage message.

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.pl: Recognize "--version" as
	synonym for "-v".  To achieve this, use Getopt::Long instead of
	Getopt::Std.
	* src/utils/afmtodit/afmtodit.1.man (Synopsis, Options):
	Document it.

2022-10-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/pdfmom.pl: Recognize "--version" as synonym
	for "-v".
	* src/devices/gropdf/pdfmom.1.man (Synopsis, Description):
	Document it.

2022-10-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/grog/grog.pl (version): Identify as a GNU program.

2022-10-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grolj4/grolj4.1.man (Typefaces): Add new
	subsection.

	Fixes <https://savannah.gnu.org/bugs/?60929>.  Thanks to T. Kurt
	Bond for the report.

2022-10-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/meref.me.in (Columnated Output): Document persistence of
	`$s` register value across columnation mode changes.

	Fixes <https://savannah.gnu.org/bugs/?62717>.  Thanks to Dave
	Kemper for the report.

2022-10-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/meref.me.in: Annotate empty default arguments more
	consistently.

	Fixes <https://savannah.gnu.org/bugs/?62801>.  Thanks to Dave
	Kemper for the report.

2022-10-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/meref.me.in: Fix documentation error.
	(Summary) <\_>: Describe as "underrule", not "underscore".
	These are distinct: the latter is a glyph; the former is drawn
	by typesetters and rendered with SGR attributes on terminals.

2022-10-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* NEWS: Advise users of changes to "name" directive handling in
	font description files.

	Fixes <https://savannah.gnu.org/bugs/?61423>.  Thanks to Dave
	Kemper for the report.

2022-10-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/number.cpp: Refactor and fix code style nits.
	Boolify and rename static (local) functions.
	- parse_expr   -> is_valid_expression
	- start_number -> is_valid_expression_start
	- parse_term   -> is_valid_term
	Rename preprocessor macro `SCALE_INDICATOR_CHARS` to
	`SCALING_UNITS`.
	(is_valid_expression, is_valid_term): Rename parameters and
	demote them from `int` to `bool`.
	- scaling_indicator -> scaling_unit (no demotion)
	- parenthesised     -> is_parenthesized
	- rigid             -> is_mandatory
	(is_valid_expression_start, is_valid_expression, is_valid_term):
	Return Boolean rather than integer literals.
	(get_vunits, get_hunits, get_number_rigidly, get_number)
	(get_integer): Update call sites of renamed functions.  Replace
	Boolean-valued integer literals used as Booleans with Boolean
	literals and annotate their purposes.  (See <https://\
	stackoverflow.com/questions/38076786/\
	why-doesnt-c-support-named-parameters>.)
	(get_vunits, get_hunits, get_number, get_integer): Replace `0`
	in assertions with a communicative predicate.  In all of these
	it's an unhandled `switch()` case.

2022-10-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (do_expr_test, do_zero_width): Use
	better terminology in diagnostic messages.

2022-10-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Fix Savannah #63151.

	* src/roff/troff/input.cpp (read_draw_node): Throw "delim"
	warning diagnostic when a drawing escape sequence ends the line
	without a closing delimiter.

	Fixes <https://savannah.gnu.org/bugs/?63151>.

2022-10-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/fallbacks.tmac: Define fallbacks for characters in ISO
	Latin-{2,5,9} but not in Latin-1.

	Fixes <https://bugs.debian.org/782903>.  Thanks to Rafal Pietrak
	for the report.

2022-10-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Fix Savannah #63149.

	* src/roff/troff/reg.cpp (alter_format): Throw comprehensible
	diagnostic when input delete character encountered in register
	format.

	Fixes <https://savannah.gnu.org/bugs/?63149>.

2022-10-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Describe an input delete character comprehensibly.

	* src/roff/troff/input.cpp (token::description): The delete
	character (ISO 127 decimal, EBCDIC 7) is a valid `TOKEN_CHAR`
	but is not printable.  Don't attempt to output it literally in
	diagnostics; describe it in a phrase instead.

2022-10-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Apply consistent terminology.

	* src/roff/troff/input.cpp: Rename functions to better align
	with our documentation, and decouple their names from an
	assumption of diagnostic severity.  Also give them imperative
	names since they are called for their side effects, not their
	return values.
	- empty_name_warning -> diagnose_missing_identifier
	- non_empty_name_warning -> diagnose_invalid_identifier
	(diagnose_missing_identifier): Refer to absent operand as
	"identifier", not "name", in diagnostic messages since the
	latter (strictly) refers to the request/macro/string/diversion
	name space, and this function is also used to gather register
	identifiers.

2022-10-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tmac]: Fix Savannah #63112 (3/3).

	* tmac/latin2.tmac: Replace characters that ISO Latin-1 has but
	Latin-2 doesn't.  Map characters that ISO Latin-2 has and
	Latin-1 doesn't to their numeric code points.

2022-10-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tmac]: Regression-test Savannah #63112 (3/3).

	* tmac/tests/latin2_works: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-10-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tmac]: Fix Savannah #63112 (2/3).

	* tmac/latin5.tmac: Replace characters that ISO Latin-1 has but
	Latin-5 doesn't.  Map characters that ISO Latin-5 has and
	Latin-1 doesn't to their numeric code points.

2022-10-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tmac]: Regression-test Savannah #63112 (2/3).

	* tmac/tests/latin5_works: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-10-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tmac]: Fix Savannah #63112 (1/3).

	* tmac/latin9.tmac: Replace characters that ISO Latin-1 has but
	Latin-9 doesn't.  Map characters that ISO Latin-9 has and
	Latin-1 doesn't to their numeric code points.

2022-10-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tmac]: Regression-test Savannah #63112 (1/3).

	* tmac/tests/latin9_works: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-10-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp: Refactor to parallelize logic in
	similar routines; namely, those handling escape sequences that
	accept newlines as argument delimiters.

2022-10-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp: Fix inconsistencies in handling of
	escape sequences that accept newlines as delimiters.  Some threw
	spurious warnings as in Savannah #63011; others failed to treat
	a newline-terminated escape sequence also as the ending of an
	input line.
	(do_name_test, do_zero_width): Suppress spurious warning.
	(do_zero_width, do_width, do_special): Synthesize newline to
	terminate input line.

2022-10-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/tests/\
	some_escapes_accept_newline_delimiters.sh: Add test cases for
	`\A` and test formatted output of escape sequences, not just the
	absence of diagnostics from permitted use of newlines as
	argument delimiters.

2022-09-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/libs/libdriver/input.cpp (do_file): Make use of
	positioning commands before the first page is started fatal
	errors; they suggest ill-formed input.  The 'p' command
	clobbers the vertical position anyway.  (See
	https://bugs.debian.org/421437 for discussion.)

2022-09-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/pdf.tmac: Add inclusion guard; if a `pdfmark` macro is
	already defined, skip inclusion of this file.  Unfortunately
	there are multiple name collisions with pdfmark.tmac.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp:
	* src/roff/troff/request.h: Trivially refactor.  Boolify
	`interpolate_macro` and `request::invoke`.  Also rename
	parameter `no_next` to `do_not_want_next_token`, exposing
	potentially confusing interface design.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (spring_trap, interpolate_string)
	(interpolate_string_with_args): Improve error diagnostics: when
	a sprung trap or an interpolation fails because it's being
	attempted on a request, say so explicitly and _name_ it.  If the
	argument to the trap-planting request or to a string
	interpolation escape sequence is itself an interpolation, this
	name might not be obvious.  Consider:
	  .wh \n[pos] \*[mac]
	  .em \*[mac]
	  .itc 1 \*[mac]
	  \*[\*[mac]]
	Supplying this information requires no additional overhead.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (interpolate_string): Trivially
	refactor.  Rename function parameter from `s` to `nm` to more
	obviously align with `interpolate_string_with_args()`.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (do_zero_width, token::description)
	(interpolate_string, interpolate_string_with_args)
	(token::get_char): Revise diagnostic messages to stop presuming
	the identity of the escape character.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (set_escape_char): Recast error
	message to describe attempted operation and tell the user what
	we're doing about being instructed to use an invalid escape
	character.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (read_size): Be more helpful to
	ambiguous type size escape sequence users; offer advice in
	terms of the current escape character.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp (main): Fix SEGV when exiting
	gxditview.  The `postdriver` pointer always referred to
	allocated memory except when the `-X` option was given; it was
	then assigned the address of a #defined string literal.  It was
	thus statically allocated and an error to attempt to `free()`
	it.  Duplicate the string on the heap instead so that we can
	clean up uniformly regardless of postprocessor.  Problem caused
	by me when introducing `xexit()` in commit 6769e56aab, 20 June.

2022-09-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac (@o, n2, sk (f, ++): Consistently call `@err`
	macro with `do`.

2022-09-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac: Initialize new register `_f`, the value of `$m`
	{column count} of the previous pending footnote, to zero,
	meaning there is no previous pending footnote.
	(@o): Emit diagnostic when flushing footnotes into a different
	column layout than the pending footnote last added.  Set `_f` to
	zero.
	((f): Emit diagnostic when enqueueing footnote using a different
	column layout than the previous pending footnote used.  Set `_f`
	to `$m`.

	Fixes <https://savannah.gnu.org/bugs/?58736>.  Thanks to Dave
	Kemper for the report and discussion.

2022-09-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac: Explicitly initialize and annotate internal
	register `?f`.

2022-09-08  Nikita Ivanov <nikita.vyach.ivanov@gmail.com>

	* tmac/ps.tmac: Fallback definitions for glyphs that usually
	come from special fonts should use `schar` instead of `fchar`.
	{Define fallback special characters using `schar` instead of
	`fchar` for glyphs that we do not expect to find in text fonts;
	that is, they don't have bold, italic, and bold-italic stylistic
	variants.  This means all special character definitions in the
	file except for rules, ligatures, and digraphs.  Problem dates
	back to a series of commits from March 2002 to February 2003,
	straddling the introduction of the `schar` request in November
	2002. --GBR}

	Fixes <https://savannah.gnu.org/bugs/?62955>.

2022-09-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Slightly simplify new `XN` macro feature to align it more
	closely with Berkeley TOC macro behavior; don't prepend the
	table of contents entry with the section number (`\*[SN]`).  If
	desired, a document can define `XN-REPLACEMENT`.  This does not
	regress "pdfmark.ms" because it uses an alternative, older
	implementation of these features from "spdf.tmac".

	* tmac/s.tmac (XH-UPDATE-TOC): Update comments.
	(XN-REPLACEMENT): Do it.

2022-09-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/pdf.tmac (pdf*href-I): Call `pdf:error` macro by its
	correct name.  Both this macro file and
	contrib/pdfmark/pdfmark.tmac seem to want to use the 'pdf'
	prefix for their macro names, with much confusing overlap.
	Problem dates back to commit 87046b2948, 2011-07-26.

2022-09-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_URW_FONTS_CHECK): If Ghostscript or awk are
	unavailable, skip only the prepopulation of the URW font search
	path instead of the entire check.  This way we still locate the
	URW fonts if they are in one of several standard locations.

	Fixes <https://savannah.gnu.org/bugs/?62775>.

2022-09-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Trivially refactor.

	* src/roff/troff/input.cpp (do_name_test): Boolify and rename
	local variables to..."impredicate" their names.
	  - bad_char -> got_bad_char
	  - some_char -> got_some_char

2022-09-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	[grodvi, ...]: Trivially refactor.

	Tidy up #includes of the "assert.h" header, which we locally
	provide to ensure a C99-conformant implementation.  Drop
	inclusion of header from files that don't directly need it, add
	it where they do, and spell the inclusion consistently with
	double quotes to cue the reader of its local status.

	* src/devices/grodvi/dvi.cpp:
	* src/devices/grolj4/lj4.cpp:
	* src/libs/libdriver/printer.cpp:
	* src/preproc/eqn/box.cpp:
	* src/preproc/eqn/delim.cpp:
	* src/preproc/eqn/pile.cpp:
	* src/preproc/eqn/script.cpp: Add inclusion.

	* src/include/driver.h:
	* src/libs/libgroff/fontfile.cpp:
	* src/preproc/eqn/eqn.h:
	* src/preproc/html/pushback.cpp:
	* src/preproc/refer/refer.h:
	* src/preproc/tbl/table.h:
	* src/utils/addftinfo/addftinfo.cpp: Drop inclusion.

	* src/include/itable.h:
	* src/include/stringclass.h:
	* src/libs/libbib/linear.cpp:
	* src/libs/libbib/search.cpp:
	* src/libs/libgroff/color.cpp:
	* src/libs/libgroff/font.cpp:
	* src/libs/libgroff/nametoindex.cpp:
	* src/libs/libgroff/prime.cpp:
	* src/libs/libgroff/searchpath.cpp:
	* src/preproc/html/pre-html.cpp:
	* src/preproc/preconv/preconv.cpp:
	* src/preproc/soelim/soelim.cpp:
	* src/utils/indxbib/indxbib.cpp:
	* src/utils/lkbib/lkbib.cpp:
	* src/utils/lookbib/lookbib.cpp: Respell inclusion.

	Fixes <https://savannah.gnu.org/bugs/?63079>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-09-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff, ...]: Trivially refactor.

	Boolify and rename internal library function from
	`invalid_input_char` to `is_invalid_input_char`.

	* src/include/lib.h: Do it.

	* src/libs/libgroff/font.cpp (text_file::next_line):
	* src/preproc/eqn/lex.cpp (file_input::read_line):
	* src/preproc/eqn/main.cpp (read_line, main):
	* src/preproc/pic/lex.cpp (file_input::read_line,
	simple_file_input::get, simple_file_input::peek):
	* src/preproc/pic/main.cpp (top_input::get, top_input::peek)
	(do_file):
	* src/preproc/refer/command.cpp (input_stack::push_file):
	* src/preproc/refer/refer.cpp (do_file, do_bib):
	* src/roff/troff/env.cpp (environment::make_tag):
	* src/roff/troff/input.cpp (file_iterator::fill)
	(file_iterator::peek, get_char_for_escape_parameter)
	(transparent_translate, read_request, asciify)
	(input_char_description, read_string, transparent_file,
	set_string): Update call sites.

2022-09-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Tweak diagnostic messages.

	* src/roff/troff/input.cpp (token::description)
	(input_char_description): Consistently use articles in
	descriptive noun phrases.

2022-09-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Tweak diagnostic messages.

	* src/roff/troff/input.cpp (non_empty_name_warning): Say
	"identifier", not "name", in diagnostic message; it can be
	thrown for attempted assignments to invalid register
	identifiers, and some of our documentation refers to identifiers
	in the name space shared by requests, macros, strings, and
	diversions as "names".

	* src/roff/troff/env.cpp (hyphen_trie::read_patterns_file):
	* src/roff/troff/input.cpp (get_char_for_escape_parameter)
	(token::usable_as_delimiter, non_empty_name_warning)
	(pipe_source, psbb_locator::psbb_locator, open_request)
	(opena_request, define_class, pipe_output, system_request):
	Consistently say "_is_ not allowed".  The zero copula poses too
	great a risk of incomprehension IMO.

2022-09-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Add internal string `doc-Lk-font` to manage the typeface
	in which to render URIs.

	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Add it.  Use roman instead of (Courier)
	bold.  This is more consistent with man(7)'s `UR` and less with
	mandoc(1).

	* tmac/doc.tmac (Lk): Use it instead of `doc-Sy-font`.

2022-09-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Fix Savannah #59738.

	* tmac/doc.tmac (Lk): Process further macro arguments more like
	other macros do, calling `doc-print-recursive`.  This permits
	recognition of end-of-sentence punctuation in the argument list.

	Fixes <https://savannah.gnu.org/bugs/?59738>.

2022-09-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Regression-test Savannah #59738.

	* tmac/tests/doc_Lk-respect-sentence-ending-punctuation.sh: Do
	it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-09-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Fix code style nit.  Rename `doc-arg-limit` to
	`doc-arg-count`.  This register doesn't track any sort of limit
	on the number of arguments you can give to an mdoc(7) macro, or
	anything like that.  It is simply a count of the number of
	arguments visible to the currently operating macro.

	* tmac/doc.tmac:
	* tmac/mdoc/doc-common:
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff:
	* tmac/mdoc/doc-syms: Do it.

2022-09-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Fix errors in documentation regarding which escape
	sequences accept newlines as argument delimiters, and other
	inaccuracies.

	* doc/groff.texi (Escape Sequences): Cover general cases before
	exceptional ones.  Leaders can be used as argument delimiters.
	Call out letters and numerals as (usually) usable as well.
	Correct an almost completely inaccurate list of escape sequences
	that accept a newline as an argument delimiter: \A, \b, \o, \w,
	\X, and \Z do; \B does not.  Correct example of use of newline
	as delimiter with \o escape sequence.  Stop referring to the
	decimal point as an "operator".  Drop "newline" from a list of
	prohibited delimiters by several escape sequences since it has
	already been discussed.

	* man/groff.7.man (Escape sequences): Replace weaksauce cross
	reference to our Texinfo manual with a proper discussion of
	acceptable delimiters in escape sequences, synced with the
	foregoing change.  Stop using quotation marks around escape
	sequences, except for "\ " which obviously needs it.

	Fixes <https://savannah.gnu.org/bugs/?63002>.  Thanks to Dave
	Kemper for the report.

2022-09-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Don't throw a spurious warning when using newline as
	delimiter with the few escape sequences that permit this.

	* src/roff/troff/input.cpp (do_overstrike, do_bracket, do_width)
	(do_special): Do it.

	Fixes <https://savannah.gnu.org/bugs/?63011>.  Thanks to Bjarni
	Ingi Gislason for the report and Dave Kemper for the discussion.

2022-09-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Add regression test for Savannah #63011.

	* src/roff/groff/tests/\
	some_escapes_accept_newline_delimiters.sh: Do it.
	* src/roff/groff/groff.am (groff_TESTS): Run it.

2022-09-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (do_special): Fix code style nit;
	align function definition with declaration (internal linkage).

2022-09-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grops/ps.cpp (ps_printer::special)
	(resource_manager::process_file): Fix code style nit.  Mark
	static structs initialized within functions and never modified
	thereafter as `const`.  This attempts to work around an apparent
	false positive from AddressSanitizer.  If it doesn't pacify
	ASAN, please explain to me how constant structure members
	initialized to string literals and pointers to functions within
	the translation unit can ever be null.  If that is infeasible,
	please report a bug to your compiler vendor.

	Fixes (addresses, at any rate) https://savannah.gnu.org/bugs/\
	?61643>.  Thanks to Bjarni Ingi Gislason for the report.

2022-09-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Refactor: relocate most rendering option handling to
	"doc.tmac" from "doc-ditroff" and "doc-nroff", cutting down on a
	lot of duplication.  The `S` register retains separate handling.

	* tmac/doc.tmac:
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Do it.

2022-09-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-ditroff (doc-setup-page-layout):  In troff mode,
	if the user does not define the `LL` register, use the device's
	default line length, not 6.5 inches.  If the user does not
	define the `LT` register, make the default line length for
	titles the same as the regular line length, not 6.5 inches
	independently of it.  This is consistent with man(7)'s handling
	of `LL` and `LT`.

2022-09-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `AD` string to set default adjustment mode.

	* tmac/mdoc/doc-common (Sh): Set adjustment mode to
	user-specified default, not troff's default (and not only in
	troff mode).

	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Process `AD` string setting from command
	line as man(7) does.

	* tmac/groff_mdoc.7.man (Formatting with groff, troff, and
	nroff): Document it.

	* NEWS: Add and update items.

	Fixes part of <https://savannah.gnu.org/bugs/?63046>.

2022-09-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac (doc-tag-list): Fix code style nit: don't give
	`ad` request a numeric argument.  Say `l` instead of `0`.

2022-09-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Align inter-paragraph spacing with man(7).

	* tmac/mdoc/doc-common: Use `doc-paragraph-space` when spacing
	prior to section and subsection headings instead of spacing by
	the 1v default.
	* tmac/mdoc/doc-ditroff: Align inter-paragraph distance amount
	in troff mode with man(7), reducing to 0.4v from 0.5v.

2022-09-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-nroff: Map monospaced fonts (CR, CB, CI, CBI) to
	standard styles as man(7) has done for 15 years.  This silences
	warnings from the formatter when a man page attempts to use
	fonts from the Courier family in tbl(1) tables, which is about
	the only place a reasonable man page attempts such a thing.

2022-09-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Stop prefixing center header with name of operating
	system.  This was hard-coded to "BSD" and stuck on all mdoc(7)
	pages using a default manual section number, regardless of host
	operating system.  Bad idea.  Further, the argument to the `Os`
	call, if any, or a default, is always disclosed in the left
	footer.

	* tmac/mdoc/doc-common: Do it.
	(Dt): Initialize `doc-volume` as empty and annotate it;
	calling the macro with a numeric second argument overrides the
	fallback default of "LOCAL".  A slash is no longer needed to
	separate a recognized architecture string from the OS name, so
	drop it.

	* tmac/tests/doc_smoke-test.sh: Update test expectations.

2022-09-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Drop dead code.  The register
	`doc-volume-operating-system-ateol`, introduced in groff 1.18
	{July 2002}, was being tested but never set to a nonzero value.
	In fact, it seems never to have been.

	* tmac/mdoc/doc-common: Get rid of it...
	(Dt): ...and the dependent block.

2022-09-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Make `Ux` render "Unix" in mixed case.

	* tmac/mdoc/doc-syms (Ux): Do it.  Also remove local string
	after we're done with it.

	Continues work begun prior to groff 1.22.4 release.

2022-09-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Align spacing around headers with man(7).

	* tmac/doc.tmac (doc-save-global-vars, doc-restore-global-vars):
	* tmac/mdoc/doc-common (Rd):
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Stop defining, saving, and restoring
	`doc-header-space`.

	* tmac/mdoc/doc-common (doc-header): When starting new document
	and not continuously rendering, space by one half-inch instead
	of by the now-defunct `doc-header-space` amount (which,
	strictly, should not have applied to this measurement).  If
	continuously rendering, extend page length by 1v to accommodate
	header line.  After formatting header, if not continuously
	rendering, space to 1 inch below first text baseline.

2022-09-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Support `C` register for consecutive page numbering.

	* tmac/mdoc/doc-common (Dd): Reset page number to 1 upon new
	document only if not consecutively numbering.

	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Process `C` register setting from command
	line as man(7) does.

	* tmac/groff_mdoc.7.man (Formatting with groff, troff, and
	nroff): Document it.

	Fixes part of <https://savannah.gnu.org/bugs/?63046>.

2022-09-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Align trap management more closely with man(7).

	* tmac/mdoc/doc-common: Call new macro (see below)
	`doc-set-up-continuous-rendering` when initializing, if that
	mode is configured.
	(doc-ne): New macro replaces `ne` request
	in continuous rendering mode.  It extends the page length by the
	amount in the argument or by 1v if none given.
	(doc-bp): New macro replaces `bp` request in continuous
	rendering mode, setting the page length to the vertical drawing
	position.
	(doc-set-up-continuous-rendering): New macro renames requests to
	emplace the foregoing.
	(Dd): Interpret this macro call strictly as starting a new
	mdoc(7) document.  (andoc.tmac already makes this assumption,
	and has for over 20 years.  groff_mdoc(7) and mandoc_mdoc(7)
	also prescribe the sequence `Dd`, `Dt`, `Os`.)  We require this
	invariant even more rigidly now because it's the only way we can
	be sure that we can process multiple documents while rendering
	headers and footers with information corresponding to the
	appropriate document.  (man(7)'s `TH` has an advantage here in
	that calling it is "atomic": from its arguments alone you can
	obtain everything you need to know to format the header and
	footer.  In mdoc(7), permuting the initialization macro order
	reliably produces chaos.)  Break the page (if necessary)
	_before_ processing any arguments (instead of after), to flush
	the previous page's footer.  Stop calling `doc-set-up-titles`
	here; we don't have enough information to do that yet.  Also
	stop writing the PDF bookmark here, because `doc-document-title`
	and `doc-section` will not reflect the new page content yet.
	(Os): Once the `doc-operating-system` string content has been
	determined, call `doc-set-up-titles`, write the PDF bookmark for
	the page, and call `doc-header`, causing the page header to be
	formatted.  These changes further imply a stronger requirement
	on initialization macro ordering being canonical.

	Fixes <https://savannah.gnu.org/bugs/?62774> (7/7).

2022-09-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Trivially refactor.  Relocate string and macro
	definition within file.  mdoc(7) mandates that the document
	setup macros `Dd`, `Dt`, and `Os` be called in that order;
	arrange their definitions accordingly, for maintainability.

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Refactor.  Rename strings and macro for clarity.  These
	things don't only affect headers.
	- doc-header-string ->       doc-pageref
	- doc-header-string-saved -> doc-pageref-saved
	- doc-setup-header ->        doc-set-up-titles

	* tmac/doc.tmac:
	* tmac/mdoc/doc-common: Do it.

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Refactor.  There is no difference in
	`doc-header-string` and `doc-setup-header` between the files
	"doc-ditroff" and "doc-nroff", so define them only once, in
	"doc-common".

	* tmac/mdoc/doc-common:
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Do it.

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Align footer management more closely with man(7).

	* tmac/doc.tmac (doc-save-global-vars, doc-restore-global-vars):
	* tmac/mdoc/doc-common (Rd):
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Stop defining, saving, and restoring
	`doc-footer-space`.

	* tmac/mdoc/doc-common (doc-break-body-text): New macro, called
	only when not continuously rendering, schedules a page break.
	(doc-footer): Stop vertically spacing by `doc-footer-space`,
	instead relying upon a trap to move us here.

	* tmac/mdoc/doc-ditroff (doc-setup-header):
	* tmac/mdoc/doc-nroff (doc-setup-header): Set traps at the end
	of the page where man(7) does by default; break the body text at
	1 inch from the page bottom, and write the footer at ½ inch.

	* tmac/mdoc/doc-nroff (doc-setup-header): Add 1/6 em "thin
	space" between man page name and parenthesized section, for
	precise parity with doc-ditroff implementation.  (`\|` does not
	take up any character cells on nroff devices.)

	Fixes <https://savannah.gnu.org/bugs/?62774> (6/7).

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (Dt, Dd): Emit diagnostic warnings if
	macros called with no arguments.

	Fixes <https://savannah.gnu.org/bugs/?62774> (5/7).

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Fix code style nit: stop using Control+G as an escape
	sequence argument delimiter.  This is not necessary in groff and
	hasn't been for at least thirty years.  See the node/section
	"Implementation Differences" of our Texinfo manual.  Our mdoc
	implementation does not operate in compatibility mode, so using
	control characters like this obfuscates input to no advantage.

	* tmac/doc.tmac:
	* tmac/mdoc/doc-common:
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff:
	* tmac/mdoc/doc-syms: Do it.

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (doc-footer): Pull more footer concerns
	into this macro.  Don't bail out if continuously rendering;
	instead, format the appropriate footer text if we are.  For now,
	break the page only if we are not continuously rendering.
	(doc-end-macro): Call `doc-footer` instead of formatting footer
	here.

	Fixes <https://savannah.gnu.org/bugs/?62774> (4/7).

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (doc-end-macro): When continuously
	rendering, set the page reference (e.g., "ls(1)") in the right
	footer instead of repeating the left footer.  Thanks to Ingo
	Schwarze for the discussion.

	* tmac/tests/doc_smoke-test.sh: Update expectations of footer
	regression test.

	Fixes part of <https://savannah.gnu.org/bugs/?62926>.

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (doc-end-macro): Reset strings to reduce
	info leaks from one man page to the next.

	Fixes <https://savannah.gnu.org/bugs/?62774> (3/7).

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (Dt): Stop reinitializing `doc-volume`
	and `doc-section`.  This is the job of package initialization
	{and, soon, the end-of-input macro}.

	Fixes <https://savannah.gnu.org/bugs/?62774> (2/7).

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common: Populate default date string
	`doc-date-string` with "UNDATED".
	(Dd, Dt, Os): Make more orthogonal: stop touching
	`doc-topic-name`.  It is "doc.tmac"'s job to initialize it and
	the `Nm` macro's job to update it.
	(Dd): Do nothing if given no arguments.  (You can still blank
	out the document date with an explicitly empty argument:
	  .Dd ""
	.)

	Fixes <https://savannah.gnu.org/bugs/?62774> (1/7).

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common: Change `doc-default-operating-system`
	string from "BSD" to "GNU", per discussion with Ingo Schwarze.
	See <https://lists.gnu.org/archive/html/groff/2022-07/\
	msg00280.html>.

	* tmac/tests/doc_smoke-test.sh: Update expectations of footer
	regression test.

2022-09-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/mdoc/doc-common (Dt): Delete lingering and useless
	definition of `doc-command-name` string.  Thanks to Steffen
	Nurpmeso for the report.  See commit e9e92ee008, 27 August.

2022-09-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/pic/pic.ypp (not_lower_than): Emit deprecation
	warning for use of 'rand()' with a (non-empty) argument.  The
	man page has declared it thus for over 30 years, at least since
	groff 1.02 (June 1991).

2022-09-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/pic/pic.ypp (object_spec): Emit deprecation
	diagnostic for "plot" command.  The man page has declared it
	thus for over 30 years, at least since groff 1.02 (June 1991).

2022-09-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/pic/pic.ypp (placeless_element): Explicitly say
	that an unsafe command is being ignored in diagnostic.

2022-09-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/main.cpp (main): Drop man page reference from
	deprecation diagnostics.  The man page might be installed with a
	prefix determined at configuration time, and that's too much
	trouble to mess with for construction of a message.  Trust the
	user of these ancient options to try reading the man page with
	the same name as the command.

2022-09-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Revise discussion of measurements.

	* doc/groff.texi: Drop Texinfo @codequote* command brackets
	around revised sections; relevant nodes have been reviewed for
	correct glyph usage.  Move concept index entries for obsolescent
	term "machine units" to same location as "basic units".
	Bump document date.
	(Measurements): Rewrite presentation.  We have already
	introduced page geometry concepts, including the concept of
	basic units.
	(Motion Quanta): New subsection node; introduce this concept
	much sooner, right after measurement units.  Relocate
	documentation of `.H` and `.V` registers from a miscellaneous
	read-only register list here.  Introduce example of rounding to
	horizontal motion quantum.
	(Default Units): Revise discussion.  Stop abusing @result
	notation in example.
	(Built-In Registers): Relocate `.H` and `.V` as above.

	* man/groff.7.man: Sync with Texinfo content updates.

	Fixes <https://savannah.gnu.org/bugs/?61432>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-09-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	Drop groff_filenames(5) document.  It says nothing accurate that
	is not covered elsewhere.

	* contrib/groff_filenames: Delete.
	* doc/doc.am (GROFF_MAN_PAGES): Drop.
	* src/roff/groff/groff.1.man: Drop cross reference to it.
	* NEWS: Add item.

	Fixes <https://savannah.gnu.org/bugs/?61818>.

2022-09-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/tbl.1.man (Table data): Generalize discussion
	of roff control line use in tables.
	(Examples): Illustrate how to embed a comment in a table.

2022-08-31  G. Branden Robinson <g.branden.robinson@gmail.com>

	* NEWS: man(7)'s `TS` no longer adds vertical space.  See commit
	7ec36dc9b9, 30 July.

2022-08-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/main.cpp (main): Issue deprecation warning
	upon use of '-p' or '-s' options.  The eqn(1) man page has
	documented these as deprecated since at least groff 1.02 (June
	1991).  Don't count on them sticking around another 30 years.

2022-08-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/main.cpp (main): Clarify error diagnostics
	regarding invalid option arguments.  Identify the option being
	handled at the time and characterize the argument as "invalid",
	not "bad".

2022-08-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	[eqn]: Drop support for undocumented '-D' option.  It has been
	undocumented, and issued a warning of its obsolescence upon use,
	for 30 years, since groff 1.06 (September 1992).  That's plenty
	long enough for a deprecation cycle.

	* src/preproc/eqn/main.cpp (main): Do it.
	* NEWS: Add item.

2022-08-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: (EX, EE): Always break line, even if call invalid.

	* tmac/an.tmac (EX, EE):
	* tmac/an-ext.tmac (EX, EE): Do it.  Ingo Schwarze pointed out
	that page authors will expect breaking semantics from these
	macros even if using them in an ill-formed way.  In a
	well-formed document, the breaks are redundant but harmless (the
	later `nf` and `fi` requests, respectively, also cause breaks).

2022-08-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Trivially refactor.

	* tmac/doc.tmac:
	* tmac/mdoc/doc-common: Rename string `doc-command-name` to
	`doc-topic-name`; the former is misleading for man pages not in
	sections 1, 6, or 8.

2022-08-25  Bjarni Ingi Gislason <bjarniig@vortex.is>

	* man/groff_char.7.man: Fix bad example syntax.

	Fixes <https://savannah.gnu.org/bugs/?62959>.

2022-08-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	[mdoc]: Trivially refactor.

	* tmac/mdoc/doc-common:
	* tmac/mdoc/doc-ditroff:
	* tmac/mdoc/doc-nroff: Stop using "Null" as an empty string
	indicator when comparing a string interpolation to an empty
	parameter will serve just as well; it is also more idiomatic.
	The string in question, `doc-section`, is never formatted if it
	is empty anyway; the very tests at issue, which populate
	`doc-header-string`, ensure this.

2022-08-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/env.cpp (environment::set_family): Throw error
	if user requests a font family that (when combined with the
	current style) can't be resolved to a real font name.  Fixes a
	regression introduced by me in commit d8cb8cf9d8, 2021-09-15,
	arising from a revision of font selection logic in node.cpp to
	enable a bunch of _other_ font error diagnostics.

	Fixes <https://savannah.gnu.org/bugs/?62941>.  Thanks to Dave
	Kemper for the report and two useful end points for a bisection.

2022-08-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/env.cpp (environment::set_family): Add some
	paranoia.  Add `assert()`s on the previous font mounting
	position still being valid and the font family dictionary lookup
	not returning a null pointer.  Add an early return for the
	latter case (which should be impossible).

2022-08-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/node.cpp (font_family::make_definite):
	Refactor.  Rename parameter from inscrutable `i` to
	`mounting_position`.  Add `assert()` to enforce invariant: we're
	passed a mounting position that is nonnegative.  Use `pos` as
	short alias of parameter once we're into the function body.
	Relocate conditional branches to front-load early returns as
	well as those requiring little code to handle.  This reduces the
	average indentation level of the function, a readability win.

2022-08-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Restore robustness to `EE` misuse.

	* tmac/an.tmac: Add `an*is-in-example` register to track state
	of within-exampleness.  Not doing so can cause a spurious use of
	`EE` to wrongly set the inter-paragraph distance to zero.
	(TH): Initialize register.
	(EX): Test register; if set, ignore macro call and, if
	`CHECKSTYLE` warnings are on, throw diagnostic.  Set register.
	(EE): Test register; if clear, ignore macro call and, if
	`CHECKSTYLE` warnings are on, throw diagnostic.  Clear register.

	* tmac/an-ext.tmac (EX, EE): Similar, using `mX` register.
	Because AT&T troff had no `return` request, invert the sense of
	the tests and put the entire macro bodies inside conditionals.

	This regressed post-1.22.4.  Thanks to Ingo Schwarze for the
	report and a proposed patch.

2022-08-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac: Refactor.  Rename `mX` to `mZ` so we can use
	`mX` for an "in-example" state register in a future commit.
	Rename `mE` to `mF` to store the current font's mounting
	position.  Bizarrely, `mF` was not already used for this
	purpose.

2022-08-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/libs/libgroff/error.cpp (do_error_with_file_and_line):
	Trivially refactor.  Use separate string constant for invariant
	material.  (This will make it easier to, for example, store the
	diagnostic level strings in an array that can be indexed by
	their corresponding `enum` type.)

2022-08-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (fatal_with_file_and_line)
	(error_with_file_and_line, debug_with_file_and_line): Align more
	closely with GNU Coding Standards regarding diagnostics: don't
	suffix the colon after the program name with a space when
	location information follows.

2022-08-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grohtml/grohtml.1.man: Fix erroneous claim.
	Images are not generated when "baseline rules" or "box rules"
	are encountered in the input.  These are troff special
	characters; the former is converted to an underscore and the
	latter to U+2502, "box drawings light vertical".  This remains
	true even if a series of them is drawn with the `\l` escape
	sequence.  (I also checked vertical line drawing with `\L`.
	grohtml's handling of that provoked a rather wet eructation from
	my lower esophageal sphincter--the output is assuredly not
	correct.  But it's still not an image.)

2022-08-22  Deri James  <deri@chuzzlewit.myzen.co.uk>

	Bug #62934 - after glyph remapped mark it as used

	When many glyphs are remapped from code points above 255
	such as writing documents in cyrillic with the U-TR fonts,
	gropdf starts reusing code points in the range 128-255.
	If subsequently one of those code points is actually required,
	such as \(em (code 138), and it has been replaced by a
	cyrillic, then it needs to be mapped to another free code.

	To determine if a particular code point is free each glyph
	has a USED flag. The bug was caused because after remapping
	\(em to the next free glyph the USED flag was not set. So the
	next new cyrillic character to be entered was given the same
	code point as had been allocated to \(em.

	* src/devices/gropdf/gropdf.pl: Set the USED flag on remapped
	glyphs.

	Fixes <https://savannah.gnu.org/bugs/?62934>.

	Thanks to Nikita Ivanov for spotting the problem and testing
	the fix.

2022-08-20  Deri James  <deri@chuzzlewit.myzen.co.uk>

	Bug #62923 - problem using aliased glyphs

	With a large font if 2 characters above the 255 code
	point limit are aliased, the aliased glyph has incorrect meta
	data.

	* src/devices/gropdf/gropdf.pl: Instead of duplicating a pointer
	to the font metadata, duplicate the data itself. Then, if the
	glyph is remapped to a code point under 256, the metadata is
	preserved.

	Fixes <https://savannah.gnu.org/bugs/?62923>.  Thanks to Nikita
	Ivanov for the report.

2022-08-18  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf]: Improve parsing of troff font files.

	* src/devices/gropdf/gropdf.pl: Allow the glyph code number
	to be octal or hex as well as a decimal number. If entity_name
	is missing use name instead.

2022-08-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Support pic(1) "flyback" feature.

	* tmac/s.tmac (PF): Add macro; it does what `PE` formerly did,
	minus vertical spacing.
	(PE): Call `PF` and vertically space as before.

	* doc/groff.texi (ms Insertions):
	* doc/ms.ms (Tables, figures, equations, and references):
	* tmac/groff_ms.7.man (Tables, figures, equations, and
	references): Document it.

	* NEWS: Add item.

	Fixes <https://savannah.gnu.org/bugs/?60558>.

2022-08-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (@PS): Validate better; check for 2 arguments
	exactly.

2022-08-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[pic]: Recognize `.PY` as synonym of `.PF`.

	* src/preproc/pic/main.cpp:
	* src/preproc/pic/pic.h: Add new Boolean variable,
	`want_alternate_flyback` to record `.PY` usage.

	* src/preproc/pic/main.cpp (top_input::get, top_input::peek):
	Recognize it.  Update diagnostic messages to mention it.
	(main): Define `PY` troff macro as empty if not defined.

	* src/preproc/pic/troff.cpp (troff_output::finish_picture):
	Don't advance the vertical position if `want_alternate_flyback`.
	Write out the `PY` macro call if it was on the input.

	* src/preproc/pic/pic.1.man: Document it.

	* tmac/pic.tmac (PY): Define the same as `PF`.

	* NEWS: Add item.

	Fixes <https://savannah.gnu.org/bugs/?62901>.

2022-08-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[pic]: Refactor `flyback_flag`.

	* src/preproc/pic/main.cpp:
	* src/preproc/pic/pic.h:
	* src/preproc/pic/troff.cpp: Rename to `want_flyback`.

	* src/preproc/pic/main.cpp:
	* src/preproc/pic/pic.h: Demote type from `int` to `bool`.

	* src/preproc/pic/main.cpp (top_input::get, top_input::peek):
	Use parentheses to clarify operation precedence.

2022-08-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/eqn.1.man: Expand to include lists of
	recognized primitives and predefined macros.

2022-08-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* NEWS: Add item for new groff mm `V` register support.

2022-08-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/lex.cpp (do_delim): Recognize "delim on" even
	in compatibility mode, enabling tbl to toggle eqn delimiter
	recognition when it is run in compatibility mode as well.
	* src/preproc/eqn/eqn.1.man (Controlling delimiters): Update.
	* NEWS: Add item.

	Fixes <https://savannah.gnu.org/bugs/?62852>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-08-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (TH): Fix spurious complaint from `CHECKSTYLE`
	feature when a custom manual section title is declared for a
	standard section number.  Thanks to Quentin Monnet for the
	report.

2022-07-31  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/pdfpic.tmac: Finish incomplete string renames.  Continues
	0fd6ab6b4c, 21 January.
		pdfpic*file-name -> pdfpic*file-name-base
		pspic-args -> pdfpic*pspic-args

2022-07-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (TS): Stop inserting space before tables.  Unlike
	ms(7), man(7) has no concept of "displays" and thus none of
	"display distance".  It is up to the page author to use
	paragraphing macros around tables if vertical space is desired.
	And not up to us to impose it.

	Fixes <https://savannah.gnu.org/bugs/?62841>.

2022-07-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Regression-test Savannah #62841.

	* tmac/tests/an_TS-adds-no-vertical-space.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-07-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/table.cpp (table::do_bottom): Avoid
	overprinting a double-boxed table's bottom border on nroff
	devices.

2022-07-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Expand regression test for Savannah #49390.  Check for
	overlap of double box borders, too.

	* src/preproc/tbl/tests/\
	do-not-overlap-bottom-border-in-nroff.sh: Do it.

2022-07-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Fix Savannah #49390.

	* src/preproc/tbl/table.cpp (table::do_bottom): Avoid
	overprinting a boxed table's bottom border on nroff devices.

	Fixes <https://savannah.gnu.org/bugs/?49390>.  Thanks to Osamu
	Sayama for the report.

2022-07-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Regression-test Savannah #49390.

	* src/preproc/tbl/tests/\
	do-not-overlap-bottom-border-in-nroff.sh: Do it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run test.

2022-07-28  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf]: Improve slant application to lowercase Greek letters.
	<https://lists.gnu.org/archive/html/groff/2022-07/msg00210.html>

	* tmac/pdf.tmac: Slant only if the glyph is sourced from a
	special font, not a regular (text) font containing Greek glyphs.

2022-07-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac: Add italic correction support to `I` and `BI`
	macros.  Call `par*define-font-macro` with newly recognized
	third argument indicating that italic corrections should be
	applied.
	(par*define-font-macro): Apply the corrections if directed.

2022-07-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (input_char_description): Clear
	static buffer on every entry to the function so that calling it
	twice in succession where the second call populates the buffer
	with less data than the first doesn't leave garbage characters
	in a diagnostic message.  Problem appears to date back to 1991
	or earlier.

	Fixes <https://savannah.gnu.org/bugs/?62813>.

2022-07-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (token::usable_as_delimiter):
	(do_non_interpreted, interpolate_arg): Recast diagnostic
	messages for clarity.

2022-07-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac: Initialize section number registers. Fixes
	warnings when starting section numbering at a depth greater than
	1.

	Fixes <https://savannah.gnu.org/bugs/?62812>.

2022-07-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PAGE): Use 'grep -q' instead of redirecting
	standard output to null device.  The '-q' option was
	standardized in POSIX Issue 5 (1997) or earlier.  Also drop the
	redirection of the standard error stream; we have already
	checked the file named in "$descfile" for existence and
	readability.  grep should thus not emit diagnostic messages.

2022-07-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PAGE): Macro used awk(1) without
	`AC_REQUIRE`-ing a relevant macro or checking for its existence.
	Fortunately, sed is powerful enough for our needs.  Remove
	dependency on awk.  Cope with "search" directive in resolv.conf
	having multiple arguments.  Match "domain" directive in same
	file instead of "dom", which I cannot find attested (this logic
	dates to 1991).  Rename `dom` shell variable to `domains` for
	clarity, since its multiplicity could be greater than 1.

2022-07-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PAGE): Refactor: drop AC_DEFINE of
	`PAGEA4`.  This symbol appears to be a relic; it is nowhere
	tested or dereferenced.

2022-07-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tty-char.tmac: Drop definition of \[sd] special
	character.  This was superseded by commit 78e666246c, 8 May,
	which defined a fallback for the character in tty.tmac instead.
	Thanks to Dave Kemper for the catch.

2022-07-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/pdfpic_does-not-choke-on-bad-pdfinfo-output.sh:
	Skip test if "pdfinfo" command not available.

2022-07-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Add sanity checks for font description file generation
	for PDF output device, prompted by discussion with Ingo
	Schwarze.  See <https://lists.gnu.org/archive/html/groff/\
	2022-06/msg00094.html>.

	* font/devpdf/tests/basic-fonts-present.sh:
	* font/devpdf/tests/urw-fonts-present.sh: Add files.

	* font/devpdf/devpdf.am (font_devpdf_TESTS): Add the former test
	unconditionally, and the latter only if `HAVE_URW_FONTS`.

2022-07-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/devpdf.am: Refactor to simplify.  Now that
	symbol.map lives in the "devpdf/generate" directory along with
	the other map files, it doesn't need a dedicated Makefile target
	to produce it.
	(DEVPDFFONTMAP_1, DEVPDFFONTMAP_2): Coalesce and rename to...
	(devpdffontmapdata): ...this.
	(font/devpdf/map/symbol.map:): Drop target.
	(devpdffontmap_DATA, font/devpdf/download): Update dependencies.

2022-07-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/util/BuildFoundries.pl (LoadFoundry): Recast
	diagnostic message so that the user understands the consequence
	of failure to locate a Type 1 font file (that isn't one of the
	base 14 PostScript level 1 fonts): the font will be unavailable
	for the "pdf" output device.

2022-07-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/util/BuildFoundries.pl (LoadFoundry): Separate
	lists of Type 1 font names with spaces as well as commas, for
	better diagnostic message readability.  Also begin message in
	lowercase (per GNU Coding Standards).

2022-07-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/util/BuildFoundries.pl (LoadFoundry): Verify that
	`$foundrypath->[$j]` is defined before operating on it.

2022-07-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	[afmtodit]: Clarify diagnostic message.

	* src/utils/afmtodit/afmtodit.pl: When we have excess Adobe
	Glyph List mappings for a groff special character identifier
	{making the reverse mapping from groff special character to font
	glyph name ambiguous}, report that we're ignoring the excess.
	Use "print STDERR" instead of Perl "warn" built-in since we want
	diagnostic messages to start with the name of the program
	emitting them.

2022-07-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Name and place PS->groff glyph name maps consistently.

	* font/devps/symbolmap: Rename from this...
	* font/devps/generate/symbol.map: ...to this.

	* font/devpdf/devpdf.am (font/devpdf/map/symbolmap): Rename
	target...
	(font/devpdf/map/symbol.map): ...to this.
	(font/devpdf/map/symbol.map): Copy "devps" version of file from
	its new location in the "generate" subdirectory.

	* font/devpdf/Foundry.in: Reflect rename.

	* font/devps/generate/Makefile (symbolmap): Rename target...
	($(srcdir)/symbol.map): ...to this.

	* font/devps/devps.am (DEVPSGENFILES, EXTRA_DIST):
	* font/devps/generate/Makefile (S, EURO $(SPECIALFONTS), clean):
	* src/utils/afmtodit/afmtodit.1.man: Reflect rename and
	relocation.

	* font/devps/generate/dingbats.rmap: Rename from this...
	* font/devps/generate/dingbats-reversed.map: ...to this.

	* font/devps/devps.am (DEVPSGENFILES):
	* font/devps/generate/Makefile (ZDR):
	* src/utils/afmtodit/afmtodit.1.man: Reflect rename.

	* font/devps/generate/lgreekmap: Rename from this...
	* font/devps/generate/slanted-symbol.map: ...to this.

	* font/devps/devps.am (DEVPSGENFILES):
	* font/devps/generate/Makefile (SS):
	* src/utils/afmtodit/afmtodit.1.man: Reflect rename.

	* font/devps/generate/textmap: Rename from this...
	* font/devps/generate/text.map: ...to this.

	* font/devpdf/Foundry.in:
	* font/devpdf/devpdf.am (DEVPDFFONTMAP_1):
	* font/devps/devps.am (DEVPSGENFILES):
	* font/devps/generate/Makefile (TEXTMAP):
	* src/devices/gropdf/gropdf.1.man:
	* src/devices/grops/grops.1.man:
	* src/utils/afmtodit/afmtodit.1.man: Reflect rename.

2022-07-10  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (doc/ms.ps): Add dependency on "eqn", and call
	groff with "-e" option.
	* src/utils/grog/tests/smoke-test.sh: Update expected "grog"
	output for the ms.ms document.

2022-07-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (doc/ms.ps): Add dependency on "tbl".

2022-07-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/node.cpp (suppress_node::tprint): Add source
	file line number after its name when emitting "grohtml-info", to
	aid debugging.

2022-07-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/node.cpp (get_register, get_string): Reorder
	null pointer inequality comparisons; they don't need to be in a
	funny order because it's pretty hard to mistype `!=` as an
	assignment operator.  Annotate them as null pointers to ease any
	future migration to ISO C++11.  Use primitive type constructor
	instead of C-style cast operator; this seems more idiomatic.

2022-07-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp (generateImages): Flush the
	standard error stream after writing to it in a loop.

2022-07-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (RP): Recognize new optional arguments
	`no-renumber` and `no-repeat-info`, the latter as a synonym for
	the existing `no`.  The former suppresses the page number
	manipulation that normally occurs.  Drop now-unnecessary `pn 0`
	request.
	(top level, cov*first-page-init, RP, cov*print): Rename
	`cov*rp-format` to `cov*use-rp-format` for clarity.
	(cov*break-page): New macro breaks the cover page at the end,
	resetting next page number to 1 only if desired by user.
	(cov*print, cov*rp-print): Call `cov*break-page` instead of
	invoking `bp`.

	* doc/groff.texi (Document Description Macros) <RP>:
	* doc/ms.ms (Document description macros) <RP>:
	* tmac/groff_ms.7.man (Document description macros) <RP>:
	Document them.

	* NEWS: Add item.

2022-07-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac: Rename register `cov*rp-no` to
	`cov*rp-no-repeat-info`.

2022-07-08  Deri James  <deri@chuzzlewit.myzen.co.uk>

	* font/devpdf/util/BuildFoundries.pl (LocateFile): Some systems
	store .afm files in a parallel directory to the Type 1 files,
	restore original path after checking for parallel directory.

2022-07-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/devpdf.am (font/devpdf/download): Call
	"BuildFoundries" with new `--strict` option so that the build
	fails if the AFM files for the URW fonts can't be found.

2022-07-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/util/BuildFoundries.pl: Add Boolean-valued scalar
	`beStrict` (defaults false) and new command-line option
	`--strict` to make it true.
	(LoadFoundry): Check return value of subroutine `LocateAF`.
	Emit diagnostic if it is null, as a warning if not "strict", and
	fatal if so.

2022-07-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/devpdf.am (font/devpdf/util/BuildFoundries): Add
	dependency on "afmtodit" since "BuildFoundries" calls this
	program when generating groff font description files from URW
	fonts.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Fix Savannah #62690.

	* tmac/s.tmac (P1, SC, UC, P2): Drop undocumented support for
	document-private macros used by Kernighan & Cherry's
	"Typesetting Mathematics -- User's Guide (Second Edition)".

	Fixes <https://savannah.gnu.org/bugs/?62690>.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Fix Savannah #62688.

	* tmac/s.tmac (DE): Set no-space mode when ending displays.
	(@EN): Set no-space mode after outputting the display distance
	so that it doesn't combine with inter-paragraph space.

	Fixes <https://savannah.gnu.org/bugs/?62688>.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Regression-test Savannah #62688.

	* tmac/tests/s_no-excess-space-around-displays.tmac: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Fix Savannah #62687.

	* tmac/s.tmac (@MC): Honor `MINGW` register even when setting
	only two columns, as clearly implied by our documentation.

	Fixes <https://savannah.gnu.org/bugs/?62687>.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Regression-test Savannah #62687.

	* tmac/tests/s_honor-MINGW-when-two-columns.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Fix Savannah #62686.

	* tmac/s.tmac (@MC): Set no-space mode before doing a paragraph
	reset, not after: we don't want vertical space at the top of the
	first column when entering multi-column mode, because then it
	doesn't align with the tops of subsequent columns.

	Fixes <https://savannah.gnu.org/bugs/?62686>.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Regression-test Savannah #62686.

	* tmac/tests/s_mark-column-start-correctly.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (IX): Drop.
	* NEWS: Add item.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac: Add "sorry" implementations for documented but
	unsupported Unix Version 7 ms macros.  This way it's easier to
	tell when a historical document needs one and this case is
	distinguishable from a document-private macro warned about with
	"groff -w mac".

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (UX): Drop undocumented support for this macro.
	This implementation isn't consistent with historical ones, which
	identified the trademark holder.  But doing that is a problem,
	so just stop trying to cope.  Also, spelling Unix in full caps
	was an imposition by the AT&T legal department on the CSRC.

	"The name Unix is a trademark, originally owned by Bell Labs and
	subsequently traded off like a baseball card among a number of
	companies." -- Ben Klemens

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Replace incomplete documentation of unimplemented macros.

	* doc/groff.texi (Missing ms Macros):
	* doc/ms.ms (AT&T ms macros not appearing in groff ms): Drop,
	replacing with...

	* doc/groff.texi (Unix Version 7 ms Macros Not Implemented by
	groff ms):
	* doc/ms.ms (Unix Version 7 ms macros not implemented by groff
	ms):
	* tmac/groff_ms.7.man (Unix Version 7 macros not implemented by
	groff ms): ...these.

2022-07-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (do_translate): Throw an error
	diagnostic when the user attempts to translate space characters.
	{By contrast, translating _to_ [unbreakable, unadjustable]
	spaces is an old troff hack often seen as ".tr ~ ", and largely
	superseded by groff's "\~" escape sequence, now widely supported
	by other troffs.}

	Fixes <https://savannah.gnu.org/bugs/?60803>.  Thanks to T. Kurt
	Bond and Oliver Corff for the report.

2022-07-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/pipeline.c: Refactor.  Drop function rename via
	preprocessor macro usage.  Declare and define `c_error` by its
	correct name.
	(run_pipeline): Update call sites.  Stop flushing standard error
	stream after calling libgroff's `error` function (which
	`c_error` wraps); libgroff already guarantees this operation.

2022-07-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (abort_request): Flush the standard
	error stream before exiting, to improve chances of user seeing
	any message as arguments to the `ab` request.

2022-06-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp
	(char_buffer::run_output_filter): Die if platform supports
	neither `fork()` nor `spawn()` for child process creation.

2022-06-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp (cleanup): Add function to tidy
	memory before exiting.
	(main): Register aforementioned function with `atexit()`.  Die
	if registration fails.

2022-06-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp (do_file): Die if `fclose()`
	fails; such a situation suggests a pretty hosed environment.

2022-06-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp (checkImageDir): If `mkdir()`
	fails, use `strerror()` to report the underlying problem.

2022-06-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp: Refactor.  Drop unnecessary
	prototype for static function.  Use idiomatic C++98 null pointer
	constant.  Annotate it as null pointer to ease any future
	migration to ISO C++11.  Boolify.  Use C++98 bool data type
	instead of preprocessor macros `TRUE` and `FALSE`.  Demote some
	global Boolean variables from `int` to `bool` and rename some to
	be more clear: `show_progress` -> `want_progress_report`;
	`debugging`; `eqn_flag` -> `need_eqn`.
	(make_message): Rename this...
	(make_string): ...to this.  Align more closely with contemporary
	version of example from Linux man-pages printf(3) page.  Use
	`vsnprintf()` to determine size of memory buffer needed prior to
	allocation instead of iteratively growing it until it is large
	enough.  Always die if `vsnprintf()` fails: this function now
	always returns a valid pointer if it returns at all.
	(makeFileName, setupAntiAlias, imageList::createPage,
	imageList::createImage): Update call sites to use
	`make_string()`.
	(char_buffer::can_see): Demote return type from `int` to `bool`.
	(char_buffer::skip_spaces): Drop unused member function.
	(char_buffer::read_file, makeTempFiles): Demote return type from
	`int` to `void`.  Stop returning after calling functions that
	don't return.
	(char_buffer::read_file): Call `sys_fatal()` if `fread()`
	returns an error, similarly to other calls into the standard C
	library that this file makes.  Improve check for error from
	`fread()` by not regarding a return value of zero when the
	end-of-file indicator is set as an error condition.
	(makeFileName, checkImageDir, char_buffer::run_output_filter,
	scanArguments): Call `fatal()` instead of `error()` and then
	`exit(1)`.
	(makeFileName, scanArguments): Dismiss Shlemiel the Painter:
	save return value of `strlen()` and call `strcpy()` multiple
	times instead of mixing `strcpy()` and `strcat()`; the latter
	approach rescans the string unnecessarily.
	(char_buffer::run_output_filter): Stop passing unnecessary null
	pointer argument to diagnostic message functions.  Stop calling
	`fflush()` after libgroff diagnostic function, which always
	{ultimately} flushes the standard error stream itself.
	(makeTempFiles, do_file, main): Boolify.
	(makeTempFiles, do_file): Reorder null pointer equality
	comparisons to avoid inadvertent lvalue assignment.
	(scanArguments, main): Use `EXIT_SUCCESS` and `EXIT_FAILURE`
	constants from C library instead of integer literals for exit
	status.
	(do_file): Demote return type from `int` to `bool`.  Return
	Boolean literals.  Drop conditional with empty consequent.
	(main): Declare local variables closer to the points of use.
	Stop trying to be a register allocator: stop reusing loop index
	variable `i` as integer storage for another (albeit related)
	purpose; introduce `operand_index` instead.  Clarify logic by
	splitting combined initialization and comparison operations, and
	by testing function return value directly instead of storing it
	in a pointless temporary.  Use `EXIT_SUCCESS` and `EXIT_FAILURE`
	constants from C library instead of integer literals for exit
	status.

2022-06-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp (run_commands): Trivially refactor.
	Rename variable for clarity; add comment.

2022-06-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/html/pre-html.cpp
	(char_buffer::run_output_filter): Return wait status of child
	process.
	(char_buffer::run_output_filter, main): Rename local variable
	`status` to `wstatus` to recognize distinction between exit
	status (a 7-bit quantity) and wait status (a wider type).
	(main): Issue fatal diagnostic if child process exited with
	nonzero status.  Since the child's output to the standard error
	stream is lost, advise re-running with different output driver
	to see them.  This unhappy shortcoming is filed as Savannah
	#62673.  Explicitly return zero otherwise.

	Fixes <https://savannah.gnu.org/bugs/?60782>.

2022-06-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/tests/ab_works.sh: Add regression test for
	Savannah #60782.

2022-06-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Trivially refactor.

	* src/roff/troff/input.cpp (token::next): Rename statement label
	to use documentary terminology.
	* src/roff/troff/node.cpp (make_composite_node)
	(make_glyph_node): Make functions static since nothing outside
	this translation unit calls them.
	* src/roff/troff/node.cpp (make_glyph_node): Refactor optional
	argument and its usage.  Put it down, flip it, and reverse it.
	That is, demote its type from `int` to `bool`, invert its sense,
	and rename it since it affects warning, not error, diagnostics.
	(character_exists): Update only call site of `make_glyph_node()`
	that uses non-default argument value.

2022-06-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Adjust diagnostic message text to clarify and better
	match terminology used in documentation.

	* src/roff/troff/input.cpp (set_escape_char, do_overstrike)
	(do_bracket, do_name_test, do_width, do_special):
	* src/roff/troff/node.cpp (suppress_node::tprint): Migrate from
	"escape" to "escape sequence".

	* src/roff/troff/node.cpp (make_composite_node)
	(make_glyph_node): Clarify what went wrong.

	* src/roff/troff/input.cpp (token::get_char)
	(check_missing_character): Migrate from "normal character" to
	"ordinary character" (see groff_char(7)).

2022-06-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Rename a function for clarity.

	* src/roff/troff/input.cpp (add_to_node_list): Rename this...
	(add_to_zero_width_node_list): ...to this.
	(do_zero_width): Update call site.
	* src/roff/troff/token.h: Update declaration.

2022-06-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp (handle_unknown_desc_command):
	Refactor to skip unnecessary string comparisons.  We explicitly
	return in the final case instead of falling off the end of this
	void function for consistency if additional cases are added.

2022-06-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp (handle_unknown_desc_command):
	Partially revert commit 64dc40d23a, 19 June.  I forgot to save
	and restore the previous values of the globals
	`current_filename` and `current_lineno`, and, noticing that this
	function has 3 return paths, decided that it's cheaper just to
	go back to `error_with_file_and_line()`.

2022-06-21  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf]: Add more search paths to the Foundry file.

	* font/devpdf/Foundry.in: Use the directory specified with the
	config flag --with-urw-fonts-dir to populate the default foundry
	as well as the U foundry. Important to populate the download
	file with font files to embed the fonts not part of the base
	pdf fonts or if user wants all fonts embedded.

2022-06-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an-ext.tmac (UR, MT): Fix problem with hyphenation
	occurring before the end of the line when the line length was
	not the device default (common for man pages at the terminal)
	and hyperlinks were enabled.  The issue is that the new
	environment we created inherits the default environment's line
	length (its state at troff initialization, prior to macro
	package loading and configuration).  This latent issue was
	exposed by post-groff 1.22.4 changes to enable the hyphenation
	of link text and add the hyperlink feature.  Fix it by copying
	the line length at the time the macro is called, which is
	necessarily after man(7) sets up the line length, to the new
	environment.

2022-06-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grops/psrm.cpp (resource_manager::output_prolog):
	(resource_manager::supply_resource):
	(resource_manager::read_download_file): Update diagnostic
	message language and report underlying problem encountered by
	system when failing to open files.  This will probably be the
	text for ENOENT in most cases, but should help avoid frustration
	in those where it isn't.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grops/psrm.cpp
	(resource_manager::read_download_file): Align diagnostic message
	wording with gropdf in the same circumstance.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Throw warning in font category when a font selection
	escape sequence is used after the output line continuation
	escape sequence on an input line, because it is ignored.

	* src/roff/troff/env.cpp (environment::set_font): Do it.

	* doc/groff.texi (Warnings):
	* src/roff/troff/troff.1.man (Warnings): Document it.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/env.cpp (font_change): Boolify.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (LoadFont): Revise error message
	when a font can't be found for embedding.  User failure to add
	an entry for locating the font file seems a more likely scenario
	than outright corruption of the file.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/env.cpp (font_change): Warn upon selection of a
	nonexistent font name.

	Fixes <https://savannah.gnu.org/bugs/?62656>.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Revise `environment::set_font` to return Boolean value
	indicating success of font selection operation.

	* src/roff/troff/env.cpp (environment::set_font):
	* src/roff/troff/env.h (environment::set_font): Do it.

	This prepares the way for a fix for Savannah #62656.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp: Use single exit path, freeing
	memory allocated for strings.
	(xexit): Add `exit()` wrapper; free allocated memory.
	(main): Use it in all three exit paths.

2022-06-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp: Refactor to be more meticulous with
	memory.  Add globals `saved_path`, `groff_bin_path`, and
	`groff_font` to store pointers into the process environment
	returned by `putenv()`; once used, they need to remain valid for
	the lifetime of the program.
	(xstrdup): Add `strdup()` wrapper: dies if `strdup()` fails.
	(main): Split nested `strsave()` and `xputenv()` (until recently
	`putenv()`) calls.  Free duplicate strings prior to exit.

2022-06-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp (main): Rename temporary variable to
	avoid shadowing one in enclosing scope, which can lead to
	cut-and-paste errors (ask me how I know).

2022-06-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp: Slightly refactor to indirect
	`putenv` calls through an error-checking wrapper.
	(xputenv): Add new function to die if `putenv()` fails.
	(main): Update call sites to use it.

2022-06-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	[groff]: Add information to diagnostic messages.

	* src/roff/groff/groff.cpp (main): Report underlying system
	error if `putenv()` fails.
	(handle_unknown_desc_command): Set globals `current_filename`
	and `current_lineno` from `filename` and `lineno` arguments
	passed to us to we can use the simpler interface of `error()`
	rather than `error_with_file_and_line()`.

2022-06-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	[libgroff]: Update return type of `font::load_desc` function to
	enable more informative diagnostics from callers.

	* src/include/font.h (font::load_desc): Change return type from
	`bool` to `const char` pointer.
	* src/libs/libgroff/font.cpp (font::load_desc): Return null
	pointer literal on failed `open()` or validation failures.
	Return filespec on success.

	* src/libs/libdriver/input.cpp (do_file):
	* src/preproc/grn/main.cpp (getres):
	* src/roff/groff/groff.cpp (main):
	* src/roff/troff/input.cpp (main): Compare `font::load_desc()`
	return value to null pointer literal instead of treating it as a
	Boolean.

	* src/roff/groff/groff.cpp (main): Report full filespec of
	troublesome "DESC" file when complaining of missing "postpro"
	directive.

2022-06-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp: Add new Boolean global,
	`need_postdriver`, and initialize it true.
	(main): Make `need_postdriver` false if the `-X` or `-Z` options
	are given.  Test it later.  This prevents groff from exiting
	with a fatal error if an output driver is not available, but
	also not required.  Also reorder null pointer equality
	comparison to avoid inadvertent lvalue assignment.

	Fixes <https://savannah.gnu.org/bugs/?62640>.

2022-06-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.cpp (help): Revise usage message for
	expressiveness and clarity.

2022-06-21  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf]: Correct display of pathnames used.

	* font/devpdf/util/BuildFoundries.pl: Convert array to
	string of pathnames.

2022-06-21  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf]: Fix to gropdf.

	* src/devices/gropdf/gropdf.pl: If pdfbookmark was called
	within 5p of top of page (e.g. straight after a .bp when
	\n[nl] was zero) the click destination would be off by a
	page.

2022-06-19  Ingo Schwarze <schwarze@openbsd.org>

	* font/devpdf/devpdf.am: Always build PDF font description
	files.

	Build font/devpdf/download and the various TR, TB, CR etc.
	files in the same directory even when they are not required
	by the build because USE_GROPDF is unset, usually because
	ghostscript is either unavailable or deliberately disabled
	by the person running the build.  These files need to be
	built and installed anyway, and can be used on the target
	system when the required infrastructure is available at run
	time.

2022-06-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Revise introduction of vertical spacing concept to avoid
	render inference that the formatter will compute a vertical
	spacing appropriate to the type size automagically--it will not.

	Fixes <https://savannah.gnu.org/bugs/?62617>.  Thanks to Dave
	Kemper for the report.

2022-06-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	[docs]: Revise discussion of end-of-sentence detection.

	* doc/groff.texi (Filling):
	* man/roff.7.man (Concepts): Do it.  "Spaces" is a now a term
	with a much more restricted usage.  Emphasize the input context,
	now explicitly identified as plain text files with Unix line
	endings.

	Fixes (one hopes) <https://savannah.gnu.org/bugs/?62593>.
	Thanks to Ingo Schwarze for the report and Dave Kemper for the
	discussion.

2022-06-10  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf]: Changes to BuildFoundries.

	* font/devpdf/util/BuildFoundries.pl: Collect search paths into
	an array rather than a colon delimited string, this allows
	the @PATH_SEPARATOR@ character (':' or ';') to be used to
	delimit paths yielded by the command 'gs -h' but still use ':'
	to delimit paths in the Foundry file. This means the same
	Foundry file can be used on all systems.

	* font/devpdf/Foundry.in: Add more likely paths to find the URW
	fonts.

2022-06-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Weaken dependency on TeX, instead using it (to generate
	the DVI and PDF forms of our Texinfo manual) only if it is
	available.

	* m4/groff.m4 (GROFF_USE_TEX_CHECK): Check for presence of 'tex'
	executable in path.  Set shell variable `groff_use_tex` to "yes"
	if present, and "no" otherwise.  This check runs only if the
	'makeinfo' and 'texi2dvi' version checks have already passed.

	* configure.ac: Run the new check.  Set Automake conditional
	`USE_TEX` only if shell variable `groff_use_tex` is "yes".
	Report whether "groff.dvi" and "groff.pdf" are (re-)buildable.

	* doc/doc.am: Parameterize names of groff.{dvi,pdf} targets as
	Make macros `GROFF_DVI` and `GROFF_PDF`.  Define them only if
	`USE_TEX`.  Do _not_ update `EXTRA_DIST` macro; leave the
	literal file names there because we require that distribution
	archives contain these files.
	(.texi.dvi, .texi.pdf): Update suffix rules to check `USE_TEX`
	and fail, complaining of missing 'tex' program, if these targets
	are attempted without it being true.  Only manually specifying
	the file names as targets to 'make' or attempting to generate a
	distribution archive without TeX present should cause these
	errors.

	* INSTALL.REPO: Update dependency information.

	Fixes <https://savannah.gnu.org/bugs/?62592>.  Thanks to Deri
	James for the report.

2022-06-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (.texi.dvi, .texi.pdf, $(DOC_GNU_EPS)): Quote names
	of programs when aborting because they're missing.

2022-06-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PROG_MAKEINFO, GROFF_PROG_TEXI2DVI):
	Largely revert commit d5013ededc, 21 May: run checks for
	'makeinfo' and 'texi2dvi' programs regardless of presence of
	".tarball-version" file.  Their presence is a necessary (but not
	sufficient) condition for refresh of formatted forms of our
	Texinfo manual if the source is modified.

	Begins addressing <https://savannah.gnu.org/bugs/?62592>.

2022-06-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Rename some groff Autoconf macros to better match
	Autoconf's own naming conventions.

	* m4/groff.m4 (GROFF_MAKEINFO): Rename to...
	(GROFF_PROG_MAKEINFO): ...this.
	(GROFF_TEXI2DVI): Rename to...
	(GROFF_PROG_TEXI2DVI): ...this.

	* configure.ac:
	* m4/groff.m4 (GROFF_TEXI2DVI): Update call sites.

2022-06-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (SH, SS, B, I, SM, SB): Set input trap with `it`
	instead of `itc` for better Unix Version 7 man(7) compatibility.

	Fixes <https://savannah.gnu.org/bugs/?51468>.  Also see
	discussion at
	https://lists.gnu.org/archive/html/groff/2022-06/msg00020.html
	et sequentia (amid a vigorous bikeshedding of `\&`'s name).

2022-06-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Regression-test use of input traps.

	* tmac/tests/an_use-input-traps-correctly.sh: Do it.
	* tmac/tmac.am (tmac_TESTS): Run test.

2022-06-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (LoadDesc): Validate device
	description file for essential directives and acceptable values
	as grops(1) does.

2022-06-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff, grohtml, grops, grotty]: Update wording of diagnostic
	messages to refer to "motion quantum" rather than "resolution"
	where appropriate.

	* src/devices/grohtml/post-html.cpp
	(html_printer::html_printer):
	* src/devices/grops/ps.cpp (ps_printer::ps_printer):
	* src/devices/grotty/tty.cpp (tty_printer::set_char)
	(tty_printer::add_char, tty_printer::end_page):
	* src/roff/troff/env.cpp (line_length, title_length): Do it.

2022-06-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl: Do more "DESC" file validation.
	(LoadDesc): Bomb out gracefully if any of "unitwidth", "res", or
	"sizescale" missing from "DESC" file.  This prevents Perl
	warnings about use of uninitialized values, and undoubtedly
	mangled output.

2022-06-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl: Revise diagnostic message
	handling.
	(top level): Add new scalar `progname` to house executable name.
	(Msg): Output messages in format recommended by GNU Coding
	Standards manual.  Identify who's talking (Savannah #52463).
	Rename `lev` scalar to `fatal` since it is used only as a
	Boolean for immediately exiting with failure status.  Report
	diagnostic severity as part of message.
	(Warn, Die): Add new subroutines through which all diagnostics
	are now emitted.
	(top level): Migrate a use of Perl `die` builtin to our `Die`.
	(top level, ToPoints, LoadDownload, LoadDesc, do_x, GetPoints,
	LoadSWF, LoadPDF, LoadStream, BuildStream, ParsePDFHash,
	LoadFont, GetType1, GetChunk, RemapChr, do_N): Migrate `Msg(0,
	...)` calls to `Warn` and `Msg(1, ...)` to `Die`.  Begin
	messages in lowercase (GNU Coding Standards).  Recast a few
	messages for clarity.

	Continues the long process of fixing Savannah #52463.

2022-06-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (Load_Config): Drop unused
	subroutine and its commented-out call site, which came in that
	way in July 2011.

2022-06-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (LoadFont): Warn if a font to be
	embedded in PDF output cannot be located in the "download" file.

	Fixes <https://savannah.gnu.org/bugs/?62572>.  Thanks to Deri
	James.

2022-06-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/a4.tmac: Drop file from distribution.  It has been
	superseded by papersize.tmac for nearly 20 years.
	* tmac/tmac.am (TMACNORMALFILES): Delete reference.
	* NEWS: Add item.

	Fixes <https://savannah.gnu.org/bugs/?62569>.

2022-06-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Parameterize X11-related man pages, so they don't get
	spuriously generated (and not cleaned) when building with X11
	support disabled.

	* Makefile.am (.man): Fix logic nit: drop unnecessary removal of
	target before clobbering it with sed.
	* src/devices/xditview/xditview.am (GXDITVIEW_MAN1): Add new
	macro, expanding to nothing if `WITHOUT_X11` and to the target
	name otherwise.
	(man1_MANS): Append `GXDITVIEW_MAN1` expansion, not a literal.
	* src/devices/xditview/xditview.am (XTOTROFF_MAN1): Add new
	macro, expanding to nothing if `WITHOUT_X11` and to the target
	name otherwise.
	(man1_MANS): Append `XTOTROFF_MAN1` expansion, not a literal.
	* doc/doc.am (GROFF_MAN_PAGES1): Append foregoing expansions
	instead of literals.

2022-06-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Add `AM_CONDITIONAL`: `HAVE_URW_FONTS`, so our
	Automake files can more easily cope with their absence.
	* font/devpdf/Foundry.in: Add easily matched phrases to
	comments, to clearly delimit the URW foundry portion of the file
	so it can be omitted if those fonts are absent.
	* font/devpdf/devpdf.am (font/devpdf/Foundry): Generate file
	differently depending on `HAVE_URW_FONTS`; keep the existing
	procedure if true, and delete the URW section from the generated
	file otherwise, avoiding diagnostic messages from afmtodit(1)
	and our BuildFoundries script.

	Fixes <https://savannah.gnu.org/bugs/?62570>.

2022-06-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/devpdf.am (font/devpdf/util/BuildFoundries):
	Generate script using the `PATH_SEPARATOR` Automake macro.
	* font/devpdf/util/BuildFoundries.pl: Add `pathsep` scalar to
	house the build-time path separator.
	(LocateFile): Use it.
	(LoadFoundry, CheckFoundry): Stop using spaces as part of the
	path separation delimiter.  It is not idiomatic.

2022-06-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Explicitly identify poppler tools in report.

2022-06-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/util/BuildFoundries.pl: Trivially refactor.  Drop
	unused hash `foundry`.  Drop scalar `warn` that was set and
	updated but never tested.

2022-06-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/util/BuildFoundries.pl: Alter script to write to
	the standard output stream instead of (re)writing a file named
	"download" in the current working directory.  This recovers from
	a problem I introduced in commit 6e62be835d, 2 May, as an
	unforeseen side effect of improving build parallelism so that
	the "download" file wouldn't be read until it was fully
	populated.  As a side benefit, this approach is more Unixy, and
	less dependent on $PWD.
	(top level): Stop calling `WriteDownload` with an argument.
	(LoadFoundry): Close only the file handle of interest when done,
	not all of them (including `STDOUT`, which we now need).
	(CheckFoundry): Same--just for cleanliness, since at present
	running the script in 'check' mode doesn't write to any streams.
	(WriteDownload): Stop taking an argument and manipulating file
	handles.  Write download file to standard output.
	(LoadDownload, WriteDownload): Drop `top` scalar, used as a
	mutex to serialize read and write access to "download" file; it
	is no longer needed since the "download" file is now only read.

2022-06-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Rename shell variables and Autoconf/Automake macros of
	Boolean sense to have names more like logical predicates and
	avoid doofy "DONT" nomenclature.

	* m4/groff.m4 (GROFF_MAKE_RM): Rename shell variable
	`groff_is_rm_defined` to `groff_make_defines_rm` (purely for
	clarity; it already had a good name).
	(GROFF_MAKE_RM): Rename this...
	(GROFF_MAKE_DEFINES_RM): to this, to make parallelism obvious,
	and enabling...
	* configure.ac: ...rename of `MAKE_DONT_HAVE_RM` to
	`MAKE_DEFINES_RM` with sense of test reversed.  Also interpolate
	`GROFF_MAKE_DEFINES_RM` instead of `GROFF_MAKE_RM`.  This in
	turn enables...
	* Makefile.am: ...revision of conditional from
	`MAKE_DONT_HAVE_RM` to "!`MAKE_DEFINES_RM`".

2022-06-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_URW_FONTS_PATH)
	(GROFF_WITH_COMPATIBILITY_WRAPPERS, GROFF_APPDEFDIR_OPTION)
	(GROFF_UCHARDET): Recast help strings to more closely parallel
	structure and style of Autoconf's own help strings.
	(GROFF_WITH_COMPATIBILITY_WRAPPERS): Recast to tighten wording.

2022-06-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac:
	* m4/groff.m4 (GROFF_APPDEFDIR_OPTION, GROFF_APPDEFDIR_DEFAULT)
	(GROFF_APPDEFDIR_CHECK): Rename m4 macros and shell variable
	from "*appres*" to "*appdef*.  Update interpolation sites.

	* configure.ac:
	* m4/groff.m4 (GROFF_APPDEFDIR_CHECK): Further rename this...
	(GROFF_APPDEFDIR_NOTICE): ...to this, for consistency with other
	post-report output macros.

	* Makefile.am:
	* PROBLEMS:
	* doc/automake.mom:
	* src/devices/xditview/xditview.am: Update interpolation sites
	of `appresdir`.

	* Makefile.am:
	* src/devices/xditview/gxditview.1.man:
	* src/roff/groff/groff.1.man: Update interpolation sites of
	`APPRESDIR`.

	* NEWS: Add item.

2022-06-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_X11, GROFF_UCHARDET): Drop redundant
	messages (which are easily overlooked amid the torrent of
	"checking" output anyway).  Discovery failures of X11 and the
	uchardet library are already parts of the configuration report
	at or near the end of output.

2022-06-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PNMTOPS_NOSETPAGE): Partially revert change
	from 21 May and document why in a comment.

2022-06-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/troffrc: Skip loading of "papersize.tmac" if not in troff
	mode.

	Fixes <https://savannah.gnu.org/bugs/?62238>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-05-31  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Report use of "g" prefix for commands and macro
	package compatibility wrappers.
	* m4/groff.m4 (GROFF_G): Fix code style nits.  Update
	indentation to match recent practice.

2022-05-31  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Fix code style nits and tweak report.  Stop
	superfluously using braces for shell parameter expansions that
	don't require them.  The shell is not make(1).  Say
	"installation _directory_ prefix" since another kind of prefix
	can be used by groff (the "g" in front of command and macro
	package names shared with AT&T troff).

2022-05-31  Dave Kemper <saint.snit@gmail.com>

	* doc/groff.texi: Fix content and style nits.
	  - Remove redundancy ("fixed-width... character that can't be
	    adjusted").
	  - Fix incorrect word ("environment value" -> "environment
	    variable").
	  - Add or change the placement of a couple tie{}s to comport
	    with style-guide recommendation.
	  - Grammarify.
	  - Clarify and tighten wording.

	Fixes <https://savannah.gnu.org/bugs/?62551>.

2022-05-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/node.cpp (font_position): If mounting a font
	fails and a third argument was given (to the `fp` request),
	report its value in the diagnostic message.  This could reveal a
	prohibited attempt at directory traversal.  See commit
	a891161bc9, 7 November.

2022-05-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/libs/libgroff/fontfile.cpp (font::open_file): Refactor.
	Move more logic, including memory allocation, inside conditional
	that accepts only file names without '/' characters, skipping
	unnecessary work in the alternative.  Annotate use of zero
	literals as null pointers to ease any future migration to ISO
	C++11.  Add 'const' qualifier to variable that doesn't require
	modification (and which is used in the LHS of an equality
	comparison, so that clumsy operator misuse will provoke a
	compiler warning).

	Fixes <https://savannah.gnu.org/bugs/?62532>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-05-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: In configuration report, say that we're
	reporting compiler options along with the compiler executable.
	Fix leftover test(1) comparison with garbage, overlooked in
	commit faa22d89d2, 20 May.

2022-05-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (doc/meintro_fr.ps): Build with '-t' option.

	Fixes <https://savannah.gnu.org/bugs/?62542>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-05-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.1.man (Options) <-l>: Handle case where
	no default print spooler is configured, and report formatter
	behavior correctly if it isn't.

	Fixes <https://savannah.gnu.org/bugs/?62535>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-05-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	* Makefile.am (.man): Process '@PSPRINT@' substitutions with
	"makevarescape.sed".

2022-05-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PROG_YACC, GROFF_MAKEINFO, GROFF_TEXI2DVI):
	Fix logic error in detection of build scenario: the presence of
	a ".git" directory is not an indicator that we're not building
	from a distribution archive, because we might be building from a
	snapshot archive (which also lacks it).  Instead, perform checks
	required only by builds from Git checkouts and snapshot archives
	if the ".tarball-version" file is not present.

2022-05-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* Makefile.am (EXTRA_DIST): Ship "HACKING" file.

2022-05-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* bootstrap.conf: Add "pkg-config" to `buildreq`.  Not having it
	causes pretty horrible macro expansion problems and diagnostics
	when 'autoreconf' is run; they're still pretty bad even if you
	use `AC_REQUIRE` and `m4_pattern_forbid`.  So just demand it.

2022-05-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devps/S:
	* font/devps/symbolmap: Drop excess mapping of `*U` special
	character.  groff maps it to the Adobe Glyph List name
	'Upsilon1'.  (The AGL 'Upsilon' is a homoglyph of the Latin
	capital 'Y'.)
	* PROBLEMS: De-document build-time warning, now resolved.

2022-05-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.tables: Regenerate using Unicode
	14.0.  No substantive changes.

2022-05-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/make-afmtodit-tables: Refactor.  Drop
	unused variable `prog`.  Use value of `CPP` from environment (if
	defined) and use parameter expansion to apply a default if null
	or not set.  Use for loop to eliminate duplicative if statement.
	Test input files for readability, not just existence.  Use more
	portable test(1) and shell syntax.  Swap usage error and fatal
	error exit statuses; using "1" for failure and "2" for usage
	errors is more common in shell scripts I've seen.  Update usage
	message to put non-literal parameter in full caps, and clarify
	its name.  Update comment blocks written to generated files to
	further clarify data provenance.

2022-05-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PRINT): Refactor.  Stop performing checks
	for spooler options if none is available.  Stop redundantly
	reporting command name used for spooling PostScript files.  If
	an option is required for spooling DVI files, report it alone
	instead of repeating the command name as well.

2022-05-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	Fix insensitivity of groff(1) man page to configured spooler.

	* Makefile.am (.man): Replace `@PSPRINT@` in man page sources
	with name of configured print spooler command.
	* src/roff/groff/groff.1.man (Options) <-l>: Use configured
	print spooler command instead of literal 'lpr'.

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_UCHARDET_CHECK): Fix grammar nit in failure
	message when user demands uchardet support but the library
	cannot be located.

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_CHECK_GROHTML_PROGRAMS): Fix logic error in
	computation of verb to be used in notice message.

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PROG_YACC, GROFF_URW_FONTS_CHECK)
	(GROFF_WITH_COMPATIBILITY_WRAPPERS, GROFF_UCHARDET_NOTICE):
	Improve shell code portability.  Per the GNU Autoconf manual,
	"The -a, -o, '(', and ')' operands are not present in all
	implementations, and have been marked obsolete by Posix 2008.
	...portable uses of test should never have more than four
	arguments, and scripts should use shell constructs like '&&' and
	'||' instead."

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/groff/groff.1.man (Installation directories): Don't
	output a tagged paragraph for the X11 application defaults
	directory if the build symbol '@APPRESDIR@' is not defined (that
	is, we didn't build with X11 support).

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_GHOSTSCRIPT_VERSION_CHECK): Fix code style
	nits.  Use lowercase for shell variables we define.  Don't quote
	literal operands to test(1) that don't contain syntactically
	shell-significant characters.  Update indentation to match
	recent practice.

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_URW_FONTS_NOTICE): Don't emit the notice if
	Ghostscript isn't available, since it was a prerequisite for
	the `GROFF_URW_FONTS_CHECK` macro in the first place.

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Add print spooler determination to configuration
	report.

	* m4/groff.m4 (GROFF_PRINT): Add shell variable
	`groff_have_spooler` to house the name of the print spooler
	{"lp" or "lpr"} or the word "no".
	* configure.ac: Report determined spooler, or its absence.

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/preconv/tests/do-not-seek-the-unseekable.sh: Skip
	seekability check of the standard input stream if there is no
	controlling terminal.

	Fixes <https://savannah.gnu.org/bugs/?62506>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-05-24  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_CHECK_GROHTML_PROGRAMS): Migrate from
	`AC_FOREACH` to `m4_foreach` to avoid obsolescence warning from
	GNU Autoconf 2.70 or later.

	Fixes <https://savannah.gnu.org/bugs/?61059>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-05-22  G. Branden Robinson <g.branden.robinson@gmail.com>

	* man/groff.7.man: Rename "pilot" list macros for man(7) from
	`BL`/`EL` to `LS`/`LE`, per suggestion from Alejandro Colomar.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_MAKEINFO, GROFF_TEXI2DVI): Check for
	makeinfo(1) and texi2dvi(1) programs only if building from Git,
	not a distribution archive.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (doc/meintro_fr.ps): Call groff with `-K utf8`
	instead of `-k`, in case the "configure" script didn't find
	uchardet (and preconv(1) thus can't auto-detect an encoding).

	Fixes <https://savannah.gnu.org/bugs/?59463>.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/preconv/tests/do-not-seek-the-unseekable.sh: Skip
	a check if /dev/stdin is not a character special device.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PDFTOOLS): Rename this...
	(GROFF_POPPLER): ...to this.
	* configure.ac: Update call site.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_UCHARDET_CHECK): Rename this...
	(GROFF_UCHARDET_NOTICE): ...to this.
	* configure.ac: Update call site.

	* m4/groff.m4 (GROFF_UCHARDET_NOTICE): Tighten wording of
	message reported to user.

	Fixes <https://savannah.gnu.org/bugs/?59481>.  Thanks to Dave
	Kemper for the report.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PNMTOOLS_CAN_BE_QUIET)
	(GROFF_PNMTOPS_NOSETPAGE): Skip check if prerequisite not met.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_URW_FONTS_CHECK): Rename this...
	(GROFF_URW_FONTS_NOTICE): ...to this.
	(GROFF_URW_FONTS): ...and this...
	(GROFF_URW_FONTS_CHECK): ...to this.
	(GROFF_URW_FONTS_NOTICE): Give lengthy notice message a one-line
	summary.
	* configure.ac: Update call sites.

2022-05-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_URW_FONTS): Refactor.  If our prerequisites
	are not met (availability of 'awk' and 'gs'), don't even run the
	check logic or print a "checking" message.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	Handle missing programs required to construct files needed at
	runtime by gropdf more gracefully.  Rename and refactor
	configuration-time logic to be more understandable.

	* configure.ac:
	* m4/groff.m4: Rename `GROFF_PDFDOC_PROGRAMS` macro to
	`GROFF_CHECK_GROPDF_PROGRAMS`.  Rename shell variable
	`make_pdfdoc` to `use_gropdf`.  Set it explicitly to "no" or
	"yes" instead of null or not null.

	* configure.ac:
	* m4/groff.m4:
	* doc/doc.am: Rename `BUILD_PDFDOC` to `USE_GROPDF`.

	* configure.ac: Call `GROFF_GROPDF_PROGRAM_NOTICE`.

	* doc/doc.am: Bracket definition of `PROCESSEDDOCFILES_PDF`
	macro and `$(PROCESSEDDOCFILES_PDF)` dependency declaration in
	Automake `if USE_GROPDF` conditional.  This prevents attempts
	to build PDF documents using groff that are doomed to fail.

	* m4/groff.m4: Refactor gropdf runtime-dependency program check.
	Split into two macros: one (`GROFF_CHECK_GROPDF_PROGRAMS`)
	performs the check, the other (`GROFF_GROPDF_PROGRAM_NOTICE`)
	issues a notice at the end of the configuration process if at
	least one program was not found.  Rename `docnote` shell
	variable to `gropdf_notice`.  Tighten wording of notice.  Drop
	unused `make_install_pdfdoc` and `make_uninstall_pdfdoc` shell
	variables.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	Handle missing programs required at runtime by grohtml more
	gracefully.  Rename and refactor configuration-time logic to be
	more understandable.

	* configure.ac:
	* m4/groff.m4: Rename `GROFF_HTML_PROGRAMS` macro to
	`GROFF_CHECK_GROHTML_PROGRAMS`.  Rename shell variable
	`make_htmldoc` to `use_grohtml`.  Set it explicitly to "no" or
	"yes" instead of null or not null.

	* configure.ac:
	* m4/groff.m4:
	* doc/doc.am: Rename `BUILD_HTML` to `USE_GROHTML`.

	* configure.ac: Call `GROFF_GROHTML_PROGRAM_NOTICE`.

	* doc/doc.am: Bracket definition of `PROCESSEDDOCFILES_HTML`
	macro and `$(PROCESSEDDOCFILES_HTML)` dependency declaration
	in Automake `if USE_GROHTML` conditional.  This prevents an
	attempt to build an HTML version of the "pic.ms" document that
	is doomed to fail (noisily).

	* m4/groff.m4: Refactor grohtml runtime-dependency program
	check.  Split into two macros: one
	{`GROFF_CHECK_GROHTML_PROGRAMS`} performs the check, the other
	{`GROFF_GROHTML_PROGRAM_NOTICE`} issues a notice at the end of
	the configuration process if at least one program was not found.
	Rename `html_docnote` shell variable to `grohtml_notice`.
	Tighten wording of notice.  Drop unused `make_install_htmldoc`
	and `make_uninstall_htmldoc` shell variables.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_GHOSTSCRIPT_VERSION_NOTICE): Add newline at
	end of buggy Ghostscript notification, so that the multiple
	possible lengthy notices after the configuration report have
	blank lines separating them.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	Check for m4 program at configuration time.

	* m4/groff.m4 (GROFF_PROG_M4): Define new macro to perform the
	check and error out if the program is missing.
	* configure.ac: Call the new macro.
	* tmac/tmac.am (tmac/groff_man.7.man)
	(tmac/groff_man_style.7.man): Use the new implicitly AC_SUBST-ed
	variable `M4` to run the program.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_PROG_YACC): Update wording of error
	message: we search for "yacc", so report it as missing if it is
	not found (along with "byacc" and "bison").

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Fix shell style nits.  Get rid of string
	{non-}nullity tests and comparisons involving concatenation with
	garbage (usually "x").  See 13 November entry regarding m4.  Use
	idiomatic shell "brace style" for control structures.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	Trivially refactor libgroff allocator configuration.

	* m4/groff.m4 (GROFF_USE_GROFF_ALLOCATOR): Update description of
	configuration flag to clarify that it's implemented in a
	library.  Rename shell variable to prefix it with "groff_",
	putting it in an ad hoc name space as with other variables.  If
	feature disabled, set variable to literal "no".
	* configure.ac: Use renamed variable and interpolate it directly
	into configuration report, simplifying shell logic.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* configure.ac: Revise configuration report for intelligibility.
	Add report of C++ compiler and flags used: we compile much more
	C++ than C code so this seems appropriate.  Report Perl
	interpreter version so that we can collect build reports and
	turn the ratchet past Perl 5.6.1 at some point.  Fix X11
	"resources" misnomer (application defaults are what is meant).
	Rephrase generally.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* Makefile.am (EXTRA_DIST): Ship "ChangeLog.122" in distribution
	archive.  Overlooked in commit c11995df16, 19 February 2021.

2022-05-20  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grotty/tests/basic_latin_glyphs_map_correctly.sh:
	Fix portability problem: POSIX says that "od -c" (and "od -t c")
	are supposed to emit printing characters as defined by the
	underlying locale, but GNU coreutils od doesn't do this and
	macOS od does.  Set `LC_ALL` to "C" when running it to force
	3-digit octal reporting of characters with their eighth bit set.

	Fixes <https://savannah.gnu.org/bugs/?62357>.  Thanks to John
	Gardner for the report.  Also see <https://pubs.opengroup.org/\
	onlinepubs/9699919799/utilities/od.html>.

2022-05-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* INSTALL.extra (In Case of Trouble): Add advice on using the
	test suite, particularly if it fails.

	Fixes <https://savannah.gnu.org/bugs/?62478> (one hopes).

2022-05-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Input Line Traps):  Expand discussion.  The
	`it` and `itc` requests count neither input lines (strictly) nor
	text lines.  Instead, they count input lines that _directly
	produce formatted output_ (and, in the case of `itc`, are not
	"interrupted" or continued with the `\c` escape sequence).  This
	is useful--empty requests and requests that don't put nodes on
	the output don't break things--but does demand some explanation.
	Clarify and provide example.
	* man/groff.7.man (Escape sequence short reference) <it>: Sync.

2022-05-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/env.cpp (environment::choose_breakpoint): Tweak
	diagnostic message ("can't" -> "cannot").
	* doc/groff.texi (Breaking): Update example.

2022-05-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Copy Mode):
	* man/groff.7.man (Copy mode): Fix omission; `\?` is interpreted
	in copy mode.

2022-05-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (PT): Unclutter name space; remove
	`pg*saved-page-number-format` string when we're done with it.

2022-05-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Add unit tests, including one XFAIL for bad behavior.

	* src/preproc/tbl/tests/check-horizontal-line-length.sh:
	* src/preproc/tbl/tests/check-line-intersections.sh:
	* src/preproc/tbl/tests/check-vertical-line-length.sh:
	* src/preproc/tbl/tests/table-lacks-spurious-top-border.sh: Do
	it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run tests.
	(tbl_XFAIL_TESTS, XFAIL_TESTS): Expect one test failure.

2022-05-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grotty/tty.cpp (tty_printer::add_char): Modify
	diagnostic message: what gets written "above [the] first line"
	might not be a character (glyph) per se, but a line (rule) from
	a drawing command, and in fact the occurrence of these from
	boxed tables is the most common cause of this message I've seen.

2022-05-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	[grotty]: Do more input validation.

	* src/devices/grotty/tty.cpp (tty_printer::draw): Throw warning
	if an unsupported geometric primitive is encountered.
	(tty_printer::line): Throw warning if a line is diagonal.  Die
	if length of a horizontal or vertical line is not a multiple of
	the appropriate motion quantum of the device (troff should never
	emit such nonsense, and currently doesn't appear to).

2022-05-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/tbl/tbl.1.man (Miscellaneous): Document GNU tbl's
	use of `#T` and `T.` registers.

2022-05-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (read_color_draw_node): Tweak
	diagnostic message to better distinguish drawing commands and
	device control commands.

2022-05-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[grohtml]: Mitigate double-free problem exposed by malformed
	input.

	* src/roff/troff/mtsm.h (struct statem): Place member variable
	`issue_no` behind `DEBUGGING` preprocessor symbol, omitting it
	from production and ordinary development builds.
	* src/roff/troff/mtsm.cpp (no_of_statems): Place global variable
	behind `DEBUGGING` preprocessor symbol, omitting it from
	production and ordinary development builds.
	(statem::statem): Make constructor trivial if `DEBUGGING` not
	defined in preprocessor; it manipulates only `issue_no` and
	`no_of_statems`, which are synchronized.
	(statem::statem {copy}): Gate assignment of `issue_no` member
	variable from copy constructor behind `DEBUGGING` preprocessor
	symbol.
	(statem::flush, mtsm::inherit): Gate debugging output, already
	runtime-gated on `debug_state` symbol, of `issue_no` member
	variable, so that we don't reference it when it is not declared.

	See <https://savannah.gnu.org/bugs/?62040>.

2022-05-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	[refer]: Rename a test artifact; it's a bibliographic database
	file, not a refer(1) command file.

	* src/preproc/refer/tests/artifacts/62124.ref: Rename this...
	* src/preproc/refer/tests/artifacts/62124.bib: ...to this.
	* src/preproc/refer/refer.am (EXTRA_DIST):
	* src/preproc/refer/tests/report-correct-line-numbers.sh: Use
	new name.

2022-05-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/command.cpp (process_commands): Begin
	migration to use existing global variables for location reports
	in diagnostic messages.  Save current file name and line number
	before calling `command_loop()` and restore them afterward.
	Also decrement line counter before entering that loop because it
	would be too far advanced by one due to the final newline on a
	parsed input line.

2022-05-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/refer.cpp (main): Report system error on
	`fflush()` failure.  POSIX Issue 5 a.k.a. SUSv2 (1997) specifies
	several possible `errno` values this C standard library function
	can set; see
	<https://pubs.opengroup.org/onlinepubs/007908799/xsh/fflush.html>.

2022-05-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	[refer]: Refactor: drop unused version of function (taking only
	a `const char *` parameter).

	* src/preproc/refer/command.cpp (process_commands): Drop
	definition.
	* src/preproc/refer/command.h (process_commands): Drop
	declaration.

2022-05-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/refer.cpp (do_file): Fix another off-by-one
	line number reporting bug exposed by fix for Savannah #62391.

2022-05-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/tests/report-correct-line-numbers.sh: Add
	more regression tests.

2022-05-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	[refer]: Trivially refactor: boolify.

	* src/preproc/refer/command.cpp (input_stack::push_file): Demote
	and rename local variable from `int` to `bool`.
	(bol): Renamed from this...
	(is_at_beginning_of_line): ...to this.

2022-05-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	[refer]: Trivially refactor.

	* src/preproc/refer/command.cpp (input_stack::push_file):
	* src/preproc/refer/refer.cpp (do_file): Drop unnecessary
	construction of integer from integer (return type of `getc()`)
	in argument to error diagnostic functions; parallelizes with
	other diagnostic function calls.

2022-05-04  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/command.cpp: Refactor to simplify.
	(get_location): Demote return type from `int` to `void`.  The
	function only ever returned a `1` literal.
	(input_stack::error): Update call site to stop uselessly testing
	return value of `get_location()`.

2022-05-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (dist-info-bits, install_infodoc, dist-gnueps): Fix
	logic error.  When checking both source and build trees for
	files to copy, break after successfully copying the files, not
	after the first iteration of the loop unconditionally.  This
	caused the Info documents not to be installed from out-of-tree
	builds, and potentially would prevent them and doc/gnu.eps from
	being included in the distribution archive if for some reason
	they didn't build and that build failure were not treated as an
	error.  Problems introduced by me in commits e78bd20d54, 27
	March, and d79c3f3a4a, 11 November.

2022-05-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* m4/groff.m4 (GROFF_APPRESDIR_OPTION): Update comments and
	human-readable output to (1) stop claiming that existing
	gxditview application defaults in the installation directory
	will be backed up; this is no longer true as of commit
	c66cb7725f, 3 April; and (2) refer to these files as
	"application defaults", not "resources".  (X11 application
	defaults are client-side and mandatory [for Xt-based programs];
	X resources are stored server-side and need not be configured to
	determine an X client's geometry and rendering.)

2022-05-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devX100-12/devX100-12.am (devX100_12_fontdir):
	* font/devX100/devX100.am (devX100_fontdir):
	* font/devX75-12/devX75-12.am (devX75_12_fontdir):
	* font/devX75/devX75.am (devX75_fontdir): Define macros without
	an extra "font/" layer in the directory hierarchy.

	Fixes problem introduced by me in commit 3c82cbbfe5, 27
	February.

2022-05-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devpdf/devpdf.am (font/devpdf/util/BuildFoundries): Spell
	dependency on `$(SH_DEPS_SED_SCRIPT)` using that macro expansion
	instead of a literal file name.  See doc/automake.mom.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/eqn.am (MAINTAINERCLEANFILES):
	* src/preproc/pic/pic.am (MAINTAINERCLEANFILES):
	* src/preproc/refer/refer.am (MAINTAINERCLEANFILES): Preserve
	byacc/bison output artifacts unless "maintainer-clean"ing.  Per
	the GNU Automake manual, "The intermediate files generated by
	yacc (or lex) will be included in any distribution that is made.
	That way the user doesn’t need to have yacc or lex."

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* Makefile.am: Stop manually handling "test-groff".  Per the
	GNU Automake manual, "If configure built it, then distclean
	should delete it."  This is taken care of automatically if we
	don't interfere.
	(BUILT_SOURCES, MOSTLYCLEANFILES): Drop "test-groff".

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/eqn.am (neqn): Produce temporary file first
	and set its permissions before moving it into place.  If
	anything in the future ever has a dependency on it, this avoids
	a race where the file exists, satisfying a dependency, but
	execution is attempted before its `x` permission bit is set.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Ensure that we install *.me source files, but don't
	include them in the distribution archive.

	* doc/doc.am (dist_otherdoc_DATA): Move `$(GENERATEDDOCFILES)`
	from here...
	(nodist_otherdoc_DATA): ...to here.
	(.PRECIOUS): Add `$(GENERATEDDOCFILES)` so that make(1) doesn't
	automatically remove "intermediate" objects in the .me.in -> .me
	-> .ps chain.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Handle "gnu.eps" file better.

	* doc/doc.am (GENERATEDDOCFILES): Remove `$(DOC_GNU_EPS)`.
	(EXTRA_DIST): Ship `$(DOC_GNU_EPS)` in distribution archive.
	($(DOC_GNU_EPS)): Simplify rule commands; stop trying to copy
	the file around since it will either be (1) in the distribution
	archive from which a build is performed; or (2) missing because
	a build is being done from Git, in which case we expect the PNM
	tools to be available.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (clean_otherdoc): Drop target: it doesn't seem to
	accomplish anything.
	(clean_infodoc): Drop target, moving its rules into...
	(maintainer-clean-local): ...this.  Drop deps, both gone now.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (distclean-local): Drop target: stop cleaning
	generated forms of our Texinfo manual with the "distclean"
	target.  They ship with the distribution archive and should
	remain in the tree even if the user needs to re-./configure.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Fix problems exposed by high build parallelism.

	* font/devpdf/devpdf.am (font/devpdf/util/BuildFoundries)
	(font/devpdf/DESC, font/devpdf/Foundry): Drop
	unnecessary removal of target prior to creating it.
	(font/devpdf/Foundry): Add creation of destination build
	directory as other targets do.
	(font/devpdf/download): Create dedicated target instead of
	lumping its generation under the stamp file.  Add missing
	dependencies on `$(DEVPDFFONTMAP_1)`, `$(DEVPDFFONTMAP_2)`,
	`font/devpdf/Foundry` and `font/devpdf/enc/text.enc`.  Remove
	now-unnecessarily complicated "forgery" of "GEN" line in quiet
	builds.  Tweak format of comment written to "download" file to
	make field identities clearer.  Construct output (with multiple
	shell commands) in temporary file so it is not read prematurely
	by the "BuildFoundries" script.  Move target into place as the
	last step.
	(font/devpdf/stamp): Relocate target to follow its dependencies.
	Add dependency on "font/devpdf/download".

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Tweak diagnostic messages in BuildFoundries script.

	* font/devpdf/util/BuildFoundries.pl (LoadFoundry)
	(WriteDownload, CheckFoundry): Recast for specificity and
	consistent style.
	(Die): Stop reporting line number with fatal errors; none of the
	call sites are parsing input.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	[refer]: Fix off-by-one error in line number for some
	diagnostics.

	* src/preproc/refer/command.cpp (input_item::get_location):
	Decrement reported line number by one after looping over input
	so that we report the line number as it was before the last
	newline character seen.  This off-by-one error was partially
	masked by...
	* src/preproc/refer/refer.cpp (do_file): ...initialization of
	`current_lineno` to zero.  However, for syntax problems (as
	opposed to the semantic problems of refer(1) command
	processing), this could result in complaints about the line
	number before they occurred, even on "line zero".  Initialize
	the variable to 1.

	Fixes <https://savannah.gnu.org/bugs/?62391>.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/tests/report-correct-line-numbers.sh: Add
	regression test for Savannah #62391.

2022-05-02  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/tfmtodit/tfmtodit.cpp (usage): Tweak usage message.
	Condense `-v` and `--version` into a single output line with
	brace and pipe notation, which we do not use in our man pages,
	but consistently do in our usage messages.  Use lowercase for
	option arguments since they are separated from option flag
	letters by space.  Call `fprintf()` once instead of 3 times.

2022-05-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/refer.cpp (main): Tweak wording of
	diagnostic messages to refer to options consistently and to
	characterize input as "invalid" rather than "bad".
	(usage): Document --version option.  Use more informative
	metasyntactic variable names.  Organize usage message
	consistently with our others, and stop wrapping the output
	lines: we know neither the width of the terminal nor the length
	of the `program_name` string we're interpolating.  See commit
	b4de44f0, 19 July 2021.

2022-05-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (string_iterator::backtrace): Fix
	spurious output when `mac.filename` is empty.  Provoked by:
	  $ printf '\\(' | troff -b

2022-05-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/refer.cpp: Trivially refactor.  Demote
	global variable `recognize_R1_R2` from integer to Boolean.
	(main, do_bib): Give expressions to `assert()` meaningful
	content.
	(is_list): Demote return type from `int` to `bool`.
	(do_file): Demote and rename integer local variables
	`start_of_line` to Boolean `at_start_of_line`.
	(is_list, do_file): Reorder equality comparisons to avoid
	inadvertent lvalue assignment.

2022-05-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Reduce and rationalize in-tree document dependencies.
	This eliminates spurious rebuilds of numerous documents
	{including the 380+-page groff-man-pages collections}.  It also
	fixes missing dependencies when using the build's groff to
	generate PostScript documents.

	* .gitignore: Drop old name of devpdf stamp file.
	* doc/.gitignore: Drop now-unused "example.stamp" file.
	* doc/doc.am (PROCESSEDDOCFILES_HTML, PROCESSEDDOCFILES_PDF)
	(PROCESSEDDOCFILES_TXT): Add new macros grouping targets by the
	format/output driver used to produce them, to better organize
	dependencies for their generation.
	(PROCESSEDDOCFILES): Redefine as simply the expansions of the
	foregeoing.
	(PROCESSEDFILES_DEPS_HTML, PROCESSEDFILES_DEPS_HTML,
	PROCESSEDFILES_DEPS_PDF, PROCESSEDFILES_DEPS_TXT): Add new
	macros defining prerequisites for production of the
	corresponding output document formats.
	($(PROCESSEDDOCFILES_HTML), $(PROCESSEDDOCFILES_PDF),
	$(PROCESSEDDOCFILES_PS), $(PROCESSEDDOCFILES_TXT)): Declare the
	dependencies using expansions of the foregoing macros.
	(MOSTLYCLEANFILES): Drop "doc/automake.pdf", now part of
	`PROCESSEDDOCFILES_PDF`.
	(doc/automake.pdf): Drop dependencies already supplied by
	`PROCESSEDFILES_DEPS_PDF`.
	(HTMLDOCFILES): Drop macro.  "doc/pic.html" is now in the
	expansion of `PROCESSEDDOCFILES_HTML`.
	(htmlpic_DATA): Redefine as expansion of
	`PROCESSEDDOCFILES_HTML` instead of `HTMLDOCFILES`.
	(PROCESSEDEXAMPLEFILES_HTML) [BUILD_HTML]: Define as
	"doc/webpage.html", otherwise as empty.
	(PROCESSEDEXAMPLEFILES_PS): Contain "doc/webpage.ps" and
	"doc/grnexampl.ps".
	(PROCESSEDEXAMPLEFILES): Redefine as expansions of
	`PROCESSEDEXAMPLEFILES_HTML` and `PROCESSEDEXAMPLEFILES_PS`.
	($(PROCESSEDEXAMPLEFILES_HTML), $(PROCESSEDEXAMPLEFILES_PS)):
	Declare dependencies using `PROCESSEDFILES_DEPS_HTML` and
	`PROCESSEDFILES_DEPS_PS`, respectively.
	(HTMLEXAMPLEFILES): Drop macro.  "doc/webpage.html" is now in
	the expansion of `PROCESSEDDOCFILES_HTML`.
	(nodist_htmlexamples_DATA): Drop macro, no longer needed.
	($(PROCESSEDDOCFILES_PS)): Relocated and redefined above.
	($(PROCESSEDEXAMPLEFILES) $(PROCESSEDDOCFILES)): Drop overbroad
	dependency declarations in favor of the above.
	(MOSTLYCLEANFILES, doc/examples.stamp): Drop generation and
	removal of unnecessary stamp file.
	(doc/pic.html, doc/webpage.html): Add explicit dependency on
	required preprocessors.  Drop redundant and spurious
	dependencies.
	* font/devhtml/devhtml.am (MOSTLYCLEANFILES)
	(font/devhtml/stamp): Generate and remove stamp file to enable
	reliable target dependencies for build-time generation of HTML
	documents by groff.
	* font/devpdf/devpdf.am (MOSTLYCLEANFILES, font/devpdf/stamp):
	Rename stamp file from "font/devpdf/build_font_files".
	(font/devpdf/stamp): Drop unnecessary dependency on "afmtodit".
	* font/devps/devps.am (MOSTLYCLEANFILES, font/devps/stamp):
	Generate and remove stamp file to enable reliable target
	dependencies for build-time generation of PostScript documents
	by groff.
	* font/devutf8/devutf8.am (MOSTLYCLEANFILES)
	(font/devutf8/stamp): Generate and remove stamp file to enable
	reliable target dependencies for build-time generation of
	UTF-8-encoded text documents by groff.

	Fixes <https://savannah.gnu.org/bugs/?62084>; thanks to
	Sergei Trofimovich for the report.  Also fixes
	<https://savannah.gnu.org/bugs/?62297>; thanks to Bjarni Ingi
	Gislason for the report.

2022-04-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	[build]: Fix code style nits in Automake files.

	* doc/doc.am: Put spaces around (Auto)make variable assignments,
	for consistency with the rest of this .am file, and our others.
	* font/devpdf/devpdf.am (font/devpdf/build_font_files): Use
	shell '>' operator instead of touch(1).
	* font/devhtml/devhtml.am (font/devhtml/DESC):
	* font/devps/devps.am (font/devps/DESC): Construct target in
	temporary file, since doing so is a multi-step process, moving
	it to the target name when it is complete and usable by
	dependencies.

2022-04-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/refer.cpp (main): When complaining of
	unrecognized option, report the entire option string (after
	the leading dash), not just its first character.

2022-04-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/libs/libgroff/error.cpp: Trivially refactor.  Explicitly
	compare pointer lvalues to null pointers instead of punningly
	treating them as Booleans.  Annotate use of zero literals as
	null pointers to ease any future migration to ISO C++11.

2022-04-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (an*abbreviate-inner-footer): Clean up better
	before early returns.  Remove temporary registers.

2022-04-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/fallbacks.tmac: Add fallbacks for U+02C6 MODIFIER LETTER
	CIRCUMFLEX ACCENT and U+02DC SMALL TILDE to Basic Latin
	characters.

2022-04-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Fix portability problem.  Don't pass echo(1) arguments
	containing backslashes because implementations handle them
	differently.  Use printf(1) instead.  Thanks to Bertrand
	Garrigues for reporting the problem and confirming the fix on
	his build host.

	* tmac/tests/e_chapter-titles-work.sh:
	* tmac/tests/e_ld-works.sh:
	* tmac/tests/localization-works.sh: Do it.

2022-04-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/gropdf/gropdf.pl (ppsz): Recognize "com10" (U.S.
	commercial envelope) paper format.

	Addresses the original issue reported in
	<https://bugs.debian.org/1009248>.  We have however broadened
	its scope; see <https://savannah.gnu.org/bugs/?62344>.

2022-04-27  Dave Kemper <saint.snit@gmail.com>

	* src/devices/gropdf/gropdf.pl (ppsz): Recognize ISO B-series
	paper formats using strings of the form "b0-b6", not "isob0-b6",
	for consistency with libgroff and papersize.tmac.

	Fixes <http://savannah.gnu.org/bugs/?62346>.

2022-04-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor to simplify.  Ingo's removal of the
	"--with-doc" "configure" option, among other changes, clears the
	way to remove many phony targets and simplify dependencies
	involving generation of the 5 formats of our Texinfo manual.
	(build_infodoc, doc, doc_all, doc_txt, dvi, doc_dvi, pdf,
	doc_pdf, html, doc_html): Drop phony targets.
	(all): Depend directly on doc/groff.{info,txt,html,dvi,pdf}.
	* NEWS: Add item since "make doc" is no longer necessary and
	will do nothing.

2022-04-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Handle `\R` sequences in text blocks robustly.

	* src/preproc/tbl/table.cpp (table::add_entry): Fix SEGV when
	repeating glyph table entry syntax (`\Rx`) used in a text block.
	Lift extraction of entry string to be done unconditionally,
	rather than in 5 different special cases.  This frees us up to
	rewrite the entry if necessary, changing '\R' to '\&' inside a
	text block.  Recast diagnostic to describe the problem
	clearly--"bad repeated character" suggests that something is
	wrong with the "argument" to `\R`, when really the problem is
	the _context_.

	Fixes <http://savannah.gnu.org/bugs/?62366>.

2022-04-27  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Regression-test Savannah #62366.

	* src/preproc/tbl/tests/\
	do-not-segv-when-backslash-R-in-text-block.sh: Do it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run test.

2022-04-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/libs/libgroff/string.cpp (string::extract): Check return
	value of `malloc()` for nullity, and only poke into the buffer
	returned if it is valid.  Discovered while troubleshooting
	Savannah #62366.

2022-04-23  Bertrand Garrigues <bertrand.garrigues@laposte.net>

	gnulib: replace non-recursive-gnulib-prefix-hack with
	automake-subdir option

	'non-recursive-gnulib-prefix-hack' is deprecated by gnulib's
	commit f8eed11b15e9141d061900e4068ea1f3ba9b63f6 and replaced by
	'--automake-subdir'.

	* bootstrap.conf:
	(gnulib_modules): Remove option
	'non-recursive-gnulib-prefix-hack'.
	(gnulib_tool_option_extras): Add option '--automake-subdir'.
	(bootstrap_post_import_hook): Remove the invocation of
	'build-aux/prefix-gnulib-mk'.

	* doc/automake.mom: update documentation accordingly.

	Fixes <http://savannah.gnu.org/bugs/?61708> and
	<https://savannah.gnu.org/bugs/?62205> , issues reported and fix
	suggested by Bjarni Ingi Gislason <bjarniig@rhi.hi.is>.  Fix
	also suggested by Werner LEMBERG <wl@gnu.org> (see
	<https://repo.or.cz/ttfautohint.git/commit/a938fc63cb55ef48393a924d7083b13c1352d294>).

2022-04-23  Bertrand Garrigues <bertrand.garrigues@laposte.net>

	Update gnulib submodule

	* gnulib now points on c8b8f3bbcde37a53cd226f4c9cebd0dde6aca37f

	* bootstrap: merge the latest version from gnulib/build-aux
	{groff's bootstrap has a patch for OS X}.

	* bootstrap.conf: update copyright date.

2022-04-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (XH-UPDATE-TOC): Modify Keith Marshall's new XN/XH
	feature to indent TOC entries by section heading depth.  The
	increment is 2 ens per depth level.

2022-04-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/s.tmac (XA): Drop apparently useless `ll` request.  It
	doesn't do anything according to my tests.

2022-04-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/refer/label.ypp: Drop redundant declaration of
	`yyparse`.  Both byacc 20140715 and GNU Bison 3.3.2 supply the
	the function prototype themselves.  Addresses
	"-Wredundant-decls" warning from GCC.

	Fixes <https://savannah.gnu.org/bugs/?43569>.

2022-04-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/grn/hdb.cpp (DBGetType): Lower fatal diagnostics
	to errors when encounting invalid element type characters.
	Return a value interpreted by our caller as an error indication
	instead.  Helps compilers determine that we're not implicitly
	falling through our cases.  Addresses "-Wimplicit-fallthrough"
	warnings from GCC.

	Fixes https://savannah.gnu.org/bugs/?54702>.

2022-04-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/grn/hdb.cpp (DBRead): Add more validity checking.
	Verify that the number of conversions returned by fscanf() is as
	expected instead of throwing this information away--abort
	processing ("giving up" like pic(1) does) if it does not.
	Consistently report this abandonment in diagnostic messages.
	Similarly validate pointer returned by fgets().  Soften handling
	of invalid text condition from fatal error, introduced in
	commit eb4f0675e, 16 August, to a normal one with abandonment of
	Gremlin file.  Addresses "-Wunused-result" warnings from GCC.

2022-04-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/grn/main.cpp (conv): Throw an error diagnostic
	when failing to open a Gremlin picture file.

2022-04-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Fix extraneous space in output after `ME` or `UE` when
	mandoc wrapper is used.

	* tmac/an-ext.tmac (UE, ME): Double backslashes in macro
	definitions when interpolating `.$` register (just like we tell
	everyone else to do).  This one was interesting to track down.
	When using just `-man`, the problem never manifested; only with
	`-mandoc`.  The difference is that with the former, the `.$`
	register is initialized to zero; with the latter, because `TH`
	is aliased to another macro (then unaliased), `.$` has the
	argument count to the `TH` macro, not to the macros actually
	being called.  This caused the wrong branch of a conditional to
	be taken and put an extra space node on the output.

	Fixes <https://savannah.gnu.org/bugs/?62044>.

2022-04-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/cp1047.tmac:
	* tmac/latin1.tmac:
	* tmac/latin2.tmac:
	* tmac/latin5.tmac:
	* tmac/latin9.tmac: Stop remapping input soft hyphen characters
	with `tr` requests in character encoding macro files.  The
	formatter does this for us now.

2022-04-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Translate 8-bit NBSP and SHY on input.

	* src/roff/troff/input.h: Define constant integers for "input"
	no-break spaces and soft hyphens for EBCDIC and non-EBCDIC
	(presumably ASCII/ISO 8859/Unicode) systems.

	* src/roff/troff/input.cpp (token::next): Translate the input
	character codes for NBSP to \~ and SHY to \%.

	Fixes <https://savannah.gnu.org/bugs/?58962>.  Thanks to Dave
	Kemper for the report, code review, and his suggestion to push
	more work to compile time.

2022-04-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[groff]: Regression-test Savannah #58962.

	* src/roff/groff/handle_special_input_code_points.diff: Do it.
	* src/roff/groff/groff.am (groff_TESTS): Run test.

2022-04-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/roff/troff/input.cpp (do_if_request): Clarify diagnostic;
	at the point it is thrown, we know not merely that we're in a
	conditional expression, but processing an output comparison
	operator.

2022-04-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi:
	* doc/ms.ms:
	* man/groff.7.man: Characterize "roff language" in the singular,
	not the plural, emphasizing the similarity of extant specimens.

	* doc/groff.texi (Conventions Used in This Manual): Add
	paragraph discussing denotations of "groff" and "roff".

	Fixes <https://savannah.gnu.org/bugs/?62233>.  Thanks to John
	Gardner and Dave Kemper for the discussion.

2022-04-12  Ingo Schwarze <schwarze@openbsd.org>

	Delete the harmful, ill-designed, buggy, and essentially
	unmaintained and untested --with-doc option of the configure
	script.

	* configure.ac: Delete five AM_CONDITIONAL variables, one
	autoconf(1) macro call, and some related diagnostic output.
	* doc/doc.am: Delete two BUILD_EXAMPLES and one BUILD_OTHERDOC
	conditional and use BUILD_HTML instead of BUILD_HTMLEXAMPLES.
	* m4/groff.m4: Delete the GROFF_DOC_CHECK macro and simplify the
	macros GROFF_HTML_PROGRAMS, GROFF_INSTALL_INFO, GROFF_MAKEINFO,
	and GROFF_PDFDOC_PROGRAMS.  This also deletes more than thirty
	configuration variables.
	* Makefile.am: Delete comments about 16 variables that are no
	longer set.
	* NEWS: Add details regarding the rationale.

2022-04-12  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/preconv/preconv.cpp (unicode_entity): Convert
	input U+00A0 to \~ as troff would, not to \[u00A0].

	Fixes <https://savannah.gnu.org/bugs/?62300>.

2022-04-11  Deri James  <deri@chuzzlewit.myzen.co.uk>

	[gropdf] fails to deal with 255th glyph in font.

	* src/devices/gropdf/gropdf.pl: a pdf font can only contain 255
	glyphs. The array which holds the glyph names also holds the
	start position (zero) as first element, it is legal for it to
	contain 256 elements, so truncate to 256 (not 255).

	Fixes <https://savannah.gnu.org/bugs/?62294>.

2022-04-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[localization]: Define hyphenation mode registers for Japanese
	and Chinese.  They are set to zero but must be defined so that
	macro packages can rely on their existence without causing 'reg'
	warnings.

	* tmac/ja.tmac:
	* tmac/zh.tmac: Do it.

2022-04-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Add test for multi-lingual man(7) scenario.

	* tmac/tests/localization-works.sh: Test two more cases.  Ensure
	that the 'trap bit' (hyphenation value 2, which has nothing to
	do with any language) is preserved when switching locales back
	from a CJK language, since those languages' modes
	unconditionally clear it.  We test Japanese and Chinese; we have
	no localization macro file for Korean at this time.

2022-04-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Slightly refactor `an*abbreviate-inner-footer`.

	* tmac/an.tmac (an*abbreviate-inner-footer): Discard
	unnecessary string.

2022-04-09  Ingo Schwarze <schwarze@openbsd.org>

	Fix the configuration of texi2dvi.

	* m4/groff.m4: Set groff_have_texi2dvi if texi2dvi(1) is
	available and usable, even if the availability was specified by
	the user by manually providing the configure variable
	PROG_TEXI2DVI, and not only if it was autodetected.
	Also, set the PROG_TEXI2DVI Makefile variable to the name of
	the texi2dvi program specified by the user or autodetected,
	and not to the string "found", such that this Makefile variable
	can be used for invoking the program.
	* doc/doc.am: Call the texi2dvi program specified by the user
	or autodetected rather than hardcoding "texi2dvi".  This lets
	the groff build succeed on systems where the first texi2dvi
	in the $PATH is an old version unfit for groff's purposes.

2022-04-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Abbreviate long `TH` arguments more carefully.

	* tmac/an.tmac: Do it.
	(an*scan-string-for-backslash): Add new helper macro.
	(an*abbreviate-inner-footer): Rewrite.  Use the foregoing and a
	different technique to compute available space and shorten the
	string.

	Fixes <https://savannah.gnu.org/bugs/?62257>.

2022-04-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	[man]: Add regression test for Savannah #62257.

	* tmac/tests/an_do-not-abbreviate-escape-using-TH-arguments.sh:
	Do it.
	* tmac/tmac.am (tmac_TESTS): Run it.

2022-04-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Trivially refactor.  Rename strings `an-ifoot`
	to `an*ifoot` and `an-outer-footer-text` to `an*ofoot`.

2022-04-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Refactor.  Abbreviate page title and inner
	footer only once per document instead of once per page.
	Exception: the legacy macros `AT` and `UC` change the inner
	footer, so re-abbreviate it if they are called.
	(TH, AT, UC): Call abbreviation macros from here...
	(an-header, an-footer): ...instead of here.

2022-04-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Refactor: initialize header/footer environment
	only once.  Also rename it to `an*env-header-and-footer`.
	(TH): Do it here...
	(an-header, an-footer): ...instead of here.

2022-04-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Trivially refactor.
	(an*prepare-page-title): Rename this...
	(an*abbreviate-page-title): ...to this.
	(an-prepare-inner-footer): And this...
	(an*abbreviate-inner-footer): ...to this.
	(an-header, an-footer): Update call sites.

2022-04-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/eqn/other.cpp (hmotion_box::output): Fix typo in
	generated MathML diagnostic message.

2022-04-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (EXTRA_DIST): Add "groff.dvi" and "groff.pdf" to
	ensure that the GNU-released groff distribution archive contains
	our Texinfo manual in these formats.  (This doesn't increase the
	build-dependency requirements unless you want to "make dist", in
	which case it _should_.)

2022-04-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	[ms]: Add nroff mode fallback for `UL` macro.

	* tmac/s.tmac (UL): On nroff devices, bracket the first argument
	with \(ul (underline rule) special character escape sequences.
	{In plain language, '.UL "like this"' renders "_like this_".}
	See corresponding 12 February change to "tmac/e.tmac".

2022-04-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Drop unnecessary `-I` options to groff.
	(DOC_GROFF): There is no need to look at the top of the build
	directory for any file inclusions.
	(doc/webpage.html): There is no need to look in `doc_builddir`
	for file inclusions, since that is the current working directory
	when "webpage.ms" is processed.

2022-04-06  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Trivially refactor.  Use `RM` macro idiomatically.
	Automake ensures that it is defined to call an `rm` command with
	the `-f` option, and this in turn ignores failures to delete
	nonexistent files, so...
	(uninstall_doc_examples, uninstall-pdf): Stop adding superfluous
	`-f` flag.
	(clean_infodoc uninstall-pdf, uninstall-html): Stop prefixing
	command with `-` to ignore error exit status.
	(uninstall-html): Drop superfluous `-r` flag; we're only
	deleting files with this command, not directories.

2022-04-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Trivially refactor shell style in rule commands.
	The placement of `&&` was inconsistent.  Always begin a
	continued rule line with it, and don't give it its own
	indentation level.  In general, operators adjacent to line
	continuations should _follow_ the continuations because they are
	easier for humans to spot at the (possibly indented) beginning
	of a physical line.

2022-04-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* Makefile.am: Rename `TFLAG` macro, which means "tmac flag", to
	`MFLAG`, because it expands to `-M` options to groff, not the
	`-T` option, which can be bewildering.
	* doc/doc.am (DOC_GROFF): Update expansion site.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Rename `DOC_GROFF_ONLY` to `DOC_GROFF`.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor.  Drop ghastly hack used to get file
	names into troff diagnostics when reading from standard input.
	We've refactored so that it no longer does, making the hack
	unnecessary.  For the same reason, no users of the `DOC_GROFF`
	macro remain, so delete it.  Add comments to explain what
	`DOC_SED` and `DOC_GROFF_ONLY` are for.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor.
	(doc/pic.html, doc/webpage.html): Drop indirection of source
	document through `DOC_SED` macro.  It was not necessary since
	neither of these documents are parameterized in configuration
	options (that is, they don't contain @VERSION@ or @g@).

2022-04-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Trivially refactor.
	(doc/webpage.html): Tidy up dependency list.  Create directory
	using the same macro interpolation we use to change into it.

2022-04-05  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor and fix error in builds in remote
	out-of-source-tree builds exposed by pending commit and `make
	distcheck`.  The images generated for the pic.html and
	webpage.html files were being built in the wrong directory, and
	subsequently not found by an install rule.
	(imagedir): Add comment explaining purpose of macro.  It should
	_not_ be used with any file specifications relative to the
	source or build trees--it is for installation directories only.
	(htmldocimagedir, exampleimagedir): Drop macros.

	(doc/pic.html, doc/webpage.html): Replace interpolations of
	`imagedir` with literal "img", since these files are being
	generated within the build tree: the directory name is known.

	(mostlyclean_doc, install_doc_htmldoc, install_doc_examples):
	Replace interpolations of `htmldocimagedir` relative to
	`doc_builddir` with "img" literals.

	(install_doc_htmldoc, uninstall_doc_htmldoc): Interpolate
	concatenation of `htmldocdir` and `imagedir` instead of
	`htmldocimagedir` (relative to `DESTDIR`).
	(install_doc_examples, uninstall_doc_examples): Interpolate
	concatenation of `exampledir` and `imagedir` instead of
	`exampleimagedir` (relative to `DESTDIR`).

2022-04-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor.  Relocate "doc/grnexampl.ps" target to
	group it with other me(7) documents.  Put addition of
	"doc/examples.stamp" to `MOSTLYCLEANFILES` adjacent to its
	target rule.  Relocate same rule so that it precedes the target
	depending on it (make(1) might not benefit from this, but human
	readers can).

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor.
	(DOC_GROFF_ONLY): Drop preprocessor options from groff command.
	This macro is now, simply, a way to run the in-tree groff: no
	assumptions about preprocessors, macro packages, or output
	device are made.
	(doc/pic.html, doc/webpage.html): Add only necessary
	preprocessor options after expansion of `DOC_GROFF_ONLY`.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor.  Add explicit dependencies of compiled
	man page documents on preprocessors needed to generate them.  In
	their target rules, explicitly use groff's preprocessor options,
	freeing us up to simplify the `DOC_GROFF_ONLY` macro.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Rationalize dependencies.  Drop dependency of
	`PROCESSEDEXAMPLEFILES` and `PROCESSEDDOCFILES` on expansion of
	`hdtbltmac_DATA`, because nothing in this directory uses the
	hdtbl package.  Move dep of same expansions on "gnu.eps" to
	"doc/webpage.html", which actually uses it.  Put the numerous
	dependencies of "doc/pic.html" and "doc/webpage.html" in a
	parallel ordering so that they are easier for humans to
	evaluate.  These targets' dependencies on `bin_PROGRAMS` and
	`prefixexecbin_PROGRAMS` are overkill and should be reviewed at
	a later date.

2022-04-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Refactor use of target and suffix rules.
	(doc/meintro.me, doc/meintro_fr.me, doc/meref.me): Add target
	rules, with lengthy, exasperated comment about lack of feature
	parity in various make(1) implementations.
	(doc/meintro_fr.ps): Add target rule, as this seems to be the
	only way to keep GNU Make from ignoring a '_fr.me._fr.ps' suffix
	rule in favor of '.me.ps', which doesn't call preconv (and
	doesn't need to--and moreover we don't want to build English
	me(7) documents with the `-mfr` option).  Depend on `preconv`.
	(doc/webpage.ps): Convert from suffix rule to target rule.
	(doc/ms.ps, doc/pic.ps, doc/webpage.ps): Add target rules and
	dependencies.
	(.ms.ps): Add commented-out suffix rule (since nothing uses it,
	but might in the future).
	(doc/meintro_fr.ps, .me.ps, doc/pic.ps, doc/webpage.ps): Migrate
	expansions of `DOC_GROFF` to `DOC_GROFF_ONLY` to prepare for a
	forthcoming simplification.

2022-04-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Clean generated doc files better.  doc/me*.me were
	getting left behind in the build tree.
	(MOSTLYCLEANFILES): Add `GENERATEDDOCFILES`.  This includes
	`DOC_GNU_EPS`, so...
	(clean_maintdoc): Drop phony target that manually removes it.
	(maintainer-clean-local): Drop dependency on foregoing.

2022-04-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/xditview/xditview.am (install_xditview)
	[!WITHOUT_X11]: Stop backing up existing "GXditview" and
	"GXditview-color" application defaults files.  There is no
	symmetric restoration of them in the uninstall target, and it
	seems like unjustifiable complexity to add such.  These are
	groff-specific file names, installed (by default) to /usr,
	not /etc, so they are not going to be "configuration files" in
	Debian-based systems, for example (and likely not elsewhere).
	There are other ways to supersede application defaults for
	programs using the X Toolkit Intrinsics.

2022-04-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Stop treating "gnu.eps" as an "example" file; it
	is also used by pdfmark's cover.ms, which is ordinary
	documentation.  We therefore must not omit it when building.
	(install-data-hook): Add dependency on new phony target,
	"install_doc_gnu_eps".
	(install_doc_examples): Move installation of "gnu.eps" from
	here...
	(install_doc_gnu_eps): ...to here.  Also refactor the loop we
	use to locate the file to follow a more idiomatic pattern.

2022-04-03  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (dist-info-bits, install_infodoc, dist-gnueps): Fix
	code style nit: use consistent "brace style" in conditionals and
	loops.

2022-04-01  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (mostlyclean_doc): When cleaning, try harder to
	remove the image directory created by the "pic.html" and
	"webpage.html" targets.

2022-04-02  Ingo Schwarze <schwarze@openbsd.org>

	* doc/doc.am: Stop installing doc/meintro.me.in,
	doc/meintro_fr.me.in, and doc/meref.me.in.

2022-03-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/webpage.ms: Die horribly if `PSPIC` call fails.

2022-03-30  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/pspic.tmac (pspic*error-hook): Define (as empty).
	* man/groff_tmac.5.man (Auxiliary packages) <pspic>: Document.
	* NEWS: Add item.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am (doc/webpage.ps): Relocate target rule.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/tests/pdfpic_does-not-choke-on-bad-pdfinfo-output.sh:
	* tmac/tests/pdfpic_falls-back-to-PSPIC.sh: Remove output file
	even when skipping test.  Quote `fail` variable when checking it
	with `test -z`.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* man/groff_tmac.7.man (Auxiliary packages): Tweak sboxes
	documentation to imply ms dependency.

	Fixes <https://savannah.gnu.org/bugs/?62062>.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac (an*bookmark): Trivially refactor.  Now that
	we're no longer doing arithmetic on our first argument, simplify
	our definition.  Made possible by commit 3baf0e2f3, 23 February.

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/preproc/preconv/preconv.cpp (detect_file_encoding): Demote
	an error diagnostic to a debugging message.  libuchardet has no
	man page, and inspecting the source of the
	`uchardet_handle_data` function we find that it effectively
	returns a Boolean value (if the result of a
	`reinterpret_cast`(!) is not `NS_OK`).  This is useless
	information for a user-facing tool.  We're designed to muddle on
	regardless (see preconv(1)).

2022-03-29  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grodvi/dvi.cpp (dvi_printer::set_color)
	(draw_dvi_printer::fill_next):
	* src/devices/grops/ps.cpp (output::put_color):
	* src/libs/libgroff/color.cpp (color::print_color): Construct
	doubles instead of casting to them.

2022-03-28  G. Branden Robinson <g.branden.robinson@gmail.com>

	[doc]: Refactor handling of "gnu.eps" file.

	* doc/doc.am: Put "gnu.eps" in a Make macro, `DOC_GNU_EPS`.
	($(PROCESSEDEXAMPLEFILES) $(PROCESSEDDOCFILES),
	doc/webpage.html, install_doc_examples): Migrate dependency to
	`DOC_GNU_EPS`.
	(doc/webpage.ps): Add (missing) dependency on `DOC_GNU_EPS`.
	(DOC_GROFF_ONLY): Drop `-I` flag; it's not necessary given the
	following.
	(.ms.ps): Drop `-mwww` argument from suffix rule.  A truly
	generic ms document won't need it.
	(doc/webpage.ps): Add target rule.  Include `-mwww` argument.
	(doc/webpage.ps, doc/webpage.html): Pass `-I` option to
	`DOC_GROFF` and `DOC_GROFF_ONLY` (respectively) to enable
	location of "gnu.eps" file.  Search the build and source trees'
	"doc" directories because the file can be generated as part of
	the build or can come with the distribution archive.
	(EXTRA_DIST): Drop redundant inclusion of "doc/gnu.xpm".
	(clean_maintdoc): Add phony target to dispose of `DOC_GNU_EPS`.
	(maintainer-clean-local): Depend on "clean_maintdoc".

	* tmac/tests/pdfpic_does-not-choke-on-bad-pdfinfo-output.sh:
	* tmac/tests/pdfpic_falls-back-to-PSPIC.sh: Update tests to look
	for "gnu.eps" in "doc" directory of build tree.  Give generated
	files distinguishable names so their tests can run concurrently.

2022-03-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Add new macro `PROCESSEDDOCFILES_PS` to isolate
	names of targets in PostScript format.  Expand this macro in
	definition of `PROCESSEDDOCFILES` and use it to move PostScript
	font description file dependencies of the latter and
	`PROCESSEDEXAMPLEFILES` to the former.  (At present, the
	dependency might seem superfluous, since those files are in the
	source distribution, but it's conceivable that in the near
	future, they will be produced at build time from Adobe font
	metric files; see font/devps/generate/Makefile).  The "pic.html"
	and "webpage.html" targets already had such a dependency because
	of the way grohtml (pre-grohtml) works.

2022-03-26  G. Branden Robinson <g.branden.robinson@gmail.com>

	* INSTALL.extra: Add a section on uninstalling.

2022-03-23  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/doc.am: Create target rule for "doc/grnexampl.ps" instead
	of relying on a suffix rule.  Explicitly depend on grn and eqn
	executables.  Produce output using their groff flags, "-ge".

2022-03-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/pdfpic.tmac (PDFPIC): Fix breakage when no temporary
	directory environment variables are defined: actually use string
	interpolation syntax in comparand to output comparison
	operator.  Problem introduced by me in commits adc1999af and
	24900cf6d, 15 February.

2022-03-25  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devX100-12/devX100-12.am:
	* font/devX100/devX100.am:
	* font/devX75-12/devX75-12.am:
	* font/devX75/devX75.am: Fix in-tree build; expand `fontdir`
	instead of `abs_top_builddir` Make macro when defining Automake
	variable for generated artifacts.  Problem introduced by me in
	commit 3c82cbbfe, 27 February.  Thanks to Robert Goulding for
	the report.

2022-03-22  Ingo Schwarze <schwarze@openbsd.org>

	* doc/doc.am: delete redundant "SUFFIXES +=" line

2022-03-22  Ingo Schwarze <schwarze@openbsd.org>

	* doc/doc.am: fix non-portable syntax in the meintro_fr.ps
	target: This rule requires DOC_GROFF and hence $<, so turn it
	into a suffix rule.

2022-03-22  Ingo Schwarze <schwarze@openbsd.org>

	* doc/doc.am: fix non-portable syntax in the doc/me*.me targets:
	POSIX does not define the meaning of $< in non-suffix rules, so
	use the portable $? instead.  This is adequate here because each
	of these three rules has exactly one prerequisite.

2022-03-22  Ingo Schwarze <schwarze@openbsd.org>

	* doc/doc.am: fix non-portable syntax in the groff-man-pages.*
	targets by using DOC_GROFF_ONLY rather than DOC_GROFF in order
	to not use $< outside a suffix rule; DOC_GROFF functionality is
	not needed here in the first place.

2022-03-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac:
	* tmac/doc.tmac: Stop remapping input hyphens on `utf8` device.

2022-03-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/doc.tmac: Stop remapping ` and ' on `utf8` output device.
	Aligns mdoc(7) with commit 697e6db7f, 19 October 2020 (for
	man(7)).

2022-03-21  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.pl: Fix bug introduced in commit
	0d451902c, 10 March.  Don't store a newline in the version
	string.  Put `\n` in its interpolation context as necessary.

2022-03-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	Install ptx.tmac.

	* tmac/tmac.am (TMACNORMALFILES): Add it.
	* NEWS: Report availability.

	Fixes <https://savannah.gnu.org/bugs/?62201>.  Thanks to Ralph
	Corderoy for the report.

2022-03-19  G. Branden Robinson <g.branden.robinson@gmail.com>

	Drop ditroff(7) document.  It says nothing that is not covered
	elsewhere.

	* man/ditroff.7.man: Delete.
	* doc/doc.am (GROFF_MAN_PAGES):
	* man/man.am (man7_MANS, EXTRA_DIST): Stop processing, shipping.
	* src/roff/groff/groff.1.man: Drop cross reference to it.
	* NEWS: Add item.

	Fixes <https://savannah.gnu.org/bugs/?61817>.

2022-03-18  G. Branden Robinson <g.branden.robinson@gmail.com>

	[preconv]: Trivially refactor.

	* src/preproc/preconv/preconv.cpp: Use diagnostic message
	functions from libgroff where possible.  Explain in a comment
	why we don't use `debug()`.  Boolify and rename some variables,
	and use Boolean literals to assign to them.
	  debug_flag         -> is_debugging
	  invalid_warning    -> emit_invalid_utf8_warning
	  incomplete_warning -> emit_incomplete_utf8_warning
	Rename `expected_bytes` to `expected_byte_count`.  Except for
	the debugging flag, these are all members of `struct
	conversion`.
	(get_tag_lines): Migrate to `warning()`.
	(detect_file_encoding): Migrate to `error()` and `fatal()`, as
	appropriate.
	(utf8::invalid, utf8::incomplete, get_tag_lines): Don't break a
	line in the middle of a diagnostic; doing so frustrates grepping
	and necessarily makes an assumption about the terminal width.

2022-03-17  G. Branden Robinson <g.branden.robinson@gmail.com>

	[troff]: Trivially refactor.

	* src/roff/troff/input.cpp: Rename global variable
	`have_string_arg` to `have_multiple_params` and demote it from
	an integer to a Boolean.  Assign Boolean literals to it.
	(read_long_escape_parameters, get_copy, token::next): Do it.

2022-03-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Fix Savannah #62191.

	* src/preproc/tbl/main.cpp (table_input::get): Increment input
	line counter when encountering an escaped newline; this fixes
	inaccurate diagnostics from the formatter at any point in a
	document after a line-continued row of table data.  Also drop a
	"perhaps" comment.  I tested the surmise (setting the FSM state
	to "START"), and it results in bad formatting.

	Fixes <https://savannah.gnu.org/bugs/?62191>.  Problem appears
	to date back to groff 1.02 (June 1991) at the latest.

2022-03-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tbl]: Regression-test Savannah #62191.

	* src/preproc/tbl/tests/count-continued-input-lines.sh: Do it.
	* src/preproc/tbl/tbl.am (tbl_TESTS): Run test.

2022-03-16  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Environments): Clarify environment handling.
	* man/groff.7.man (Environments): Add new section.

	Fixes <https://savannah.gnu.org/bugs/?62036>.  Thanks to Dave
	Kemper for the report and a suggested patch.

2022-03-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac (initialization): Define `@b` as empty if
	formatting for HTML, because no page breaks occur in that
	format.

	Fixes <https://savannah.gnu.org/bugs/?62039>.

2022-03-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grodvi/dvi.cpp (usage): Align usage message with
	man page; disclose `-l` option.

2022-03-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grodvi/dvi.cpp (main):
	* src/devices/grops/ps.cpp (main): Update diagnostic:
	characterize bad `-w` argument as "invalid", not "bad", and
	explicitly report it as ignored.

	* src/devices/grodvi/dvi.cpp (main): Report invalid parameter
	in `-w` diagnostic.

2022-03-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grodvi/dvi.cpp (dvi_printer::set_color)
	(draw_dvi_printer::fill_next):
	* src/devices/grops/ps.cpp (output::put_color):
	* src/libs/libgroff/color.cpp (color::print_color): Explicitly
	cast `enum` divisors to `double`; quietens
	`-Wdeprecated-enum-float-conversion` warnings.

	Fixes <https://savannah.gnu.org/bugs/?61964>.  Thanks to Bjarni
	Ingi Gislason for the report.

2022-03-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/an.tmac: Recover more quickly from missing `EE` calls.
	(initialization): Define new strings, `an*body-family` and
	`an*example-family` to house the font families used in these
	rendering contexts.
	(TH, SH, SS): Restore the font family to `an*body-family`.
	(TH): Set font style to roman as well.
	(EX): Change to `an*example-family` instead of literal "C".

	Fixes <https://savannah.gnu.org/bugs/?62187>.

2022-03-15  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/e.tmac: Test register for existence before using it to
	set hyphenation mode.  A site troffrc or other local
	customization might remove the register (which is guaranteed to
	be set under the stock configuration) and, perversely, Heirloom
	Doctools troff interprets a `do` request, instead of ignoring it
	as a historical troff implementation would, so if they borrow
	our me(7) changes, the register would be unset, interpolate
	zero, and hyphenation would wind up disabled.

	Fixes <https://savannah.gnu.org/bugs/?62181>.  Thanks to Dave
	Kemper for the report.

2022-03-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	[tests]: Rename test to apply naming scheme.

	* tmac/tests/pdfpic_falls_back_to_PSPIC.sh: Rename this...
	* tmac/tests/pdfpic_falls-back-to-PSPIC.sh: ...to this.
	* tmac/tmac.am (tmac_TESTS): Use new name.

2022-03-14  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/devices/grops/ps.cpp (usage): Align usage message with man
	page synopsis.

2022-03-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* doc/groff.texi (Input Line Traps): Fix error; input traps do
	_not_ ignore control lines.  Error appears to have crept in with
	the first version of our Texinfo manual, shipped with groff 1.14
	{December 1999}.

2022-03-13  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devps/devps.am: Rename targets.
	(fonts):
	(devps_fonts): Rename these...
	(maintainer-font-descriptions):
	(devps_font-descriptions): ...to these.  Add comments explaining
	what they're for and why they aren't used in a build.

	* font/devps/generate/Makefile: Add `outdir` variable to store
	destination directory of font description files, and update all
	targets that write artifacts to use this directory.  This makes
	the targets "phony", which I don't regard as a problem since the
	generated artifacts are kept under source control, and this
	isn't really a user-facing script (even though it gets
	installed).  I think there is a good chance that this will
	become a shell script, because to avoid regressions we need to
	generate the font descriptions using both the 229-glyph and
	314-glyph versions of the Adobe fonts' AFM files (so that we get
	wider glyph coverage _and_ more kerning pair data) and we need
	to add kerning information for the ellipsis (Savannah #58897).
	(symbolsl.afm): Revise generation process to be sensitive to
	failure.

2022-03-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* font/devps/symbolsl.afm: New file.
	* font/devps/devps.am (EXTRA_DIST): We have long shipped
	"symbol.afm" with the distribution archive--I don't see why we
	don't ship "symbolsl.afm" and "zapfdr.afm" as well (metrics for
	`SS`, the slanted symbol font, and ZDR, reversed Zapf Dingbats).
	Like the Type 1 font descriptions themselves, this file is
	updated only in "maintainer mode", not as part of the build.
	Moreover, these fonts are not part of the PostScript level 2
	base 35 fonts so their AFM files are unlikely to be readily
	available elsewhere.

2022-03-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.pl: Trivially refactor.  Store the
	program's version string in scalar `afmtodit_version` and use
	that in the usage message and comment embedded in the output.

2022-03-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.pl: Fix code style nits.  Migrate
	to the shebang line style we use in more recently modified Perl
	scripts.  Replace `-w` with `use warnings;`.  Shorten an output
	comment since the groff version string can grow long (see commit
	1264531310, 14 January 2018).

2022-03-09  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.pl: Stop writing full file name to
	the generated font description file as the "name" (i.e., don't
	include directory components).

	Fixes <https://savannah.gnu.org/bugs/?62150>.  Thanks to Dave
	Kemper for the discussion and code review.

2022-03-08  G. Branden Robinson <g.branden.robinson@gmail.com>

	* src/utils/afmtodit/afmtodit.1.man:
	* src/utils/afmtodit/afmtodit.pl: Update and align man page
	synopsis, option descriptions, and command usage output.

2022-03-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* tmac/X.tmac: Redirect `fchar` requests for \[lq] and \[rq] to
	\[dq] since the X11 Type 1-based text fonts encode ISO 8859-1
	{Latin-1} and don't have typopgrapher's quotes.  Drop `fchar`
	request for \[aq], which _is_ represented, per recent changes.

2022-03-07  G. Branden Robinson <g.branden.robinson@gmail.com>

	* /font/devX100-12/CB:
	* /font/devX100-12/CBI:
	* /font/devX100-12/CI:
	* /font/devX100-12/CR:
	* /font/devX100-12/HB:
	* /font/devX100-12/HBI:
	* /font/devX100-12/HI:
	* /font/devX100-12/HR:
	* /font/devX100-12/NB:
	* /font/devX100-12/NBI:
